define("errbackoff", [ "./date", "rdcommon/log", "module", "exports" ], function(e, t, n, i) {
    function o(e, t, n) {
        this.state = "healthy", this._iNextBackoff = 0, this._LOG = s.BackoffEndpoint(this, n, e), 
        this._LOG.state(this.state), this._badResources = {}, this.listener = t;
    }
    var a = i.BACKOFF_DURATIONS = [ {
        fixedMS: 0,
        randomMS: 0
    }, {
        fixedMS: 800,
        randomMS: 400
    }, {
        fixedMS: 4500,
        randomMS: 1e3
    } ], r = window.setTimeout.bind(window);
    i.TEST_useTimeoutFunc = function(e) {
        r = e;
        for (var t = 0; t < a.length; t++) a[t].randomMS = 0;
    }, o.prototype = {
        _setState: function(e) {
            this.state !== e && (this.state = e, this._LOG.state(e), this.listener && this.listener.onEndpointStateChange(e));
        },
        noteConnectSuccess: function() {
            this._setState("healthy"), this._iNextBackoff = 0;
        },
        noteConnectFailureMaybeRetry: function(e) {
            return this._LOG.connectFailure(e), "shutdown" === this.state ? !1 : e ? (this._setState("broken"), 
            !1) : (this._iNextBackoff > 0 && this._setState(e ? "broken" : "unreachable"), this._iNextBackoff >= a.length ? !1 : !0);
        },
        noteBrokenConnection: function() {
            this._LOG.connectFailure(!0), this._setState("broken"), this._iNextBackoff = a.length;
        },
        scheduleConnectAttempt: function(e) {
            if ("shutdown" !== this.state) {
                if (this._iNextBackoff >= a.length) return e(), void 0;
                var t = a[this._iNextBackoff++], n = t.fixedMS + Math.floor(Math.random() * t.randomMS);
                r(e, n);
            }
        },
        noteBadResource: function(t) {
            var n = e.NOW();
            if (this._badResources.hasOwnProperty(t)) {
                var i = this._badResources[t];
                i.count++, i.last = n;
            } else this._badResources[t] = {
                count: 1,
                last: n
            };
        },
        resourceIsOkayToUse: function(t) {
            return this._badResources.hasOwnProperty(t) ? (this._badResources[t], e.NOW(), void 0) : !0;
        },
        shutdown: function() {
            this._setState("shutdown");
        }
    }, i.createEndpoint = function(e, t, n) {
        return new o(e, t, n);
    };
    var s = i.LOGFAB = t.register(n, {
        BackoffEndpoint: {
            type: t.TASK,
            subtype: t.CLIENT,
            stateVars: {
                state: !1
            },
            events: {
                connectFailure: {
                    reachable: !0
                }
            },
            errors: {}
        }
    });
}), define("composite/incoming", [ "rdcommon/log", "../a64", "../accountmixins", "../mailslice", "../searchfilter", "../util", "../db/folder_info_rep", "require", "exports" ], function(e, t, n, i, o, a, r, s, c) {
    function l(e, t) {
        return e.path.localeCompare(t.path);
    }
    function d(e, t, n, o, a, r, s, c) {
        this.universe = t, this.compositeAccount = n, this.id = o, this.accountDef = n.accountDef, 
        this.enabled = !0, this._alive = !0, this._credentials = a, this._connInfo = r, 
        this._db = c;
        var l = this._folderStorages = {}, d = this.folders = [];
        this.FolderSyncer = e, this._deadFolderIds = null, this._folderInfos = s, this.meta = this._folderInfos.$meta, 
        this.mutations = this._folderInfos.$mutations;
        for (var p in s) if ("$" !== p[0]) {
            var u = s[p];
            l[p] = new i.FolderStorage(this, p, u, this._db, e, this._LOG), d.push(u.$meta);
        }
        this.folders.sort(function(e, t) {
            return e.path.localeCompare(t.path);
        });
        var h = this.getFirstFolderWithType("inbox");
        h || this._learnAboutFolder("INBOX", "INBOX", null, "inbox", "/", 0, !0);
    }
    var p = a.bsearchForInsert;
    c.CompositeIncomingAccount = d, d.prototype = {
        runOp: n.runOp,
        getFirstFolderWithType: n.getFirstFolderWithType,
        getFolderByPath: n.getFolderByPath,
        saveAccountState: n.saveAccountState,
        runAfterSaves: n.runAfterSaves,
        _learnAboutFolder: function(e, n, o, a, s, c, d) {
            var u = this.id + "/" + t.encodeInt(this.meta.nextFolderNum++), h = this._folderInfos[u] = {
                $meta: r.makeFolderMeta({
                    id: u,
                    name: e,
                    type: a,
                    path: n,
                    parentId: o,
                    delim: s,
                    depth: c,
                    lastSyncedAt: 0,
                    version: i.FOLDER_DB_VERSION
                }),
                $impl: {
                    nextId: 0,
                    nextHeaderBlock: 0,
                    nextBodyBlock: 0
                },
                accuracy: [],
                headerBlocks: [],
                bodyBlocks: [],
                serverIdHeaderBlockMapping: null
            };
            this._folderStorages[u] = new i.FolderStorage(this, u, h, this._db, this.FolderSyncer, this._LOG);
            var f = h.$meta, m = p(this.folders, f, l);
            return this.folders.splice(m, 0, f), d || this.universe.__notifyAddedFolder(this, f), 
            f;
        },
        _forgetFolder: function(e, t) {
            var n = this._folderInfos[e], i = n.$meta;
            delete this._folderInfos[e];
            var o = this._folderStorages[e];
            delete this._folderStorages[e];
            var a = this.folders.indexOf(i);
            this.folders.splice(a, 1), null === this._deadFolderIds && (this._deadFolderIds = []), 
            this._deadFolderIds.push(e), o.youAreDeadCleanupAfterYourself(), t || this.universe.__notifyRemovedFolder(this, i);
        },
        _recreateFolder: function(e, t) {
            this._LOG.recreateFolder(e);
            var n = this._folderInfos[e];
            n.$impl = {
                nextId: 0,
                nextHeaderBlock: 0,
                nextBodyBlock: 0
            }, n.accuracy = [], n.headerBlocks = [], n.bodyBlocks = [], null === this._deadFolderIds && (this._deadFolderIds = []), 
            this._deadFolderIds.push(e);
            var o = this;
            this.saveAccountState(null, function() {
                var a = new i.FolderStorage(o, e, n, o._db, o.FolderSyncer, o._LOG);
                for (var r in Iterator(o._folderStorages[e]._slices)) {
                    var s = r[1];
                    s._storage = a, s.reset(), a.sliceOpenMostRecent(s);
                }
                o._folderStorages[e]._slices = [], o._folderStorages[e] = a, t(a);
            }, "recreateFolder");
        },
        __checkpointSyncCompleted: function(e, t) {
            this.saveAccountState(null, e, t || "checkpointSync");
        },
        deleteFolder: function(e, t) {
            function n(e) {
                r = e, r.delBox(a.path, i);
            }
            function i(e) {
                e ? o("unknown") : o(null);
            }
            function o(n) {
                r && (s.__folderDoneWithConnection(r, !1, !1), r = null), n || (s._LOG.deleteFolder(a.path), 
                s._forgetFolder(e)), t && t(n, a);
            }
            if (!this._folderInfos.hasOwnProperty(e)) throw new Error("No such folder: " + e);
            if (!this.universe.online) return t && t("offline"), void 0;
            var a = this._folderInfos[e].$meta, r = null, s = this;
            this.__folderDemandsConnection(null, "deleteFolder", n);
        },
        getFolderStorageForFolderId: function(e) {
            if (this._folderStorages.hasOwnProperty(e)) return this._folderStorages[e];
            throw new Error("No folder with id: " + e);
        },
        getFolderStorageForMessageSuid: function(e) {
            var t = e.substring(0, e.lastIndexOf("/"));
            if (this._folderStorages.hasOwnProperty(t)) return this._folderStorages[t];
            throw new Error("No folder with id: " + t);
        },
        getFolderMetaForFolderId: function(e) {
            return this._folderInfos.hasOwnProperty(e) ? this._folderInfos[e].$meta : null;
        },
        sliceFolderMessages: function(e, t) {
            var n = this._folderStorages[e], o = new i.MailSlice(t, n, this._LOG);
            n.sliceOpenMostRecent(o);
        },
        searchFolderMessages: function(e, t, n, i) {
            var a = this._folderStorages[e], r = new o.SearchSlice(t, a, n, i, this._LOG);
            return a.sliceOpenSearch(r), r;
        },
        shutdownFolders: function() {
            for (var e = 0; e < this.folders.length; e++) {
                var t = this.folders[e], n = this._folderStorages[t.id];
                n.shutdown();
            }
        },
        scheduleMessagePurge: function(e, t) {
            this.universe.purgeExcessMessages(this.compositeAccount, e, t);
        },
        onEndpointStateChange: function(e) {
            switch (e) {
              case "healthy":
                this.universe.__removeAccountProblem(this.compositeAccount, "connection", "incoming");
                break;

              case "unreachable":
              case "broken":
                this.universe.__reportAccountProblem(this.compositeAccount, "connection", "incoming");
            }
        }
    }, c.LOGFAB_DEFINITION = {
        CompositeIncomingAccount: {
            type: e.ACCOUNT,
            events: {
                createFolder: {},
                deleteFolder: {},
                recreateFolder: {
                    id: !1
                },
                createConnection: {},
                reuseConnection: {},
                releaseConnection: {},
                deadConnection: {
                    why: !0
                },
                unknownDeadConnection: {},
                connectionMismatch: {},
                accountDeleted: {
                    where: !1
                },
                maximumConnsNoNew: {}
            },
            TEST_ONLY_events: {
                deleteFolder: {
                    path: !1
                },
                createConnection: {
                    label: !1
                },
                reuseConnection: {
                    label: !1
                },
                releaseConnection: {
                    folderId: !1,
                    label: !1
                },
                deadConnection: {
                    folder: !1
                },
                connectionMismatch: {}
            },
            errors: {
                connectionError: {},
                folderAlreadyHasConn: {
                    folderId: !1
                },
                opError: {
                    mode: !1,
                    type: !1,
                    ex: e.EXCEPTION
                }
            },
            asyncJobs: {
                checkAccount: {
                    err: null
                },
                runOp: {
                    mode: !0,
                    type: !0,
                    error: !0,
                    op: !1
                },
                saveAccountState: {
                    reason: !0,
                    folderSaveCount: !0
                }
            },
            TEST_ONLY_asyncJobs: {}
        }
    };
}), define("imap/folder", [ "rdcommon/log", "../a64", "../allback", "../date", "../syncbase", "../util", "module", "require", "exports" ], function(e, t, n, i, o, a, r, s, c) {
    function l(e) {
        for (var t = 0, n = e.length, i = 0; n > i; i++) {
            var o = e[i];
            null !== o ? t && (e[i - t] = o) : t++;
        }
        return t && e.splice(n - t, t), e;
    }
    function d(e) {
        return e = e || {}, e.not = {
            deleted: !0
        }, e;
    }
    function p(e, t, n) {
        this._account = e, this._storage = t, this._LOG = C.ImapFolderConn(this, n, t.folderId), 
        this._conn = null, this.box = null, this._deathback = null;
    }
    function u(e, t, n) {
        this._account = e, this.folderStorage = t, this._LOG = C.ImapFolderSyncer(this, n, t.folderId), 
        this._syncSlice = null, this._curSyncAccuracyStamp = null, this._curSyncDir = 1, 
        this._curSyncIsGrow = null, this._nextSyncAnchorTS = null, this._fallbackOriginTS = null, 
        this._syncThroughTS = null, this._curSyncDayStep = null, this._curSyncDoNotGrowBoundary = null, 
        this._curSyncDoneCallback = null, this.folderConn = new p(e, t, this._LOG);
    }
    function h() {}
    var f = null, m = null, g = null, v = null, _ = null, y = n.allbackMaker, b = (a.bsearchForInsert, 
    a.bsearchMaybeExists, a.cmpHeaderYoungToOld, i.DAY_MILLIS), x = i.NOW, S = (i.BEFORE, 
    i.ON_OR_BEFORE, i.SINCE), w = i.TIME_DIR_AT_OR_BEYOND, T = (i.TIME_DIR_ADD, i.TIME_DIR_DELTA, 
    i.makeDaysAgo), k = i.makeDaysBefore, E = i.quantizeDate, I = 1, A = -1, O = Math.pow(2, 32) - 1;
    p.prototype = {
        acquireConn: function(e, t, n, i) {
            var o = this;
            this._deathback = t, this._account.__folderDemandsConnection(this._storage.folderId, n, function(t) {
                o._conn = t, o._conn.selectMailbox(o._storage.folderMeta.path, function(t, n) {
                    if (t) {
                        if (console.error("Problem entering folder", o._storage.folderMeta.path), o._conn = null, 
                        o._account.__folderDoneWithConnection(o._conn, !1, !0), o._deathback) {
                            var i = o._deathback;
                            o.clearErrorHandler(), i();
                        }
                    } else o.box = n, e(o, o._storage);
                });
            }, function() {
                if (o._conn = null, o._deathback) {
                    var e = o._deathback;
                    o.clearErrorHandler(), e();
                }
            }, i);
        },
        relinquishConn: function() {
            this._conn && (this.clearErrorHandler(), this._account.__folderDoneWithConnection(this._conn, !0, !1), 
            this._conn = null);
        },
        withConnection: function(e, t, n, i) {
            return this._conn ? (this._deathback = t, e(this), void 0) : (this.acquireConn(function() {
                this.withConnection(e, t, n);
            }.bind(this), t, n, i), void 0);
        },
        clearErrorHandler: function() {
            this._deathback = null;
        },
        reselectBox: function(e) {
            this._conn.selectMailbox(this._storage.folderMeta.path, e);
        },
        _timelySyncSearch: function(e, t, n, i, o) {
            var a = !1;
            if (!this._conn) return this.acquireConn(this._timelySyncSearch.bind(this, e, t, n, i, o), n, "sync", !0), 
            void 0;
            if (!o) {
                var r = n;
                n = function() {
                    a ? r() : (console.warn("Broken connection for SEARCH. Retrying."), this._timelySyncSearch(e, t, r, i, !0));
                }.bind(this);
            }
            this._deathback = n, i && i(.1), this._account.isGmail && this._conn.exec("NOOP"), 
            this._conn.search(e, {
                byUid: !0
            }, function(i, o) {
                return a = !0, i ? (console.error("Search error on", e, "err:", i), n(), void 0) : (t(o), 
                void 0);
            });
        },
        syncDateRange: function() {
            var e = Array.slice(arguments), t = this;
            s([ "imap/protocol/sync" ], function(n) {
                _ = n, (t.syncDateRange = t._lazySyncDateRange).apply(t, e);
            });
        },
        _lazySyncDateRange: function(e, t, n, i, a) {
            if (e && t && S(e, t)) return this._LOG.illegalSync(e, t), i("invariant"), void 0;
            console.log("syncDateRange:", e, t);
            var r = d(), s = this, c = s._storage, p = o.BISECT_DATE_AT_N_MESSAGES;
            e && (r.since = new Date(e)), t && (r.before = new Date(t));
            var u = y([ "search", "db" ], function(o) {
                var r = o.search, d = o.db, u = [], g = 0, v = "";
                if (s.box.highestModseq && (v = s.box.highestModseq + ""), console.log("SERVER UIDS", r.length, p), 
                r.length > p) {
                    var y = t || E(x() + b + s._account.tzOffset), S = Math.round((y - e) / b);
                    if (console.log("BISECT CASE", r.length, "curDaysDelta", S), S > 1) {
                        s._LOG.syncDateRange_end(null, null, null, e, t, null, null);
                        var w = {
                            oldStartTS: e,
                            oldEndTS: t,
                            numHeaders: r.length,
                            curDaysDelta: S,
                            newStartTS: e,
                            newEndTS: t
                        };
                        return "abort" === i("bisect", w, null) ? (s.clearErrorHandler(), i("bisect-aborted", null), 
                        null) : s.syncDateRange(w.newStartTS, w.newEndTS, n, i, a);
                    }
                }
                a && a(.25);
                for (var T = 0; T < d.length; T++) null === d[T].srvid && d.splice(T--, 1);
                for (var T = 0; T < d.length; T++) {
                    var k = d[T], I = r.indexOf(k.srvid);
                    -1 !== I ? (r[I] = null, u.push(k.srvid)) : (c.deleteMessageHeaderAndBodyUsingHeader(k), 
                    g++, d[T] = null);
                }
                var A = l(r);
                g && l(d);
                var O = new _.Sync({
                    connection: s._conn,
                    storage: s._storage,
                    newUIDs: A,
                    knownUIDs: u,
                    knownHeaders: d
                });
                O.onprogress = a, O.oncomplete = function(o, a) {
                    s._LOG.syncDateRange_end(o, a, g, e, t, null, null), s._storage.markSyncRange(e, t, v, n), 
                    m || (m = !0, s.clearErrorHandler(), i(null, null, o + a, h, f));
                };
            }), h = e - this._account.tzOffset, f = t ? t - this._account.tzOffset : null, m = !1;
            console.log("Skewed DB lookup. Start: ", h, new Date(h).toUTCString(), "End: ", f, f ? new Date(f).toUTCString() : null), 
            this._LOG.syncDateRange_begin(null, null, null, e, t, h, f), this._timelySyncSearch(r, u.search, function() {
                m || (m = !0, this._LOG.syncDateRange_end(0, 0, 0, e, t, null, null), i("aborted"));
            }.bind(this), a, !1), this._storage.getAllMessagesInImapDateRange(h, f, u.db);
        },
        downloadBodyReps: function() {
            var e = Array.slice(arguments), t = this;
            s([ "./imapchew", "./protocol/bodyfetcher", "./protocol/textparser", "./protocol/snippetparser" ], function(n, i, o, a) {
                v = n, g = i, f = o, m = a, (t.downloadBodyReps = t._lazyDownloadBodyReps).apply(t, e);
            });
        },
        _lazyDownloadBodyReps: function(e, t, i) {
            "function" == typeof t && (i = t, t = null), t = t || {};
            var o = this, a = function(a) {
                var r = v.selectSnippetBodyRep(e, a), s = t.maximumBytesToFetch, c = f.TextParser, l = [], d = n.latch();
                if (a.bodyReps.forEach(function(t, n) {
                    if (!t.isDownloaded) {
                        var i = {
                            uid: e.srvid,
                            partInfo: t._partInfo,
                            bodyRepIndex: n,
                            createSnippet: n === r,
                            headerUpdatedCallback: d.defer(e.srvid + "-" + t._partInfo)
                        }, o = Math.min(5 * t.sizeEstimate, O);
                        if (void 0 !== s) {
                            if (c = m.SnippetParser, 0 >= s) return;
                            t.sizeEstimate > s && (o = s), s -= t.sizeEstimate;
                        }
                        0 >= o && (o = 64), (void 0 !== s || t.amountDownloaded) && (i.bytes = [ t.amountDownloaded, o ]), 
                        l.push(i);
                    }
                }), !l.length) return i(null, a), void 0;
                var p = new g.BodyFetcher(o._conn, c, l);
                o._handleBodyFetcher(p, e, a, d.defer("body")), d.then(function(e) {
                    i(n.extractErrFromCallbackArgs(e), a);
                });
            };
            this._storage.getMessageBody(e.suid, e.date, a);
        },
        _handleBodyFetcher: function(e, t, n, i) {
            var o = {
                changeDetails: {
                    bodyReps: []
                }
            };
            e.onparsed = function(e, i, a) {
                return e ? (i.headerUpdatedCallback(e), void 0) : (v.updateMessageWithFetch(t, n, i, a, this._LOG), 
                t.bytesToDownloadForBodyDisplay = v.calculateBytesToDownloadForImapBodyDisplay(n), 
                this._storage.updateMessageHeader(t.date, t.id, !1, t, n, i.headerUpdatedCallback.bind(null, null)), 
                o.changeDetails.bodyReps.push(i.bodyRepIndex), void 0);
            }.bind(this), e.onend = function() {
                this._storage.updateMessageBody(t, n, {}, o, i.bind(null, null));
            }.bind(this);
        },
        _lazyDownloadBodies: function(e, t, i) {
            for (var o = 0, a = n.latch(), r = 0; r < e.length; r++) {
                var s = e[r];
                s && null === s.snippet && (o++, this.downloadBodyReps(e[r], t, a.defer(s.suid)));
            }
            a.then(function(e) {
                i(n.extractErrFromCallbackArgs(e), o);
            });
        },
        downloadBodies: function() {
            var e = Array.slice(arguments), t = this;
            s([ "./imapchew", "./protocol/bodyfetcher", "./protocol/snippetparser" ], function(n, i, o) {
                v = n, g = i, m = o, (t.downloadBodies = t._lazyDownloadBodies).apply(t, e);
            });
        },
        downloadMessageAttachments: function(e, t, i) {
            s([ "mimeparser" ], function(o) {
                var a = this._conn, r = n.latch(), s = null, c = [];
                t.forEach(function(t, n) {
                    var i = "body.peek[" + t.part + "]", l = r.defer(t.part);
                    a.listMessages(e, [ i ], {
                        byUid: !0
                    }, function(e, a) {
                        if (e) return s = e, console.error("attachments:download-error", {
                            error: e,
                            part: t.part,
                            type: t.type
                        }), l(), void 0;
                        var r, d = a[0];
                        for (var p in d) if (/body\[/.test(p)) {
                            r = d[p];
                            break;
                        }
                        if (!r) return console.error("attachments:download-error", {
                            error: "no body part?",
                            requestedPart: i,
                            responseKeys: Object.keys(d)
                        }), l(), void 0;
                        var u = new o();
                        u.write("Content-Type: " + t.type + "\r\n"), u.write("Content-Transfer-Encoding: " + t.encoding + "\r\n"), 
                        u.write("\r\n"), u.write(r), u.end();
                        var h = u.node;
                        c[n] = new Blob([ h.content ], {
                            type: h.contentType.value
                        }), l();
                    });
                }), r.then(function() {
                    i(s, c);
                });
            }.bind(this));
        },
        shutdown: function() {
            this._LOG.__die();
        }
    }, c.ImapFolderSyncer = u, u.prototype = {
        syncable: !0,
        get canGrowSync() {
            return !this.folderStorage.isLocalOnly;
        },
        initialSync: function(e, t, n, i, a) {
            n("sync", !1), this.folderConn.withConnection(function(n) {
                var r = !1;
                n && n.box && n.box.exists < o.SYNC_WHOLE_FOLDER_AT_N_MESSAGES && (r = !0), this._startSync(e, I, "grow", null, o.OLDEST_SYNC_DATE, null, r ? null : t, i, a);
            }.bind(this), function() {
                i("aborted");
            }, "initialSync", !0);
        },
        refreshSync: function(e, t, n, i, o, a, r) {
            this._startSync(e, t, "refresh", t === I ? i : n, t === I ? n : i, o, null, a, r);
        },
        growSync: function(e, t, n, i, a, r) {
            var s;
            s = t === I ? o.OLDEST_SYNC_DATE : null, this._startSync(e, t, "grow", n, s, null, i, a, r);
        },
        _startSync: function(e, t, n, i, o, a, r, s, c) {
            var l, d;
            this._syncSlice = e, this._curSyncAccuracyStamp = x(), this._curSyncDir = t, this._curSyncIsGrow = "grow" === n, 
            this._fallbackOriginTS = a, t === I ? (d = i, r ? this._nextSyncAnchorTS = l = d ? d - r * b : T(r, this._account.tzOffset) : (l = o, 
            this._nextSyncAnchorTS = null)) : (l = i, r ? this._nextSyncAnchorTS = d = l + r * b : (d = o, 
            this._nextSyncAnchorTS = null)), this._syncThroughTS = o, this._curSyncDayStep = r, 
            this._curSyncDoNotGrowBoundary = null, this._curSyncDoneCallback = s, this.folderConn.syncDateRange(l, d, this._curSyncAccuracyStamp, this.onSyncCompleted.bind(this), c);
        },
        _doneSync: function(e) {
            this._syncSlice.desiredHeaders = this._syncSlice.headers.length, this._account.__checkpointSyncCompleted(function() {
                this._curSyncDoneCallback && this._curSyncDoneCallback(e), this._syncSlice = null, 
                this._curSyncAccuracyStamp = null, this._curSyncDir = null, this._nextSyncAnchorTS = null, 
                this._syncThroughTS = null, this._curSyncDayStep = null, this._curSyncDoNotGrowBoundary = null, 
                this._curSyncDoneCallback = null;
            }.bind(this));
        },
        onSyncCompleted: function(e, t, n, i, a) {
            if ("bisect" === e) {
                var r = t.curDaysDelta, s = t.numHeaders;
                if (this._curSyncDir === A && this._fallbackOriginTS) {
                    this.folderStorage.clearSyncedToDawnOfTime(this._fallbackOriginTS), t.oldStartTS = this._fallbackOriginTS, 
                    this._fallbackOriginTS = null;
                    var c = t.oldEndTS || E(x() + b + this._account.tzOffset);
                    r = Math.round((c - t.oldStartTS) / b), s = 1.5 * o.BISECT_DATE_AT_N_MESSAGES;
                } else r > 1e3 && (r = 30);
                var l = o.BISECT_DATE_AT_N_MESSAGES / (2 * s), d = Math.max(1, Math.min(r - 2, Math.ceil(l * r)));
                return this._curSyncDayStep = d, this._curSyncDir === I ? (t.newEndTS = t.oldEndTS, 
                this._nextSyncAnchorTS = t.newStartTS = k(t.newEndTS, d, this._account.tzOffset), 
                this._curSyncDoNotGrowBoundary = t.oldStartTS) : (t.newStartTS = t.oldStartTS, this._nextSyncAnchorTS = t.newEndTS = k(t.newStartTS, -d, this._account.tzOffset), 
                this._curSyncDoNotGrowBoundary = t.oldEndTS), void 0;
            }
            if (e) return this._doneSync(e), void 0;
            if (console.log("Sync Completed!", this._curSyncDayStep, "days", n, "messages synced"), 
            this._syncSlice.isDead) return this._doneSync(), void 0;
            var p = this.folderConn && this.folderConn.box && this.folderConn.box.exists, u = this.folderStorage.getKnownMessageCount(), h = this._curSyncDir === I ? i : a;
            if (console.log("folder message count", p, "dbCount", u, "syncedThrough", h, "oldest known", this.folderStorage.getOldestMessageTimestamp()), 
            this._curSyncDir === I && p === u && (!p || w(this._curSyncDir, h, this.folderStorage.getOldestMessageTimestamp()))) return this.folderStorage.markSyncedToDawnOfTime(), 
            this._doneSync(), void 0;
            if (!this._nextSyncAnchorTS || w(this._curSyncDir, this._nextSyncAnchorTS, this._syncThroughTS)) return this._doneSync(), 
            void 0;
            if (this._curSyncIsGrow && this._syncSlice.headers.length >= this._syncSlice.desiredHeaders) return console.log("SYNCDONE Enough headers retrieved.", "have", this._syncSlice.headers.length, "want", this._syncSlice.desiredHeaders, "conn knows about", this.folderConn.box.exists, "sync date", this._curSyncStartTS, "[oldest defined as", o.OLDEST_SYNC_DATE, "]"), 
            this._doneSync(), void 0;
            var f, m;
            n || null !== this._curSyncDoNotGrowBoundary && !w(this._curSyncDir, this._nextSyncAnchorTS, this._curSyncDoNotGrowBoundary) ? f = this._curSyncDayStep : (this._curSyncDoNotGrowBoundary = null, 
            m = (E(x() + this._account.tzOffset) - this._nextSyncAnchorTS) / b, f = Math.ceil(this._curSyncDayStep * o.TIME_SCALE_FACTOR_ON_NO_MESSAGES), 
            180 > m ? f > 45 && (f = 45) : 365 > m ? f > 90 && (f = 90) : 730 > m ? f > 120 && (f = 120) : 1825 > m ? f > 180 && (f = 180) : 3650 > m ? f > 365 && (f = 365) : f > 730 && (f = 730), 
            this._curSyncDayStep = f);
            var g, v;
            this._curSyncDir === I ? (v = this._nextSyncAnchorTS, this._nextSyncAnchorTS = g = k(v, f, this._account.tzOffset)) : (g = this._nextSyncAnchorTS, 
            this._nextSyncAnchorTS = v = k(g, -f, this._account.tzOffset)), this.folderConn.syncDateRange(g, v, this._curSyncAccuracyStamp, this.onSyncCompleted.bind(this));
        },
        allConsumersDead: function() {
            this.folderConn.relinquishConn();
        },
        shutdown: function() {
            this.folderConn.shutdown(), this._LOG.__die();
        }
    }, h.prototype = {};
    var C = c.LOGFAB = e.register(r, {
        ImapFolderConn: {
            type: e.CONNECTION,
            subtype: e.CLIENT,
            events: {},
            TEST_ONLY_events: {},
            errors: {
                callbackErr: {
                    ex: e.EXCEPTION
                },
                htmlParseError: {
                    ex: e.EXCEPTION
                },
                htmlSnippetError: {
                    ex: e.EXCEPTION
                },
                textChewError: {
                    ex: e.EXCEPTION
                },
                textSnippetError: {
                    ex: e.EXCEPTION
                },
                illegalSync: {
                    startTS: !1,
                    endTS: !1
                }
            },
            asyncJobs: {
                syncDateRange: {
                    newMessages: !0,
                    existingMessages: !0,
                    deletedMessages: !0,
                    start: !1,
                    end: !1,
                    skewedStart: !1,
                    skewedEnd: !1
                }
            }
        },
        ImapFolderSyncer: {
            type: e.DATABASE,
            events: {}
        }
    });
}), function(e, t) {
    "function" == typeof define && define.amd ? define("mimeparser-tzabbr", t) : "object" == typeof exports ? module.exports = t() : e.tzabbr = t();
}(this, function() {
    return {
        ACDT: "+1030",
        ACST: "+0930",
        ACT: "+0800",
        ADT: "-0300",
        AEDT: "+1100",
        AEST: "+1000",
        AFT: "+0430",
        AKDT: "-0800",
        AKST: "-0900",
        AMST: "-0300",
        AMT: "+0400",
        ART: "-0300",
        AST: "+0300",
        AWDT: "+0900",
        AWST: "+0800",
        AZOST: "-0100",
        AZT: "+0400",
        BDT: "+0800",
        BIOT: "+0600",
        BIT: "-1200",
        BOT: "-0400",
        BRT: "-0300",
        BST: "+0600",
        BTT: "+0600",
        CAT: "+0200",
        CCT: "+0630",
        CDT: "-0500",
        CEDT: "+0200",
        CEST: "+0200",
        CET: "+0100",
        CHADT: "+1345",
        CHAST: "+1245",
        CHOT: "+0800",
        CHST: "+1000",
        CHUT: "+1000",
        CIST: "-0800",
        CIT: "+0800",
        CKT: "-1000",
        CLST: "-0300",
        CLT: "-0400",
        COST: "-0400",
        COT: "-0500",
        CST: "-0600",
        CT: "+0800",
        CVT: "-0100",
        CWST: "+0845",
        CXT: "+0700",
        DAVT: "+0700",
        DDUT: "+1000",
        DFT: "+0100",
        EASST: "-0500",
        EAST: "-0600",
        EAT: "+0300",
        ECT: "-0500",
        EDT: "-0400",
        EEDT: "+0300",
        EEST: "+0300",
        EET: "+0200",
        EGST: "+0000",
        EGT: "-0100",
        EIT: "+0900",
        EST: "-0500",
        FET: "+0300",
        FJT: "+1200",
        FKST: "-0300",
        FKT: "-0400",
        FNT: "-0200",
        GALT: "-0600",
        GAMT: "-0900",
        GET: "+0400",
        GFT: "-0300",
        GILT: "+1200",
        GIT: "-0900",
        GMT: "+0000",
        GST: "+0400",
        GYT: "-0400",
        HADT: "-0900",
        HAEC: "+0200",
        HAST: "-1000",
        HKT: "+0800",
        HMT: "+0500",
        HOVT: "+0700",
        HST: "-1000",
        ICT: "+0700",
        IDT: "+0300",
        IOT: "+0300",
        IRDT: "+0430",
        IRKT: "+0900",
        IRST: "+0330",
        IST: "+0530",
        JST: "+0900",
        KGT: "+0600",
        KOST: "+1100",
        KRAT: "+0700",
        KST: "+0900",
        LHST: "+1030",
        LINT: "+1400",
        MAGT: "+1200",
        MART: "-0930",
        MAWT: "+0500",
        MDT: "-0600",
        MET: "+0100",
        MEST: "+0200",
        MHT: "+1200",
        MIST: "+1100",
        MIT: "-0930",
        MMT: "+0630",
        MSK: "+0400",
        MST: "-0700",
        MUT: "+0400",
        MVT: "+0500",
        MYT: "+0800",
        NCT: "+1100",
        NDT: "-0230",
        NFT: "+1130",
        NPT: "+0545",
        NST: "-0330",
        NT: "-0330",
        NUT: "-1100",
        NZDT: "+1300",
        NZST: "+1200",
        OMST: "+0700",
        ORAT: "+0500",
        PDT: "-0700",
        PET: "-0500",
        PETT: "+1200",
        PGT: "+1000",
        PHOT: "+1300",
        PHT: "+0800",
        PKT: "+0500",
        PMDT: "-0200",
        PMST: "-0300",
        PONT: "+1100",
        PST: "-0800",
        PYST: "-0300",
        PYT: "-0400",
        RET: "+0400",
        ROTT: "-0300",
        SAKT: "+1100",
        SAMT: "+0400",
        SAST: "+0200",
        SBT: "+1100",
        SCT: "+0400",
        SGT: "+0800",
        SLST: "+0530",
        SRT: "-0300",
        SST: "+0800",
        SYOT: "+0300",
        TAHT: "-1000",
        THA: "+0700",
        TFT: "+0500",
        TJT: "+0500",
        TKT: "+1300",
        TLT: "+0900",
        TMT: "+0500",
        TOT: "+1300",
        TVT: "+1200",
        UCT: "+0000",
        ULAT: "+0800",
        UTC: "+0000",
        UYST: "-0200",
        UYT: "-0300",
        UZT: "+0500",
        VET: "-0430",
        VLAT: "+1000",
        VOLT: "+0400",
        VOST: "+0600",
        VUT: "+1100",
        WAKT: "+1200",
        WAST: "+0200",
        WAT: "+0100",
        WEDT: "+0100",
        WEST: "+0100",
        WET: "+0000",
        WST: "+0800",
        YAKT: "+1000",
        YEKT: "+0600",
        Z: "+0000"
    };
}), function(e, t) {
    "function" == typeof define && define.amd ? define("mimeparser", [ "mimefuncs", "addressparser", "mimeparser-tzabbr" ], t) : "object" == typeof exports ? module.exports = t(require("mimefuncs"), require("wo-addressparser"), require("./mimeparser-tzabbr")) : e.MimeParser = t(e.mimefuncs, e.addressparser, e.tzabbr);
}(this, function(e, t, n) {
    function i() {
        this.running = !0, this.nodes = {}, this.node = new o(null, this), this._remainder = "";
    }
    function o(e, t) {
        this.header = [], this.headers = {}, this.path = e ? e.path.concat(e._childNodes.length + 1) : [], 
        this._parser = t, this._parentNode = e, this._state = "HEADER", this._bodyBuffer = "", 
        this._lineCount = 0, this._childNodes = !1, this._currentChild = !1, this._lineRemainder = "", 
        this._isMultipart = !1, this._multipartBoundary = !1, this._isRfc822 = !1, this.raw = "", 
        this._parser.nodes["node" + this.path.join(".")] = this;
    }
    return i.prototype.write = function(t) {
        if (!t || !t.length) return !this.running;
        var n = (this._remainder + ("object" == typeof t ? e.fromTypedArray(t) : t)).split(/\r?\n/g);
        this._remainder = n.pop();
        for (var i = 0, o = n.length; o > i; i++) this.node.writeLine(n[i]);
        return !this.running;
    }, i.prototype.end = function(e) {
        e && e.length && this.write(e), (this.node._lineCount || this._remainder) && (this.node.writeLine(this._remainder), 
        this._remainder = ""), this.node && this.node.finalize(), this.onend();
    }, i.prototype.getNode = function(e) {
        return e = e || "", this.nodes["node" + e] || null;
    }, i.prototype.onend = function() {}, i.prototype.onheader = function() {}, i.prototype.onbody = function() {}, 
    o.prototype.writeLine = function(e) {
        this.raw += (this.raw ? "\n" : "") + e, "HEADER" === this._state ? this._processHeaderLine(e) : "BODY" === this._state && this._processBodyLine(e);
    }, o.prototype.finalize = function() {
        this._isRfc822 ? this._currentChild.finalize() : this._emitBody(!0);
    }, o.prototype._processHeaderLine = function(e) {
        return e ? (e.match(/^\s/) && this.header.length ? this.header[this.header.length - 1] += "\n" + e : this.header.push(e), 
        void 0) : (this._parseHeaders(), this._parser.onheader(this), this._state = "BODY", 
        void 0);
    }, o.prototype._parseHeaders = function() {
        for (var t, n, i, o = 0, a = this.header.length; a > o; o++) n = this.header[o].split(":"), 
        t = (n.shift() || "").trim().toLowerCase(), n = (n.join(":") || "").replace(/\n/g, "").trim(), 
        n.match(/[\u0080-\uFFFF]/) && (this.charset || (i = !0), n = e.charset.decode(e.charset.convert(e.toTypedArray(n), this.charset || "iso-8859-1"))), 
        this.headers[t] ? this.headers[t].push(this._parseHeaderValue(t, n)) : this.headers[t] = [ this._parseHeaderValue(t, n) ], 
        this.charset || "content-type" !== t || (this.charset = this.headers[t][this.headers[t].length - 1].params.charset), 
        i && this.charset && (i = !1, this.headers = {}, o = -1);
        this._processContentType(), this._processContentTransferEncoding();
    }, o.prototype._parseHeaderValue = function(n, i) {
        var o, a = !1;
        switch (n) {
          case "content-type":
          case "content-transfer-encoding":
          case "content-disposition":
          case "dkim-signature":
            o = e.parseHeaderValue(i);
            break;

          case "from":
          case "sender":
          case "to":
          case "reply-to":
          case "cc":
          case "bcc":
          case "abuse-reports-to":
          case "errors-to":
          case "return-path":
          case "delivered-to":
            a = !0, o = {
                value: [].concat(t.parse(i) || [])
            };
            break;

          case "date":
            o = {
                value: this._parseDate(i)
            };
            break;

          default:
            o = {
                value: i
            };
        }
        return o.initial = i, this._decodeHeaderCharset(o, {
            isAddress: a
        }), o;
    }, o.prototype._parseDate = function(e) {
        e = (e || "").toString().trim();
        var t = new Date(e);
        return this._isValidDate(t) ? t.toUTCString().replace(/GMT/, "+0000") : (e = e.replace(/\b[a-z]+$/i, function(e) {
            return e = e.toUpperCase(), n.hasOwnProperty(e) ? n[e] : e;
        }), t = new Date(e), this._isValidDate(t) ? t.toUTCString().replace(/GMT/, "+0000") : e);
    }, o.prototype._isValidDate = function(e) {
        return "[object Date]" === Object.prototype.toString.call(e) && "Invalid Date" !== e.toString();
    }, o.prototype._decodeHeaderCharset = function(t, n) {
        return n = n || {}, "string" == typeof t.value && (t.value = e.mimeWordsDecode(t.value)), 
        Object.keys(t.params || {}).forEach(function(n) {
            "string" == typeof t.params[n] && (t.params[n] = e.mimeWordsDecode(t.params[n]));
        }), n.isAddress && Array.isArray(t.value) && t.value.forEach(function(t) {
            t.name && (t.name = e.mimeWordsDecode(t.name), Array.isArray(t.group) && this._decodeHeaderCharset({
                value: t.group
            }, {
                isAddress: !0
            }));
        }.bind(this)), t;
    }, o.prototype._processContentType = function() {
        var t;
        this.contentType = this.headers["content-type"] && this.headers["content-type"][0] || e.parseHeaderValue("text/plain"), 
        this.contentType.value = (this.contentType.value || "").toLowerCase().trim(), this.contentType.type = this.contentType.value.split("/").shift() || "text", 
        this.contentType.params && this.contentType.params.charset && !this.charset && (this.charset = this.contentType.params.charset), 
        "multipart" === this.contentType.type && this.contentType.params.boundary && (this._childNodes = [], 
        this._isMultipart = this.contentType.value.split("/").pop() || "mixed", this._multipartBoundary = this.contentType.params.boundary), 
        "message/rfc822" === this.contentType.value && (t = this.headers["content-disposition"] && this.headers["content-disposition"][0] || e.parseHeaderValue(""), 
        "attachment" !== (t.value || "").toLowerCase().trim() && (this._childNodes = [], 
        this._currentChild = new o(this, this._parser), this._childNodes.push(this._currentChild), 
        this._isRfc822 = !0));
    }, o.prototype._processContentTransferEncoding = function() {
        this.contentTransferEncoding = this.headers["content-transfer-encoding"] && this.headers["content-transfer-encoding"][0] || e.parseHeaderValue("7bit"), 
        this.contentTransferEncoding.value = (this.contentTransferEncoding.value || "").toLowerCase().trim();
    }, o.prototype._processBodyLine = function(t) {
        var n, i;
        if (this._lineCount++, this._isMultipart) t === "--" + this._multipartBoundary ? (this._currentChild && this._currentChild.finalize(), 
        this._currentChild = new o(this, this._parser), this._childNodes.push(this._currentChild)) : t === "--" + this._multipartBoundary + "--" ? (this._currentChild && this._currentChild.finalize(), 
        this._currentChild = !1) : this._currentChild && this._currentChild.writeLine(t); else if (this._isRfc822) this._currentChild.writeLine(t); else switch (this.contentTransferEncoding.value) {
          case "base64":
            n = this._lineRemainder + t.trim(), n.length % 4 ? (this._lineRemainder = n.substr(-n.length % 4), 
            n = n.substr(0, n.length - this._lineRemainder.length)) : this._lineRemainder = "", 
            n.length && (this._bodyBuffer += e.fromTypedArray(e.base64.decode(n)));
            break;

          case "quoted-printable":
            n = this._lineRemainder + (this._lineCount > 1 ? "\n" : "") + t, (i = n.match(/=[a-f0-9]{0,1}$/i)) ? (this._lineRemainder = i[0], 
            n = n.substr(0, n.length - this._lineRemainder.length)) : this._lineRemainder = "", 
            this._bodyBuffer += n.replace(/\=(\r?\n|$)/g, "").replace(/=([a-f0-9]{2})/gi, function(e, t) {
                return String.fromCharCode(parseInt(t, 16));
            });
            break;

          default:
            this._bodyBuffer += (this._lineCount > 1 ? "\n" : "") + t;
        }
    }, o.prototype._emitBody = function() {
        var t, n = this.headers["content-disposition"] && this.headers["content-disposition"][0] || e.parseHeaderValue("");
        !this._isMultipart && this._bodyBuffer && (/^text\/(plain|html)$/i.test(this.contentType.value) && this.contentType.params && /^flowed$/i.test(this.contentType.params.format) && (t = /^yes$/i.test(this.contentType.params.delsp), 
        this._bodyBuffer = this._bodyBuffer.split("\n").reduce(function(e, n) {
            var i = e;
            return t && (i = i.replace(/[ ]+$/, "")), / $/.test(e) && !/(^|\n)\-\- $/.test(e) ? i + n : i + "\n" + n;
        }).replace(/^ /gm, "")), this.content = e.toTypedArray(this._bodyBuffer), /^text\/(plain|html)$/i.test(this.contentType.value) && !/^attachment$/i.test(n.value) && (!this.charset && /^text\/html$/i.test(this.contentType.value) && (this.charset = this._detectHTMLCharset(this._bodyBuffer)), 
        /^utf[\-_]?8$/i.test(this.charset) || (this.content = e.charset.convert(e.toTypedArray(this._bodyBuffer), this.charset || "iso-8859-1")), 
        this.charset = this.contentType.params.charset = "utf-8"), this._bodyBuffer = "", 
        this._parser.onbody(this, this.content));
    }, o.prototype._detectHTMLCharset = function(e) {
        var t, n, i;
        return "string" != typeof e && (e = e.toString("ascii")), e = e.replace(/\r?\n|\r/g, " "), 
        (i = e.match(/<meta\s+http-equiv=["'\s]*content-type[^>]*?>/i)) && (n = i[0]), n && (t = n.match(/charset\s?=\s?([a-zA-Z\-_:0-9]*);?/), 
        t && (t = (t[1] || "").trim().toLowerCase())), !t && (i = e.match(/<meta\s+charset=["'\s]*([^"'<>\/\s]+)/i)) && (t = (i[1] || "").trim().toLowerCase()), 
        t;
    }, i;
}), define("imap/jobs", [ "rdcommon/log", "slog", "mix", "../jobmixins", "../drafts/jobs", "../allback", "mimeparser", "module", "exports" ], function(e, t, n, i, o, a, r, s, c) {
    function l(e, t, n) {
        this.account = e, this.resilientServerIds = !1, this._heldMutexReleasers = [], this._LOG = f.ImapJobDriver(this, n, this.account.id), 
        this._state = t, t.hasOwnProperty("suidToServerId") || (t.suidToServerId = {}, t.moveMap = {}), 
        this._stateDelta = {
            serverIdMap: null,
            moveMap: null
        };
    }
    function d() {}
    var p = "idempotent", u = "/", h = c.deriveFolderPath = function(e, t, n, i) {
        var o, a, r;
        return n ? (a = n.delim || i.delimiter || u, o = n.path || "", r = n.depth + 1) : (a = i.delimiter || u, 
        o = i.prefix || "", r = o ? 1 : 0), o && (o += a), o += e, t && (o += a), {
            path: o,
            delimiter: a,
            depth: r
        };
    };
    c.ImapJobDriver = l, l.prototype = {
        _accessFolderForMutation: function(e, t, n, i, o) {
            var a = this.account.getFolderStorageForFolderId(e), r = this;
            a.runMutexed(o, function(e) {
                var s = a.folderSyncer, c = function() {
                    r._heldMutexReleasers.push(e);
                    try {
                        n(s.folderConn, a);
                    } catch (t) {
                        r._LOG.callbackErr(t);
                    }
                };
                t && !a.isLocalOnly ? s.folderConn.withConnection(function() {
                    r._heldMutexReleasers.push(function() {
                        s.folderConn.clearErrorHandler();
                    }), c();
                }, i, o, !0) : c();
            });
        },
        _partitionAndAccessFoldersSequentially: i._partitionAndAccessFoldersSequentially,
        _acquireConnWithoutFolder: function(e, t, n) {
            this._LOG.acquireConnWithoutFolder_begin(e);
            var i = this;
            this.account.__folderDemandsConnection(null, e, function(n) {
                i._LOG.acquireConnWithoutFolder_end(e), i._heldMutexReleasers.push(function() {
                    i.account.__folderDoneWithConnection(n, !1, !1);
                });
                try {
                    t(n);
                } catch (o) {
                    i._LOG.callbackErr(o);
                }
            }, n);
        },
        postJobCleanup: i.postJobCleanup,
        allJobsDone: i.allJobsDone,
        local_do_downloadBodies: i.local_do_downloadBodies,
        do_downloadBodies: i.do_downloadBodies,
        check_downloadBodies: i.check_downloadBodies,
        local_do_downloadBodyReps: i.local_do_downloadBodyReps,
        do_downloadBodyReps: i.do_downloadBodyReps,
        check_downloadBodyReps: i.check_downloadBodyReps,
        local_do_download: i.local_do_download,
        do_download: i.do_download,
        check_download: i.check_download,
        local_undo_download: i.local_undo_download,
        undo_download: i.undo_download,
        local_do_upgradeDB: i.local_do_upgradeDB,
        local_do_modtags: i.local_do_modtags,
        do_modtags: function(e, t, n) {
            var i = n ? e.removeTags : e.addTags, o = n ? e.addTags : e.removeTags, r = null;
            this._partitionAndAccessFoldersSequentially(e.messages, !0, function(t, s, c, l, d) {
                for (var p = [], u = 0; u < c.length; u++) {
                    var h = c[u];
                    h && p.push(h);
                }
                if (!p.length) return d(), void 0;
                var f = a.latch();
                i ? t._conn.setFlags(p.join(","), {
                    add: i
                }, {
                    byUid: !0
                }, f.defer("add")) : o && t._conn.setFlags(p.join(","), {
                    remove: o
                }, {
                    byUid: !0
                }, f.defer("remove")), f.then(function(t) {
                    var i = t.add && t.add[0] || t.remove && t.remove[0];
                    i ? (console.error("failure modifying tags", i), r = "unknown") : e.progress += n ? -c.length : c.length, 
                    d();
                });
            }, function() {
                t(r);
            }, function() {
                r = "aborted-retry";
            }, n, "modtags");
        },
        check_modtags: function(e, t) {
            t(null, p);
        },
        local_undo_modtags: i.local_undo_modtags,
        undo_modtags: function(e, t) {
            return this.do_modtags(e, t, !0);
        },
        local_do_delete: i.local_do_delete,
        do_delete: function(e, t) {
            var n = this.account.getFirstFolderWithType("trash");
            this.do_move(e, t, n.id);
        },
        check_delete: function(e, t) {
            var n = this.account.getFirstFolderWithType("trash");
            this.check_move(e, t, n.id);
        },
        local_undo_delete: i.local_undo_delete,
        undo_delete: function() {},
        local_do_move: i.local_do_move,
        do_move: function(e, t, n) {
            var i = this._state, o = this._stateDelta, s = null;
            o.serverIdMap || (o.serverIdMap = {}), n || (n = e.targetFolder), this._partitionAndAccessFoldersSequentially(e.messages, !0, function(t, c, l, d, p) {
                function u(e, n) {
                    function s() {
                        e._conn.selectMailbox(n.folderMeta.path, c);
                    }
                    function c() {
                        e._conn.listMessages(u + ":*", [ "UID", "BODY.PEEK[HEADER.FIELDS (MESSAGE-ID)]" ], {
                            byUid: d
                        }, function(e, t) {
                            if (e) p(); else {
                                var s = a.latch();
                                t.forEach(function(e) {
                                    var t = s.defer();
                                    for (var a in e) if (/header\.fields/.test(a)) {
                                        var c = new r();
                                        c.write(e[a] + "\r\n"), c.end(), e.headers = c.node.headers;
                                        break;
                                    }
                                    var l = e.headers["message-id"] && e.headers["message-id"][0] && e.headers["message-id"][0].value;
                                    if (l && "<" === l[0] && (l = l.slice(1, -1)), !m.hasOwnProperty(l)) return t(), 
                                    void 0;
                                    var d = m[l];
                                    o.serverIdMap[d.suid] = e.uid, uidnext = e.uid + 1;
                                    var p = i.moveMap[d.suid], u = parseInt(p.substring(p.lastIndexOf("/") + 1));
                                    n.updateMessageHeader(d.date, u, !1, function(n) {
                                        return n ? n.srvid = e.uid : console.warn("did not find header for", d.suid, p, d.date, u), 
                                        t(), !0;
                                    }, null);
                                }), s.then(h);
                            }
                        });
                    }
                    var d, u;
                    e.box.uidNext ? (d = !0, u = e.box.uidNext) : (d = !1, u = e.box.exists), t._conn.copyMessages(l.join(","), n.folderMeta.path, {
                        byUid: !0
                    }, s);
                }
                function h() {
                    t._conn.deleteMessages(l.join(","), {
                        byUid: !0
                    }, f);
                }
                function f(e) {
                    e && (s = !0), p();
                }
                for (var m = {}, g = d.length - 1; g >= 0; g--) {
                    var v = l[g];
                    if (v) {
                        var _ = d[g];
                        m[_.guid] = _;
                    } else l.splice(g, 1), d.splice(g, 1);
                }
                return 0 === l.length ? (p(), void 0) : (c.isLocalOnly ? p() : c.folderId === n ? "move" === e.type ? p() : h() : this._accessFolderForMutation(n, !0, u, function() {}, "move target"), 
                void 0);
            }.bind(this), function() {
                t(s);
            }, null, !1, "server move source");
        },
        check_move: function(e, t) {
            t(null, "moot");
        },
        local_undo_move: i.local_undo_move,
        undo_move: function(e, t) {
            t("moot");
        },
        local_do_append: function(e, t) {
            t(null);
        },
        do_append: function(e, t) {
            var n, i = this.account.getFolderStorageForFolderId(e.folderId), o = i.folderMeta, a = 0, r = function(e) {
                return e ? (n = e, c(), void 0) : (d("unknown"), void 0);
            }, s = function() {
                t("aborted-retry");
            }, c = function() {
                var t = e.messages[a++], i = new FileReaderSync().readAsBinaryString(t.messageText);
                n._conn.upload(o.path, i, {
                    flags: t.flags
                }, l);
            }, l = function(t) {
                return t ? (console.error("failure appending message", t), d("unknown"), void 0) : (a < e.messages.length ? c() : d(null), 
                void 0);
            }, d = function(e) {
                n && (n = null), t(e);
            };
            this._accessFolderForMutation(e.folderId, !0, r, s, "append");
        },
        check_append: function(e, t) {
            t(null, "moot");
        },
        local_undo_append: function(e, t) {
            t(null);
        },
        undo_append: function(e, t) {
            t("moot");
        },
        local_do_syncFolderList: function(e, t) {
            t(null);
        },
        do_syncFolderList: function(e, t) {
            var n = this.account, i = !1;
            this._acquireConnWithoutFolder("syncFolderList", function(e) {
                n._syncFolderList(e, function(e) {
                    e || (n.meta.lastFolderSyncAt = Date.now()), i || t(e ? "aborted-retry" : null, null, !e), 
                    i = !0;
                });
            }, function() {
                i || t("aborted-retry"), i = !0;
            });
        },
        check_syncFolderList: function(e, t) {
            t(null, "coherent-notyet");
        },
        local_undo_syncFolderList: function(e, t) {
            t("moot");
        },
        undo_syncFolderList: function(e, t) {
            t("moot");
        },
        local_do_createFolder: function(e, t) {
            t(null);
        },
        do_createFolder: function(e, n) {
            function i(e, t) {
                n && (n(e, t), n = null);
            }
            function o() {
                i("aborted-retry", null);
            }
            var a;
            if (e.parentFolderId) {
                if (!this.account._folderInfos.hasOwnProperty(e.parentFolderId)) throw new Error("No such folder: " + e.parentFolderId);
                a = this.account._folderInfos[e.parentFolderId].$meta;
            }
            var r = this.account._namespaces && this.account._namespaces.personal || {
                prefix: "",
                delimiter: u
            }, s = h(e.folderName, e.containOtherFolders, a, r), c = s.path, l = function(e) {
                t.log("imap:creatingFolder", {
                    _path: c
                }), e.createMailbox(c, d);
            }.bind(this), d = function(n, o) {
                if (n) return t.error("imap:createFolderErr", {
                    _path: c,
                    err: n
                }), i("failure-give-up", null), void 0;
                t.log("imap:createdFolder", {
                    _path: c,
                    alreadyExists: o
                });
                var a = this.account._learnAboutFolder(e.folderName, c, e.parentFolderId, e.folderType, s.delimiter, s.depth, !1);
                i(null, a);
            }.bind(this), p = this.account.getFolderByPath(c);
            p ? i(null, p) : this._acquireConnWithoutFolder("createFolder", l, o);
        },
        check_createFolder: function(e, t) {
            t("moot");
        },
        local_undo_createFolder: function(e, t) {
            t(null);
        },
        undo_createFolder: function(e, t) {
            t("moot");
        },
        local_do_purgeExcessMessages: function(e, t) {
            this._accessFolderForMutation(e.folderId, !1, function(e, n) {
                n.purgeExcessMessages(function(e) {
                    t(null, null, e > 0);
                });
            }, null, "purgeExcessMessages");
        },
        do_purgeExcessMessages: function(e, t) {
            t(null);
        },
        check_purgeExcessMessages: function() {
            return p;
        },
        local_undo_purgeExcessMessages: function(e, t) {
            t(null);
        },
        undo_purgeExcessMessages: function(e, t) {
            t(null);
        },
        local_do_sendOutboxMessages: i.local_do_sendOutboxMessages,
        do_sendOutboxMessages: i.do_sendOutboxMessages,
        check_sendOutboxMessages: i.check_sendOutboxMessages,
        local_undo_sendOutboxMessages: i.local_undo_sendOutboxMessages,
        undo_sendOutboxMessages: i.undo_sendOutboxMessages,
        local_do_setOutboxSyncEnabled: i.local_do_setOutboxSyncEnabled
    }, d.prototype = {
        do_xmove: function() {},
        check_xmove: function() {},
        undo_xmove: function() {},
        do_xcopy: function() {},
        check_xcopy: function() {},
        undo_xcopy: function() {}
    }, n(l.prototype, o.draftsMixins);
    var f = c.LOGFAB = e.register(s, {
        ImapJobDriver: {
            type: e.DAEMON,
            events: {
                savedAttachment: {
                    storage: !0,
                    mimeType: !0,
                    size: !0
                },
                saveFailure: {
                    storage: !1,
                    mimeType: !1,
                    error: !1
                }
            },
            TEST_ONLY_events: {
                saveFailure: {
                    filename: !1
                }
            },
            asyncJobs: {
                acquireConnWithoutFolder: {
                    label: !1
                }
            },
            errors: {
                callbackErr: {
                    ex: e.EXCEPTION
                }
            }
        }
    });
}), function(e, t) {
    "function" == typeof define && define.amd ? define("imap-formal-syntax", t) : "object" == typeof exports ? module.exports = t() : e.imapFormalSyntax = t();
}(this, function() {
    function e(e, t) {
        for (var n = [], i = e; t >= i; i++) n.push(i);
        return String.fromCharCode.apply(String, n);
    }
    function t(e, t) {
        for (var n = Array.prototype.slice.call(e), i = n.length - 1; i >= 0; i--) t.indexOf(n[i]) >= 0 && n.splice(i, 1);
        return n.join("");
    }
    return {
        CHAR: function() {
            var t = e(1, 127);
            return this.CHAR = function() {
                return t;
            }, t;
        },
        CHAR8: function() {
            var t = e(1, 255);
            return this.CHAR8 = function() {
                return t;
            }, t;
        },
        SP: function() {
            return " ";
        },
        CTL: function() {
            var t = e(0, 31) + "";
            return this.CTL = function() {
                return t;
            }, t;
        },
        DQUOTE: function() {
            return '"';
        },
        ALPHA: function() {
            var t = e(65, 90) + e(97, 122);
            return this.ALPHA = function() {
                return t;
            }, t;
        },
        DIGIT: function() {
            var t = e(48, 57) + e(97, 122);
            return this.DIGIT = function() {
                return t;
            }, t;
        },
        "ATOM-CHAR": function() {
            var e = t(this.CHAR(), this["atom-specials"]());
            return this["ATOM-CHAR"] = function() {
                return e;
            }, e;
        },
        "ASTRING-CHAR": function() {
            var e = this["ATOM-CHAR"]() + this["resp-specials"]();
            return this["ASTRING-CHAR"] = function() {
                return e;
            }, e;
        },
        "TEXT-CHAR": function() {
            var e = t(this.CHAR(), "\r\n");
            return this["TEXT-CHAR"] = function() {
                return e;
            }, e;
        },
        "atom-specials": function() {
            var e = "(){" + this.SP() + this.CTL() + this["list-wildcards"]() + this["quoted-specials"]() + this["resp-specials"]();
            return this["atom-specials"] = function() {
                return e;
            }, e;
        },
        "list-wildcards": function() {
            return "%*";
        },
        "quoted-specials": function() {
            var e = this.DQUOTE() + "\\";
            return this["quoted-specials"] = function() {
                return e;
            }, e;
        },
        "resp-specials": function() {
            return "]";
        },
        tag: function() {
            var e = t(this["ASTRING-CHAR"](), "+");
            return this.tag = function() {
                return e;
            }, e;
        },
        command: function() {
            var e = this.ALPHA() + this.DIGIT();
            return this.command = function() {
                return e;
            }, e;
        },
        verify: function(e, t) {
            for (var n = 0, i = e.length; i > n; n++) if (t.indexOf(e.charAt(n)) < 0) return n;
            return -1;
        }
    };
}), function(e, t) {
    "function" == typeof define && define.amd ? define("imap-handler/src/imap-parser", [ "imap-formal-syntax" ], t) : "object" == typeof exports ? module.exports = t(require("./imap-formal-syntax")) : e.imapParser = t(e.imapFormalSyntax);
}(this, function(e) {
    function t(e, t) {
        this.input = (e || "").toString(), this.options = t || {}, this.remainder = this.input, 
        this.pos = 0;
    }
    function n(e, t, n, i) {
        this.str = (n || "").toString(), this.options = i || {}, this.parent = e, this.tree = this.currentNode = this.createNode(), 
        this.pos = t || 0, this.currentNode.type = "TREE", this.state = "NORMAL", this.processString();
    }
    return t.prototype.getTag = function() {
        return this.tag || (this.tag = this.getElement(e.tag() + "*+", !0)), this.tag;
    }, t.prototype.getCommand = function() {
        var t;
        switch (this.command || (this.command = this.getElement(e.command())), (this.command || "").toString().toUpperCase()) {
          case "OK":
          case "NO":
          case "BAD":
          case "PREAUTH":
          case "BYE":
            t = this.remainder.match(/^ \[(?:[^\]]*\])+/), t ? (this.humanReadable = this.remainder.substr(t[0].length).trim(), 
            this.remainder = t[0]) : (this.humanReadable = this.remainder.trim(), this.remainder = "");
        }
        return this.command;
    }, t.prototype.getElement = function(t) {
        var n, i, o;
        if (this.remainder.match(/^\s/)) throw new Error("Unexpected whitespace at position " + this.pos);
        if (!(n = this.remainder.match(/^[^\s]+(?=\s|$)/))) throw new Error("Unexpected end of input at position " + this.pos);
        if (i = n[0], (o = e.verify(i, t)) >= 0) throw new Error("Unexpected char at position " + (this.pos + o));
        return this.pos += n[0].length, this.remainder = this.remainder.substr(n[0].length), 
        i;
    }, t.prototype.getSpace = function() {
        if (!this.remainder.length) throw new Error("Unexpected end of input at position " + this.pos);
        if (e.verify(this.remainder.charAt(0), e.SP()) >= 0) throw new Error("Unexpected char at position " + this.pos);
        this.pos++, this.remainder = this.remainder.substr(1);
    }, t.prototype.getAttributes = function() {
        if (!this.remainder.length) throw new Error("Unexpected end of input at position " + this.pos);
        if (this.remainder.match(/^\s/)) throw new Error("Unexpected whitespace at position " + this.pos);
        return new n(this, this.pos, this.remainder, this.options).getAttributes();
    }, n.prototype.getAttributes = function() {
        var e = [], t = e, n = function(e) {
            var i, o, a = t;
            if (e.closed || "SEQUENCE" !== e.type || "*" !== e.value || (e.closed = !0, e.type = "ATOM"), 
            !e.closed) throw new Error("Unexpected end of input at position " + (this.pos + this.str.length - 1));
            switch (e.type.toUpperCase()) {
              case "LITERAL":
              case "STRING":
              case "SEQUENCE":
                i = {
                    type: e.type.toUpperCase(),
                    value: e.value
                }, t.push(i);
                break;

              case "ATOM":
                if ("NIL" === e.value.toUpperCase()) {
                    t.push(null);
                    break;
                }
                i = {
                    type: e.type.toUpperCase(),
                    value: e.value
                }, t.push(i);
                break;

              case "SECTION":
                t = t[t.length - 1].section = [];
                break;

              case "LIST":
                i = [], t.push(i), t = i;
                break;

              case "PARTIAL":
                if (o = e.value.split(".").map(Number), o.slice(-1)[0] < o.slice(0, 1)[0]) throw new Error("Invalid partial value at position " + e.startPos);
                t[t.length - 1].partial = o;
            }
            e.childNodes.forEach(function(e) {
                n(e);
            }), t = a;
        }.bind(this);
        return n(this.tree), e;
    }, n.prototype.createNode = function(e, t) {
        var n = {
            childNodes: [],
            type: !1,
            value: "",
            closed: !0
        };
        return e && (n.parentNode = e), "number" == typeof t && (n.startPos = t), e && e.childNodes.push(n), 
        n;
    }, n.prototype.processString = function() {
        var t, n, i, o = function() {
            for (;" " === this.str.charAt(n + 1); ) n++;
        }.bind(this);
        for (n = 0, i = this.str.length; i > n; n++) switch (t = this.str.charAt(n), this.state) {
          case "NORMAL":
            switch (t) {
              case '"':
                this.currentNode = this.createNode(this.currentNode, this.pos + n), this.currentNode.type = "string", 
                this.state = "STRING", this.currentNode.closed = !1;
                break;

              case "(":
                this.currentNode = this.createNode(this.currentNode, this.pos + n), this.currentNode.type = "LIST", 
                this.currentNode.closed = !1;
                break;

              case ")":
                if ("LIST" !== this.currentNode.type) throw new Error("Unexpected list terminator ) at position " + (this.pos + n));
                this.currentNode.closed = !0, this.currentNode.endPos = this.pos + n, this.currentNode = this.currentNode.parentNode, 
                o();
                break;

              case "]":
                if ("SECTION" !== this.currentNode.type) throw new Error("Unexpected section terminator ] at position " + (this.pos + n));
                this.currentNode.closed = !0, this.currentNode.endPos = this.pos + n, this.currentNode = this.currentNode.parentNode, 
                o();
                break;

              case "<":
                "]" !== this.str.charAt(n - 1) ? (this.currentNode = this.createNode(this.currentNode, this.pos + n), 
                this.currentNode.type = "ATOM", this.currentNode.value = t, this.state = "ATOM") : (this.currentNode = this.createNode(this.currentNode, this.pos + n), 
                this.currentNode.type = "PARTIAL", this.state = "PARTIAL", this.currentNode.closed = !1);
                break;

              case "{":
                this.currentNode = this.createNode(this.currentNode, this.pos + n), this.currentNode.type = "LITERAL", 
                this.state = "LITERAL", this.currentNode.closed = !1;
                break;

              case "*":
                this.currentNode = this.createNode(this.currentNode, this.pos + n), this.currentNode.type = "SEQUENCE", 
                this.currentNode.value = t, this.currentNode.closed = !1, this.state = "SEQUENCE";
                break;

              case " ":
                break;

              case "[":
                if ([ "OK", "NO", "BAD", "BYE", "PREAUTH" ].indexOf(this.parent.command.toUpperCase()) >= 0 && this.currentNode === this.tree) {
                    this.currentNode.endPos = this.pos + n, this.currentNode = this.createNode(this.currentNode, this.pos + n), 
                    this.currentNode.type = "ATOM", this.currentNode = this.createNode(this.currentNode, this.pos + n), 
                    this.currentNode.type = "SECTION", this.currentNode.closed = !1, this.state = "NORMAL", 
                    "REFERRAL " === this.str.substr(n + 1, 9).toUpperCase() && (this.currentNode = this.createNode(this.currentNode, this.pos + n + 1), 
                    this.currentNode.type = "ATOM", this.currentNode.endPos = this.pos + n + 8, this.currentNode.value = "REFERRAL", 
                    this.currentNode = this.currentNode.parentNode, this.currentNode = this.createNode(this.currentNode, this.pos + n + 10), 
                    this.currentNode.type = "ATOM", n = this.str.indexOf("]", n + 10), this.currentNode.endPos = this.pos + n - 1, 
                    this.currentNode.value = this.str.substring(this.currentNode.startPos - this.pos, this.currentNode.endPos - this.pos + 1), 
                    this.currentNode = this.currentNode.parentNode, this.currentNode.closed = !0, this.currentNode = this.currentNode.parentNode, 
                    o());
                    break;
                }

              default:
                if (e["ATOM-CHAR"]().indexOf(t) < 0 && "\\" !== t && "%" !== t) throw new Error("Unexpected char at position " + (this.pos + n));
                this.currentNode = this.createNode(this.currentNode, this.pos + n), this.currentNode.type = "ATOM", 
                this.currentNode.value = t, this.state = "ATOM";
            }
            break;

          case "ATOM":
            if (" " === t) {
                this.currentNode.endPos = this.pos + n - 1, this.currentNode = this.currentNode.parentNode, 
                this.state = "NORMAL";
                break;
            }
            if (this.currentNode.parentNode && (")" === t && "LIST" === this.currentNode.parentNode.type || "]" === t && "SECTION" === this.currentNode.parentNode.type)) {
                this.currentNode.endPos = this.pos + n - 1, this.currentNode = this.currentNode.parentNode, 
                this.currentNode.closed = !0, this.currentNode.endPos = this.pos + n, this.currentNode = this.currentNode.parentNode, 
                this.state = "NORMAL", o();
                break;
            }
            if ("," !== t && ":" !== t || !this.currentNode.value.match(/^\d+$/) || (this.currentNode.type = "SEQUENCE", 
            this.currentNode.closed = !0, this.state = "SEQUENCE"), "[" === t) {
                if ([ "BODY", "BODY.PEEK" ].indexOf(this.currentNode.value.toUpperCase()) < 0) throw new Error("Unexpected section start char [ at position " + this.pos);
                this.currentNode.endPos = this.pos + n, this.currentNode = this.createNode(this.currentNode.parentNode, this.pos + n), 
                this.currentNode.type = "SECTION", this.currentNode.closed = !1, this.state = "NORMAL";
                break;
            }
            if ("<" === t) throw new Error("Unexpected start of partial at position " + this.pos);
            if (e["ATOM-CHAR"]().indexOf(t) < 0 && "]" !== t && ("*" !== t || "\\" !== this.currentNode.value)) throw new Error("Unexpected char at position " + (this.pos + n));
            if ("\\*" === this.currentNode.value) throw new Error("Unexpected char at position " + (this.pos + n));
            this.currentNode.value += t;
            break;

          case "STRING":
            if ('"' === t) {
                this.currentNode.endPos = this.pos + n, this.currentNode.closed = !0, this.currentNode = this.currentNode.parentNode, 
                this.state = "NORMAL", o();
                break;
            }
            if ("\\" === t) {
                if (n++, n >= i) throw new Error("Unexpected end of input at position " + (this.pos + n));
                t = this.str.charAt(n);
            }
            if (e["TEXT-CHAR"]().indexOf(t) < 0) throw new Error("Unexpected char at position " + (this.pos + n));
            this.currentNode.value += t;
            break;

          case "PARTIAL":
            if (">" === t) {
                if ("." === this.currentNode.value.substr(-1)) throw new Error("Unexpected end of partial at position " + this.pos);
                this.currentNode.endPos = this.pos + n, this.currentNode.closed = !0, this.currentNode = this.currentNode.parentNode, 
                this.state = "NORMAL", o();
                break;
            }
            if ("." === t && (!this.currentNode.value.length || this.currentNode.value.match(/\./))) throw new Error("Unexpected partial separator . at position " + this.pos);
            if (e.DIGIT().indexOf(t) < 0 && "." !== t) throw new Error("Unexpected char at position " + (this.pos + n));
            if (this.currentNode.value.match(/^0$|\.0$/) && "." !== t) throw new Error("Invalid partial at position " + (this.pos + n));
            this.currentNode.value += t;
            break;

          case "LITERAL":
            if (this.currentNode.started) {
                if ("\0" === t) throw new Error("Unexpected \\x00 at position " + (this.pos + n));
                this.currentNode.value += t, this.currentNode.value.length >= this.currentNode.literalLength && (this.currentNode.endPos = this.pos + n, 
                this.currentNode.closed = !0, this.currentNode = this.currentNode.parentNode, this.state = "NORMAL", 
                o());
                break;
            }
            if ("+" === t && this.options.literalPlus) {
                this.currentNode.literalPlus = !0;
                break;
            }
            if ("}" === t) {
                if (!("literalLength" in this.currentNode)) throw new Error("Unexpected literal prefix end char } at position " + (this.pos + n));
                if ("\n" === this.str.charAt(n + 1)) n++; else {
                    if ("\r" !== this.str.charAt(n + 1) || "\n" !== this.str.charAt(n + 2)) throw new Error("Unexpected char at position " + (this.pos + n));
                    n += 2;
                }
                this.currentNode.literalLength = Number(this.currentNode.literalLength), this.currentNode.started = !0, 
                this.currentNode.literalLength || (this.currentNode.endPos = this.pos + n, this.currentNode.closed = !0, 
                this.currentNode = this.currentNode.parentNode, this.state = "NORMAL", o());
                break;
            }
            if (e.DIGIT().indexOf(t) < 0) throw new Error("Unexpected char at position " + (this.pos + n));
            if ("0" === this.currentNode.literalLength) throw new Error("Invalid literal at position " + (this.pos + n));
            this.currentNode.literalLength = (this.currentNode.literalLength || "") + t;
            break;

          case "SEQUENCE":
            if (" " === t) {
                if (!this.currentNode.value.substr(-1).match(/\d/) && "*" !== this.currentNode.value.substr(-1)) throw new Error("Unexpected whitespace at position " + (this.pos + n));
                if ("*" === this.currentNode.value.substr(-1) && ":" !== this.currentNode.value.substr(-2, 1)) throw new Error("Unexpected whitespace at position " + (this.pos + n));
                this.currentNode.closed = !0, this.currentNode.endPos = this.pos + n - 1, this.currentNode = this.currentNode.parentNode, 
                this.state = "NORMAL";
                break;
            }
            if (this.currentNode.parentNode && "]" === t && "SECTION" === this.currentNode.parentNode.type) {
                this.currentNode.endPos = this.pos + n - 1, this.currentNode = this.currentNode.parentNode, 
                this.currentNode.closed = !0, this.currentNode.endPos = this.pos + n, this.currentNode = this.currentNode.parentNode, 
                this.state = "NORMAL", o();
                break;
            }
            if (":" === t) {
                if (!this.currentNode.value.substr(-1).match(/\d/) && "*" !== this.currentNode.value.substr(-1)) throw new Error("Unexpected range separator : at position " + (this.pos + n));
            } else if ("*" === t) {
                if ([ ",", ":" ].indexOf(this.currentNode.value.substr(-1)) < 0) throw new Error("Unexpected range wildcard at position " + (this.pos + n));
            } else if ("," === t) {
                if (!this.currentNode.value.substr(-1).match(/\d/) && "*" !== this.currentNode.value.substr(-1)) throw new Error("Unexpected sequence separator , at position " + (this.pos + n));
                if ("*" === this.currentNode.value.substr(-1) && ":" !== this.currentNode.value.substr(-2, 1)) throw new Error("Unexpected sequence separator , at position " + (this.pos + n));
            } else if (!t.match(/\d/)) throw new Error("Unexpected char at position " + (this.pos + n));
            if (t.match(/\d/) && "*" === this.currentNode.value.substr(-1)) throw new Error("Unexpected number at position " + (this.pos + n));
            this.currentNode.value += t;
        }
    }, function(n, i) {
        var o, a = {};
        return i = i || {}, o = new t(n, i), a.tag = o.getTag(), o.getSpace(), a.command = o.getCommand(), 
        [ "UID", "AUTHENTICATE" ].indexOf((a.command || "").toUpperCase()) >= 0 && (o.getSpace(), 
        a.command += " " + o.getElement(e.command())), o.remainder.trim().length && (o.getSpace(), 
        a.attributes = o.getAttributes()), o.humanReadable && (a.attributes = (a.attributes || []).concat({
            type: "TEXT",
            value: o.humanReadable
        })), a;
    };
}), function(e, t) {
    "function" == typeof define && define.amd ? define("imap-handler/src/imap-compiler", [ "imap-formal-syntax" ], t) : "object" == typeof exports ? module.exports = t(require("./imap-formal-syntax")) : e.imapCompiler = t(e.imapFormalSyntax);
}(this, function(e) {
    return function(t, n) {
        var i, o, a = [], r = (t.tag || "") + (t.command ? " " + t.command : ""), s = function(t) {
            if (("LITERAL" === o || [ "(", "<", "[" ].indexOf(r.substr(-1)) < 0 && r.length) && (r += " "), 
            Array.isArray(t)) return o = "LIST", r += "(", t.forEach(s), r += ")", void 0;
            if (!t && "string" != typeof t && "number" != typeof t) return r += "NIL", void 0;
            if ("string" == typeof t) return r += JSON.stringify(t), void 0;
            if ("number" == typeof t) return r += Math.round(t) || 0, void 0;
            switch (o = t.type, t.type.toUpperCase()) {
              case "LITERAL":
                r += t.value ? "{" + t.value.length + "}\r\n" : "{0}\r\n", a.push(r), r = t.value || "";
                break;

              case "STRING":
                r += JSON.stringify(t.value || "");
                break;

              case "TEXT":
              case "SEQUENCE":
                r += t.value || "";
                break;

              case "NUMBER":
                r += t.value || 0;
                break;

              case "ATOM":
              case "SECTION":
                i = t.value || "", e.verify("\\" === i.charAt(0) ? i.substr(1) : i, e["ATOM-CHAR"]()) >= 0 && (i = JSON.stringify(i)), 
                r += i, t.section && (r += "[", t.section.forEach(s), r += "]"), t.partial && (r += "<" + t.partial.join(".") + ">");
            }
        };
        return [].concat(t.attributes || []).forEach(s), r.length && a.push(r), n ? a : a.join("");
    };
}), function(e, t) {
    "function" == typeof define && define.amd ? define("imap-handler/src/imap-handler", [ "./imap-parser", "./imap-compiler" ], t) : "object" == typeof exports ? module.exports = t(require("./imap-parser"), require("./imap-compiler")) : e.imapHandler = t(e.imapParser, e.imapCompiler);
}(this, function(e, t) {
    return {
        parser: e,
        compiler: t
    };
}), define("imap-handler", [ "./imap-handler/src/imap-handler" ], function(e) {
    return e;
}), define("axeshim-browserbox", [ "slog" ], function() {
    var e = require("slog"), t = "browserbox";
    return {
        debug: function(n, i) {
            e.debug(t, {
                msg: i
            });
        },
        log: function(n, i) {
            e.log(t, {
                msg: i
            });
        },
        warn: function(n, i) {
            e.warn(t, {
                msg: i
            });
        },
        error: function(n, i) {
            e.error(t, {
                msg: i
            });
        }
    };
}), function(e, t) {
    "function" == typeof define && define.amd ? define("browserbox-imap", [ "tcp-socket", "imap-handler", "mimefuncs", "axe" ], function(e, n, i, o) {
        return t(e, n, i, o);
    }) : "object" == typeof exports ? module.exports = t(require("tcp-socket"), require("wo-imap-handler"), require("mimefuncs"), require("axe-logger")) : e.BrowserboxImapClient = t(navigator.TCPSocket, e.imapHandler, e.mimefuncs, e.axe);
}(this, function(e, t, n, i) {
    function o(t, n, i) {
        this._TCPSocket = e, this.options = i || {}, this.port = n || (this.options.useSecureTransport ? 993 : 143), 
        this.host = t || "localhost", this.options.useSecureTransport = "useSecureTransport" in this.options ? !!this.options.useSecureTransport : 993 === this.port, 
        this.options.auth = this.options.auth || !1, this.socket = !1, this.destroyed = !1, 
        this.waitDrain = !1, this.secureMode = !!this.options.useSecureTransport, this._connectionReady = !1, 
        this._remainder = "", this._command = "", this._literalRemaining = 0, this._processingServerData = !1, 
        this._serverQueue = [], this._canSend = !1, this._clientQueue = [], this._tagCounter = 0, 
        this._currentCommand = !1, this._globalAcceptUntagged = {}, this._idleTimer = !1, 
        this._socketTimeoutTimer = !1;
    }
    var a = "browserbox IMAP";
    return o.prototype.TIMEOUT_ENTER_IDLE = 1e3, o.prototype.TIMEOUT_SOCKET_LOWER_BOUND = 1e4, 
    o.prototype.TIMEOUT_SOCKET_MULTIPLIER = .1, o.prototype.onerror = function() {}, 
    o.prototype.ondrain = function() {}, o.prototype.onclose = function() {}, o.prototype.onready = function() {}, 
    o.prototype.onidle = function() {}, o.prototype.connect = function() {
        this.socket = this._TCPSocket.open(this.host, this.port, {
            binaryType: "arraybuffer",
            useSecureTransport: this.secureMode,
            ca: this.options.ca,
            tlsWorkerPath: this.options.tlsWorkerPath
        });
        try {
            this.socket.oncert = this.oncert;
        } catch (e) {}
        this.socket.onerror = this._onError.bind(this), this.socket.onopen = this._onOpen.bind(this);
    }, o.prototype.close = function() {
        this.socket && "open" === this.socket.readyState ? this.socket.close() : this._destroy();
    }, o.prototype.upgrade = function(e) {
        return this.secureMode ? e(null, !1) : (this.secureMode = !0, this.socket.upgradeToSecure(), 
        e(null, !0), void 0);
    }, o.prototype.exec = function(e, t, n, i) {
        return "string" == typeof e && (e = {
            command: e
        }), this._addToClientQueue(e, t, n, i), this;
    }, o.prototype.send = function(e) {
        var t = n.toTypedArray(e).buffer, i = this.TIMEOUT_SOCKET_LOWER_BOUND + Math.floor(t.byteLength * this.TIMEOUT_SOCKET_MULTIPLIER);
        clearTimeout(this._socketTimeoutTimer), this._socketTimeoutTimer = setTimeout(this._onTimeout.bind(this), i), 
        this.waitDrain = this.socket.send(t);
    }, o.prototype.setHandler = function(e, t) {
        this._globalAcceptUntagged[(e || "").toString().toUpperCase().trim()] = t;
    }, o.prototype._onError = function(e) {
        this.isError(e) ? this.onerror(e) : e && this.isError(e.data) ? this.onerror(e.data) : this.onerror(new Error(e && e.data && e.data.message || e.data || e || "Error")), 
        this.close();
    }, o.prototype._destroy = function() {
        this._serverQueue = [], this._clientQueue = [], this._currentCommand = !1, clearTimeout(this._idleTimer), 
        clearTimeout(this._socketTimeoutTimer), this.destroyed || (this.destroyed = !0, 
        this.onclose());
    }, o.prototype._onClose = function() {
        this._destroy();
    }, o.prototype._onTimeout = function() {
        var e = new Error("Socket timed out!");
        i.error(a, e), this._onError(e);
    }, o.prototype._onDrain = function() {
        this.waitDrain = !1, this.ondrain();
    }, o.prototype._onData = function(e) {
        if (e && e.data) {
            clearTimeout(this._socketTimeoutTimer);
            var t, i = n.fromTypedArray(e.data);
            if (this._literalRemaining) {
                if (this._literalRemaining > i.length) return this._literalRemaining -= i.length, 
                this._command += i, void 0;
                this._command += i.substr(0, this._literalRemaining), i = i.substr(this._literalRemaining), 
                this._literalRemaining = 0;
            }
            for (this._remainder = i = this._remainder + i; t = i.match(/(\{(\d+)(\+)?\})?\r?\n/); ) if (t[2]) {
                if (this._remainder = "", this._command += i.substr(0, t.index + t[0].length), this._literalRemaining = Number(t[2]), 
                i = i.substr(t.index + t[0].length), this._literalRemaining > i.length) return this._command += i, 
                this._literalRemaining -= i.length, void 0;
                this._command += i.substr(0, this._literalRemaining), this._remainder = i = i.substr(this._literalRemaining), 
                this._literalRemaining = 0;
            } else this._addToServerQueue(this._command + i.substr(0, t.index)), this._remainder = i = i.substr(t.index + t[0].length), 
            this._command = "";
        }
    }, o.prototype._onOpen = function() {
        i.debug(a, "tcp socket opened"), this.socket.ondata = this._onData.bind(this), this.socket.onclose = this._onClose.bind(this), 
        this.socket.ondrain = this._onDrain.bind(this);
    }, o.prototype._addToServerQueue = function(e) {
        this._serverQueue.push(e), this._processingServerData || (this._processingServerData = !0, 
        this._processServerQueue());
    }, o.prototype._processServerQueue = function() {
        if (!this._serverQueue.length) return this._processingServerData = !1, void 0;
        this._clearIdle();
        var e, n = this._serverQueue.shift();
        try {
            /^\+/.test(n) ? e = {
                tag: "+",
                payload: n.substr(2) || ""
            } : (e = t.parser(n), i.debug(a, "received response: " + e.tag + " " + e.command));
        } catch (o) {
            return i.error(a, "error parsing imap response: " + o + "\n" + o.stack + "\nraw:" + n), 
            this._onError(o);
        }
        if ("*" === e.tag && /^\d+$/.test(e.command) && e.attributes && e.attributes.length && "ATOM" === e.attributes[0].type && (e.nr = Number(e.command), 
        e.command = (e.attributes.shift().value || "").toString().toUpperCase().trim()), 
        "+" === e.tag) {
            if (this._currentCommand.data.length) n = this._currentCommand.data.shift(), this.send(n + (this._currentCommand.data.length ? "" : "\r\n")); else if ("function" == typeof this._currentCommand.onplustagged) return this._currentCommand.onplustagged(e, this._processServerQueue.bind(this)), 
            void 0;
            return setTimeout(this._processServerQueue.bind(this), 0), void 0;
        }
        this._processServerResponse(e, function(t) {
            return t ? this._onError(t) : (this._connectionReady ? "*" !== e.tag && (this._canSend = !0, 
            this._sendRequest()) : (this._connectionReady = !0, this.onready(), this._canSend = !0, 
            this._sendRequest()), setTimeout(this._processServerQueue.bind(this), 0), void 0);
        }.bind(this));
    }, o.prototype._processServerResponse = function(e, t) {
        var n = (e && e.command || "").toUpperCase().trim();
        return this._processResponse(e), this._currentCommand ? this._currentCommand.payload && "*" === e.tag && n in this._currentCommand.payload ? (this._currentCommand.payload[n].push(e), 
        t()) : "*" === e.tag && n in this._globalAcceptUntagged ? (this._globalAcceptUntagged[n](e, t), 
        void 0) : e.tag === this._currentCommand.tag ? "function" == typeof this._currentCommand.callback ? (this._currentCommand.payload && Object.keys(this._currentCommand.payload).length && (e.payload = this._currentCommand.payload), 
        this._currentCommand.callback(e, t)) : t() : t() : "*" === e.tag && n in this._globalAcceptUntagged ? this._globalAcceptUntagged[n](e, t) : t();
    }, o.prototype._addToClientQueue = function(e, t, n, i) {
        var o, a = "W" + ++this._tagCounter;
        i || "function" != typeof n || (i = n, n = void 0), i || "function" != typeof t || (i = t, 
        t = void 0), t = [].concat(t || []).map(function(e) {
            return (e || "").toString().toUpperCase().trim();
        }), e.tag = a, o = {
            tag: a,
            request: e,
            payload: t.length ? {} : void 0,
            callback: i
        }, Object.keys(n || {}).forEach(function(e) {
            o[e] = n[e];
        }), t.forEach(function(e) {
            o.payload[e] = [];
        }), this._clientQueue.push(o), this._canSend && this._sendRequest();
    }, o.prototype._sendRequest = function() {
        if (!this._clientQueue.length) return this._enterIdle();
        this._clearIdle(), this._canSend = !1, this._currentCommand = this._clientQueue.shift();
        try {
            this._currentCommand.data = t.compiler(this._currentCommand.request, !0);
        } catch (e) {
            return i.error(a, "error compiling imap command: " + e + "\nstack trace: " + e.stack + "\nraw:" + this._currentCommand.request), 
            this._onError(e);
        }
        i.debug(a, "sending request: " + this._currentCommand.request.tag + " " + this._currentCommand.request.command);
        var n = this._currentCommand.data.shift();
        return this.send(n + (this._currentCommand.data.length ? "" : "\r\n")), this.waitDrain;
    }, o.prototype._enterIdle = function() {
        clearTimeout(this._idleTimer), this._idleTimer = setTimeout(function() {
            this.onidle();
        }.bind(this), this.TIMEOUT_ENTER_IDLE);
    }, o.prototype._clearIdle = function() {
        clearTimeout(this._idleTimer);
    }, o.prototype._processResponse = function(e) {
        var t, n, i = (e && e.command || "").toString().toUpperCase().trim();
        [ "OK", "NO", "BAD", "BYE", "PREAUTH" ].indexOf(i) >= 0 && ((t = e && e.attributes && e.attributes.length && "ATOM" === e.attributes[0].type && e.attributes[0].section && e.attributes[0].section.map(function(e) {
            return e ? Array.isArray(e) ? e.map(function(e) {
                return (e.value || "").toString().trim();
            }) : (e.value || "").toString().toUpperCase().trim() : void 0;
        })) && (n = t && t.shift(), e.code = n, t.length && (t = [].concat(t || []), e[n.toLowerCase()] = 1 === t.length ? t[0] : t)), 
        e && e.attributes && e.attributes.length && "TEXT" === e.attributes[e.attributes.length - 1].type && (e.humanReadable = e.attributes[e.attributes.length - 1].value));
    }, o.prototype.isError = function(e) {
        return !!Object.prototype.toString.call(e).match(/Error\]$/);
    }, o;
}), function(e, t) {
    "function" == typeof define && define.amd ? define("browserbox", [ "browserbox-imap", "utf7", "imap-handler", "mimefuncs", "axe" ], function(e, n, i, o, a) {
        return t(e, n, i, o, a);
    }) : "object" == typeof exports ? module.exports = t(require("./browserbox-imap"), require("wo-utf7"), require("wo-imap-handler"), require("mimefuncs"), require("axe-logger")) : e.BrowserBox = t(e.BrowserboxImapClient, e.utf7, e.imapHandler, e.mimefuncs, e.axe);
}(this, function(e, t, n, i, o) {
    function a(t, n, i) {
        this.options = i || {}, this.capability = [], this.serverId = !1, this.state = !1, 
        this.authenticated = !1, this.selectedMailbox = !1, this.client = new e(t, n, this.options), 
        this._enteredIdle = !1, this._idleTimeout = !1, this._init();
    }
    var r = "browserbox", s = [ "\\All", "\\Archive", "\\Drafts", "\\Flagged", "\\Junk", "\\Sent", "\\Trash" ], c = {
        "\\Sent": [ "aika", "bidaliak", "bidalita", "dihantar", "e rometsweng", "e tindami", "elküldött", "elküldöttek", "enviadas", "enviadas", "enviados", "enviats", "envoyés", "ethunyelweyo", "expediate", "ezipuru", "gesendete", "gestuur", "gönderilmiş öğeler", "göndərilənlər", "iberilen", "inviati", "išsiųstieji", "kuthunyelwe", "lasa", "lähetetyt", "messages envoyés", "naipadala", "nalefa", "napadala", "nosūtītās ziņas", "odeslané", "padala", "poslane", "poslano", "poslano", "poslané", "poslato", "saadetud", "saadetud kirjad", "sendt", "sendt", "sent", "sent items", "sent messages", "sända poster", "sänt", "terkirim", "ti fi ranṣẹ", "të dërguara", "verzonden", "vilivyotumwa", "wysłane", "đã gửi", "σταλθέντα", "жиберилген", "жіберілгендер", "изпратени", "илгээсэн", "ирсол шуд", "испратено", "надіслані", "отправленные", "пасланыя", "юборилган", "ուղարկված", "נשלחו", "פריטים שנשלחו", "المرسلة", "بھیجے گئے", "سوزمژہ", "لېګل شوی", "موارد ارسال شده", "पाठविले", "पाठविलेले", "प्रेषित", "भेजा गया", "প্রেরিত", "প্রেরিত", "প্ৰেৰিত", "ਭੇਜੇ", "મોકલેલા", "ପଠାଗଲା", "அனுப்பியவை", "పంపించబడింది", "ಕಳುಹಿಸಲಾದ", "അയച്ചു", "යැවු පණිවුඩ", "ส่งแล้ว", "გაგზავნილი", "የተላኩ", "បាន​ផ្ញើ", "寄件備份", "寄件備份", "已发信息", "送信済みﾒｰﾙ", "발신 메시지", "보낸 편지함" ],
        "\\Trash": [ "articole șterse", "bin", "borttagna objekt", "deleted", "deleted items", "deleted messages", "elementi eliminati", "elementos borrados", "elementos eliminados", "gelöschte objekte", "item dipadam", "itens apagados", "itens excluídos", "mục đã xóa", "odstraněné položky", "pesan terhapus", "poistetut", "praht", "prügikast", "silinmiş öğeler", "slettede beskeder", "slettede elementer", "trash", "törölt elemek", "usunięte wiadomości", "verwijderde items", "vymazané správy", "éléments supprimés", "видалені", "жойылғандар", "удаленные", "פריטים שנמחקו", "العناصر المحذوفة", "موارد حذف شده", "รายการที่ลบ", "已删除邮件", "已刪除項目", "已刪除項目" ],
        "\\Junk": [ "bulk mail", "correo no deseado", "courrier indésirable", "istenmeyen", "istenmeyen e-posta", "junk", "levélszemét", "nevyžiadaná pošta", "nevyžádaná pošta", "no deseado", "posta indesiderata", "pourriel", "roskaposti", "skräppost", "spam", "spam", "spamowanie", "søppelpost", "thư rác", "спам", "דואר זבל", "الرسائل العشوائية", "هرزنامه", "สแปม", "‎垃圾郵件", "垃圾邮件", "垃圾電郵" ],
        "\\Drafts": [ "ba brouillon", "borrador", "borrador", "borradores", "bozze", "brouillons", "bản thảo", "ciorne", "concepten", "draf", "drafts", "drög", "entwürfe", "esborranys", "garalamalar", "ihe edeturu", "iidrafti", "izinhlaka", "juodraščiai", "kladd", "kladder", "koncepty", "koncepty", "konsep", "konsepte", "kopie robocze", "layihələr", "luonnokset", "melnraksti", "meralo", "mesazhe të padërguara", "mga draft", "mustandid", "nacrti", "nacrti", "osnutki", "piszkozatok", "rascunhos", "rasimu", "skice", "taslaklar", "tsararrun saƙonni", "utkast", "vakiraoka", "vázlatok", "zirriborroak", "àwọn àkọpamọ́", "πρόχειρα", "жобалар", "нацрти", "нооргууд", "сиёҳнавис", "хомаки хатлар", "чарнавікі", "чернетки", "чернови", "черновики", "черновиктер", "սևագրեր", "טיוטות", "مسودات", "مسودات", "موسودې", "پیش نویسها", "ڈرافٹ/", "ड्राफ़्ट", "प्रारूप", "খসড়া", "খসড়া", "ড্ৰাফ্ট", "ਡ੍ਰਾਫਟ", "ડ્રાફ્ટસ", "ଡ୍ରାଫ୍ଟ", "வரைவுகள்", "చిత్తు ప్రతులు", "ಕರಡುಗಳು", "കരടുകള്‍", "කෙටුම් පත්", "ฉบับร่าง", "მონახაზები", "ረቂቆች", "សារព្រាង", "下書き", "草稿", "草稿", "草稿", "임시 보관함" ]
    }, l = Object.keys(c);
    return a.prototype.STATE_CONNECTING = 1, a.prototype.STATE_NOT_AUTHENTICATED = 2, 
    a.prototype.STATE_AUTHENTICATED = 3, a.prototype.STATE_SELECTED = 4, a.prototype.STATE_LOGOUT = 5, 
    a.prototype.TIMEOUT_CONNECTION = 9e4, a.prototype.TIMEOUT_NOOP = 6e4, a.prototype.TIMEOUT_IDLE = 6e4, 
    a.prototype._init = function() {
        this.client.onerror = function(e) {
            this.onerror(e);
        }.bind(this), this.client.oncert = function(e) {
            this.oncert(e);
        }.bind(this), this.client.onclose = function() {
            clearTimeout(this._connectionTimeout), clearTimeout(this._idleTimeout), this.onclose();
        }.bind(this), this.client.onready = this._onReady.bind(this), this.client.onidle = this._onIdle.bind(this), 
        this.client.setHandler("capability", this._untaggedCapabilityHandler.bind(this)), 
        this.client.setHandler("ok", this._untaggedOkHandler.bind(this)), this.client.setHandler("exists", this._untaggedExistsHandler.bind(this)), 
        this.client.setHandler("expunge", this._untaggedExpungeHandler.bind(this)), this.client.setHandler("fetch", this._untaggedFetchHandler.bind(this));
    }, a.prototype.onclose = function() {}, a.prototype.onauth = function() {}, a.prototype.onupdate = function() {}, 
    a.prototype.oncert = function() {}, a.prototype.onselectmailbox = function() {}, 
    a.prototype.onclosemailbox = function() {}, a.prototype._onClose = function() {
        o.debug(r, "connection closed. goodbye."), this.onclose();
    }, a.prototype._onTimeout = function() {
        clearTimeout(this._connectionTimeout);
        var e = new Error("Timeout creating connection to the IMAP server");
        o.error(r, e), this.onerror(e), this.client._destroy();
    }, a.prototype._onReady = function() {
        clearTimeout(this._connectionTimeout), o.debug(r, "session: connection established"), 
        this._changeState(this.STATE_NOT_AUTHENTICATED), this.updateCapability(function() {
            this.upgradeConnection(function(e) {
                return e ? (this.onerror(e), this.close(), void 0) : (this.updateId(this.options.id, function() {
                    this.login(this.options.auth, function(e) {
                        return e ? (this.onerror(e), this.close(), void 0) : (this.onauth(), void 0);
                    }.bind(this));
                }.bind(this)), void 0);
            }.bind(this));
        }.bind(this));
    }, a.prototype._onIdle = function() {
        this.authenticated && !this._enteredIdle && (o.debug(r, "client: started idling"), 
        this.enterIdle());
    }, a.prototype.connect = function() {
        o.debug(r, "connecting to " + this.client.host + ":" + this.client.port), this._changeState(this.STATE_CONNECTING), 
        clearTimeout(this._connectionTimeout), this._connectionTimeout = setTimeout(this._onTimeout.bind(this), this.TIMEOUT_CONNECTION), 
        this.client.connect();
    }, a.prototype.close = function(e) {
        o.debug(r, "closing connection"), this._changeState(this.STATE_LOGOUT), this.exec("LOGOUT", function(t) {
            "function" == typeof e && e(t || null), this.client.close();
        }.bind(this));
    }, a.prototype.exec = function() {
        var e = Array.prototype.slice.call(arguments), t = e.pop();
        "function" != typeof t && (e.push(t), t = void 0), e.push(function(e, n) {
            var i = null;
            e && e.capability && (this.capability = e.capability), [ "NO", "BAD" ].indexOf((e && e.command || "").toString().toUpperCase().trim()) >= 0 && (i = new Error(e.humanReadable || "Error"), 
            e.code && (i.code = e.code)), "function" == typeof t ? t(i, e, n) : n();
        }.bind(this)), this.breakIdle(function() {
            this.client.exec.apply(this.client, e);
        }.bind(this));
    }, a.prototype.enterIdle = function() {
        this._enteredIdle || (this._enteredIdle = this.capability.indexOf("IDLE") >= 0 ? "IDLE" : "NOOP", 
        o.debug(r, "entering idle with " + this._enteredIdle), "NOOP" === this._enteredIdle ? this._idleTimeout = setTimeout(function() {
            this.exec("NOOP");
        }.bind(this), this.TIMEOUT_NOOP) : "IDLE" === this._enteredIdle && (this.client.exec({
            command: "IDLE"
        }, function(e, t) {
            t();
        }.bind(this)), this._idleTimeout = setTimeout(function() {
            o.debug(r, "sending idle DONE"), this.client.socket.send(new Uint8Array([ 68, 79, 78, 69, 13, 10 ]).buffer), 
            this._enteredIdle = !1;
        }.bind(this), this.TIMEOUT_IDLE)));
    }, a.prototype.breakIdle = function(e) {
        return this._enteredIdle ? (clearTimeout(this._idleTimeout), "IDLE" === this._enteredIdle && (o.debug(r, "sending idle DONE"), 
        this.client.socket.send(new Uint8Array([ 68, 79, 78, 69, 13, 10 ]).buffer)), this._enteredIdle = !1, 
        o.debug(r, "idle terminated"), e()) : e();
    }, a.prototype.upgradeConnection = function(e) {
        return this.client.secureMode ? e(null, !1) : (this.capability.indexOf("STARTTLS") < 0 || this.options.ignoreTLS) && !this.options.requireTLS ? e(null, !1) : (this.exec("STARTTLS", function(t, n, i) {
            t ? (e(t), i()) : (this.capability = [], this.client.upgrade(function(t, n) {
                this.updateCapability(function() {
                    e(t, n);
                }), i();
            }.bind(this)));
        }.bind(this)), void 0);
    }, a.prototype.updateCapability = function(e, t) {
        return t || "function" != typeof e || (t = e, e = void 0), !e && this.capability.length ? t(null, !1) : !this.client.secureMode && this.options.requireTLS ? t(null, !1) : (this.exec("CAPABILITY", function(e, n, i) {
            e ? t(e) : t(null, !0), i();
        }), void 0);
    }, a.prototype.listNamespaces = function(e) {
        return this.capability.indexOf("NAMESPACE") < 0 ? e(null, !1) : (this.exec("NAMESPACE", "NAMESPACE", function(t, n, i) {
            t ? e(t) : e(null, this._parseNAMESPACE(n)), i();
        }.bind(this)), void 0);
    }, a.prototype.login = function(e, t) {
        var n, a = {};
        return e ? (this.capability.indexOf("AUTH=XOAUTH2") >= 0 && e && e.xoauth2 ? (n = {
            command: "AUTHENTICATE",
            attributes: [ {
                type: "ATOM",
                value: "XOAUTH2"
            }, {
                type: "ATOM",
                value: this._buildXOAuth2Token(e.user, e.xoauth2)
            } ]
        }, a.onplustagged = function(e, t) {
            var n;
            if (e && e.payload) try {
                n = JSON.parse(i.base64Decode(e.payload));
            } catch (a) {
                o.error(r, "error parsing XOAUTH2 payload: " + a + "\nstack trace: " + a.stack);
            }
            this.client.send("\r\n"), t();
        }.bind(this)) : n = {
            command: "login",
            attributes: [ {
                type: "STRING",
                value: e.user || ""
            }, {
                type: "STRING",
                value: e.pass || ""
            } ]
        }, this.exec(n, "capability", a, function(e, n, i) {
            var a = !1;
            return e ? (t(e), i()) : (this._changeState(this.STATE_AUTHENTICATED), this.authenticated = !0, 
            n.capability && n.capability.length ? (this.capability = [].concat(n.capability || []), 
            a = !0, o.debug(r, "post-auth capabilites updated: " + this.capability), t(null, !0)) : n.payload && n.payload.CAPABILITY && n.payload.CAPABILITY.length ? (this.capability = [].concat(n.payload.CAPABILITY.pop().attributes || []).map(function(e) {
                return (e.value || "").toString().toUpperCase().trim();
            }), a = !0, o.debug(r, "post-auth capabilites updated: " + this.capability), t(null, !0)) : this.updateCapability(!0, function(e) {
                e ? t(e) : (o.debug(r, "post-auth capabilites updated: " + this.capability), t(null, !0));
            }.bind(this)), i(), void 0);
        }.bind(this)), void 0) : t(new Error("Authentication information not provided"));
    }, a.prototype.updateId = function(e, t) {
        if (this.capability.indexOf("ID") < 0) return t(null, !1);
        var n = [ [] ];
        e ? ("string" == typeof e && (e = {
            name: e
        }), Object.keys(e).forEach(function(t) {
            n[0].push(t), n[0].push(e[t]);
        })) : n[0] = null, this.exec({
            command: "ID",
            attributes: n
        }, "ID", function(e, n, i) {
            if (e) return o.error(r, "error updating server id: " + e + "\n" + e.stack), t(e), 
            i();
            if (!n.payload || !n.payload.ID || !n.payload.ID.length) return t(null, !1), i();
            this.serverId = {};
            var a;
            [].concat([].concat(n.payload.ID.shift().attributes || []).shift() || []).forEach(function(e, t) {
                0 === t % 2 ? a = (e && e.value || "").toString().toLowerCase().trim() : this.serverId[a] = (e && e.value || "").toString();
            }.bind(this)), t(null, this.serverId), i();
        }.bind(this));
    }, a.prototype.listMailboxes = function(e) {
        this.exec({
            command: "LIST",
            attributes: [ "", "*" ]
        }, "LIST", function(t, n, i) {
            if (t) return e(t), i();
            var a = {
                root: !0,
                children: []
            };
            return n.payload && n.payload.LIST && n.payload.LIST.length ? (n.payload.LIST.forEach(function(e) {
                if (e && e.attributes && !(e.attributes.length < 3)) {
                    var t = this._ensurePath(a, (e.attributes[2].value || "").toString(), (e.attributes[1] ? e.attributes[1].value : "/").toString());
                    t.flags = [].concat(e.attributes[0] || []).map(function(e) {
                        return (e.value || "").toString();
                    }), t.listed = !0, this._checkSpecialUse(t);
                }
            }.bind(this)), this.exec({
                command: "LSUB",
                attributes: [ "", "*" ]
            }, "LSUB", function(t, n, i) {
                return t ? (o.error(r, "error while listing subscribed mailboxes: " + t + "\n" + t.stack), 
                e(null, a), i()) : n.payload && n.payload.LSUB && n.payload.LSUB.length ? (n.payload.LSUB.forEach(function(e) {
                    if (e && e.attributes && !(e.attributes.length < 3)) {
                        var t = this._ensurePath(a, (e.attributes[2].value || "").toString(), (e.attributes[1] ? e.attributes[1].value : "/").toString());
                        [].concat(e.attributes[0] || []).map(function(e) {
                            e = (e.value || "").toString(), (!t.flags || t.flags.indexOf(e) < 0) && (t.flags = [].concat(t.flags || []).concat(e));
                        }), t.subscribed = !0;
                    }
                }.bind(this)), e(null, a), i(), void 0) : (e(null, a), i());
            }.bind(this)), i(), void 0) : (e(null, !1), i());
        }.bind(this));
    }, a.prototype.createMailbox = function(e, n) {
        this.exec({
            command: "CREATE",
            attributes: [ t.imap.encode(e) ]
        }, function(e, t, i) {
            e && "ALREADYEXISTS" === e.code ? n(null, !0) : n(e, !1), i();
        });
    }, a.prototype.listMessages = function(e, t, n, i) {
        i || "function" != typeof n || (i = n, n = void 0), i || "function" != typeof t || (i = t, 
        t = void 0), t = t || {
            fast: !0
        }, n = n || {};
        var o = this._buildFETCHCommand(e, t, n);
        this.exec(o, "FETCH", function(e, t, n) {
            e ? i(e) : i(null, this._parseFETCH(t)), n();
        }.bind(this));
    }, a.prototype.search = function(e, t, n) {
        n || "function" != typeof t || (n = t, t = void 0), t = t || {};
        var i = this._buildSEARCHCommand(e, t);
        this.exec(i, "SEARCH", function(e, t, i) {
            e ? n(e) : n(null, this._parseSEARCH(t)), i();
        }.bind(this));
    }, a.prototype.setFlags = function(e, t, n, i) {
        i || "function" != typeof n || (i = n, n = void 0), n = n || {};
        var o = this._buildSTORECommand(e, t, n);
        this.exec(o, "FETCH", function(e, t, n) {
            e ? i(e) : i(null, this._parseFETCH(t)), n();
        }.bind(this));
    }, a.prototype.upload = function(e, t, n, i) {
        i || "function" != typeof n || (i = n, n = void 0), n = n || {}, n.flags = n.flags || [ "\\Seen" ];
        var o = n.flags.map(function(e) {
            return {
                type: "atom",
                value: e
            };
        }), a = {
            command: "APPEND"
        };
        a.attributes = [ {
            type: "atom",
            value: e
        }, o, {
            type: "literal",
            value: t
        } ], this.exec(a, function(e, t, n) {
            i(e, e ? void 0 : !0), n();
        }.bind(this));
    }, a.prototype.deleteMessages = function(e, t, n) {
        n || "function" != typeof t || (n = t, t = void 0), t = t || {}, this.setFlags(e, {
            add: "\\Deleted"
        }, t, function(i) {
            return i ? n(i) : (this.exec(t.byUid && this.capability.indexOf("UIDPLUS") >= 0 ? {
                command: "UID EXPUNGE",
                attributes: [ {
                    type: "sequence",
                    value: e
                } ]
            } : "EXPUNGE", function(e, t, i) {
                e ? n(e) : n(null, !0), i();
            }.bind(this)), void 0);
        }.bind(this));
    }, a.prototype.copyMessages = function(e, t, n, i) {
        i || "function" != typeof n || (i = n, n = void 0), n = n || {}, this.exec({
            command: n.byUid ? "UID COPY" : "COPY",
            attributes: [ {
                type: "sequence",
                value: e
            }, {
                type: "atom",
                value: t
            } ]
        }, function(e, t, n) {
            e ? i(e) : i(null, t.humanReadable || "COPY completed"), n();
        }.bind(this));
    }, a.prototype.moveMessages = function(e, t, n, i) {
        i || "function" != typeof n || (i = n, n = void 0), n = n || {}, this.capability.indexOf("MOVE") >= 0 ? this.exec({
            command: n.byUid ? "UID MOVE" : "MOVE",
            attributes: [ {
                type: "sequence",
                value: e
            }, {
                type: "atom",
                value: t
            } ]
        }, [ "OK" ], function(e, t, n) {
            e ? i(e) : i(null, !0), n();
        }.bind(this)) : this.copyMessages(e, t, n, function(t) {
            return t ? i(t) : (this.deleteMessages(e, n, i), void 0);
        }.bind(this));
    }, a.prototype.selectMailbox = function(e, t, n) {
        n || "function" != typeof t || (n = t, t = void 0), t = t || {};
        var i = {
            command: t.readOnly ? "EXAMINE" : "SELECT",
            attributes: [ {
                type: "STRING",
                value: e
            } ]
        };
        t.condstore && this.capability.indexOf("CONDSTORE") >= 0 && i.attributes.push([ {
            type: "ATOM",
            value: "CONDSTORE"
        } ]), this.exec(i, [ "EXISTS", "FLAGS", "OK" ], function(t, i, o) {
            if (t) return n(t), o();
            this._changeState(this.STATE_SELECTED), this.selectedMailbox && this.selectedMailbox !== e && this.onclosemailbox(this.selectedMailbox), 
            this.selectedMailbox = e;
            var a = this._parseSELECT(i);
            n(null, a), this.onselectmailbox(e, a), o();
        }.bind(this));
    }, a.prototype.hasCapability = function(e) {
        return this.capability.indexOf((e || "").toString().toUpperCase().trim()) >= 0;
    }, a.prototype._untaggedOkHandler = function(e, t) {
        e && e.capability && (this.capability = e.capability), t();
    }, a.prototype._untaggedCapabilityHandler = function(e, t) {
        this.capability = [].concat(e && e.attributes || []).map(function(e) {
            return (e.value || "").toString().toUpperCase().trim();
        }), t();
    }, a.prototype._untaggedExistsHandler = function(e, t) {
        e && e.hasOwnProperty("nr") && this.onupdate("exists", e.nr), t();
    }, a.prototype._untaggedExpungeHandler = function(e, t) {
        e && e.hasOwnProperty("nr") && this.onupdate("expunge", e.nr), t();
    }, a.prototype._untaggedFetchHandler = function(e, t) {
        this.onupdate("fetch", [].concat(this._parseFETCH({
            payload: {
                FETCH: [ e ]
            }
        }) || []).shift()), t();
    }, a.prototype._parseSELECT = function(e) {
        if (e && e.payload) {
            var t = {
                readOnly: "READ-ONLY" === e.code
            }, n = e.payload.EXISTS && e.payload.EXISTS.pop(), i = e.payload.FLAGS && e.payload.FLAGS.pop(), o = e.payload.OK;
            return n && (t.exists = n.nr || 0), i && i.attributes && i.attributes.length && (t.flags = i.attributes[0].map(function(e) {
                return (e.value || "").toString().trim();
            })), [].concat(o || []).forEach(function(e) {
                switch (e && e.code) {
                  case "PERMANENTFLAGS":
                    t.permanentFlags = [].concat(e.permanentflags || []);
                    break;

                  case "UIDVALIDITY":
                    t.uidValidity = Number(e.uidvalidity) || 0;
                    break;

                  case "UIDNEXT":
                    t.uidNext = Number(e.uidnext) || 0;
                    break;

                  case "HIGHESTMODSEQ":
                    t.highestModseq = e.highestmodseq || "0";
                }
            }), t;
        }
    }, a.prototype._parseNAMESPACE = function(e) {
        var t, n = !1, i = function(e) {
            return e ? [].concat(e || []).map(function(e) {
                return e && e.length ? {
                    prefix: e[0].value,
                    delimiter: e[1] && e[1].value
                } : !1;
            }) : !1;
        };
        return e.payload && e.payload.NAMESPACE && e.payload.NAMESPACE.length && (t = [].concat(e.payload.NAMESPACE.pop().attributes || [])).length && (n = {
            personal: i(t[0]),
            users: i(t[1]),
            shared: i(t[2])
        }), n;
    }, a.prototype._buildFETCHCommand = function(e, t, i) {
        var o = {
            command: i.byUid ? "UID FETCH" : "FETCH",
            attributes: [ {
                type: "SEQUENCE",
                value: e
            } ]
        }, a = [];
        return [].concat(t || []).forEach(function(e) {
            var t;
            if (e = (e || "").toString().toUpperCase().trim(), /^\w+$/.test(e)) a.push({
                type: "ATOM",
                value: e
            }); else if (e) try {
                t = n.parser("* Z " + e), a = a.concat(t.attributes || []);
            } catch (i) {
                a.push({
                    type: "ATOM",
                    value: e
                });
            }
        }), 1 === a.length && (a = a.pop()), o.attributes.push(a), i.changedSince && o.attributes.push([ {
            type: "ATOM",
            value: "CHANGEDSINCE"
        }, {
            type: "ATOM",
            value: i.changedSince
        } ]), o;
    }, a.prototype._parseFETCH = function(e) {
        var t;
        return e && e.payload && e.payload.FETCH && e.payload.FETCH.length ? t = [].concat(e.payload.FETCH || []).map(function(e) {
            var t, i, o, a = [].concat([].concat(e.attributes || [])[0] || []), r = {
                "#": e.nr
            };
            for (t = 0, i = a.length; i > t; t++) 0 !== t % 2 ? r[o] = this._parseFetchValue(o, a[t]) : o = n.compiler({
                attributes: [ a[t] ]
            }).toLowerCase().replace(/<\d+>$/, "");
            return r;
        }.bind(this)) : [];
    }, a.prototype._parseFetchValue = function(e, t) {
        if (!t) return null;
        if (!Array.isArray(t)) {
            switch (e) {
              case "uid":
              case "rfc822.size":
                return Number(t.value) || 0;

              case "modseq":
                return t.value || "0";
            }
            return t.value;
        }
        switch (e) {
          case "flags":
            t = [].concat(t).map(function(e) {
                return e.value || "";
            });
            break;

          case "envelope":
            t = this._parseENVELOPE([].concat(t || []));
            break;

          case "bodystructure":
            t = this._parseBODYSTRUCTURE([].concat(t || []));
            break;

          case "modseq":
            t = (t.shift() || {}).value || "0";
        }
        return t;
    }, a.prototype._parseENVELOPE = function(e) {
        var t = function(e) {
            return [].concat(e || []).map(function(e) {
                return {
                    name: i.mimeWordsDecode(e[0] && e[0].value || ""),
                    address: (e[2] && e[2].value || "") + "@" + (e[3] && e[3].value || "")
                };
            });
        }, n = {};
        return e[0] && e[0].value && (n.date = e[0].value), e[1] && e[1].value && (n.subject = i.mimeWordsDecode(e[1] && e[1].value)), 
        e[2] && e[2].length && (n.from = t(e[2])), e[3] && e[3].length && (n.sender = t(e[3])), 
        e[4] && e[4].length && (n["reply-to"] = t(e[4])), e[5] && e[5].length && (n.to = t(e[5])), 
        e[6] && e[6].length && (n.cc = t(e[6])), e[7] && e[7].length && (n.bcc = t(e[7])), 
        e[8] && e[8].value && (n["in-reply-to"] = e[8].value), e[9] && e[9].value && (n["message-id"] = e[9].value), 
        n;
    }, a.prototype._parseBODYSTRUCTURE = function(e) {
        var t = this, n = function(e, o) {
            o = o || [];
            var a, r = {}, s = 0, c = 0;
            if (o.length && (r.part = o.join(".")), Array.isArray(e[0])) {
                for (r.childNodes = []; Array.isArray(e[s]); ) r.childNodes.push(n(e[s], o.concat(++c))), 
                s++;
                r.type = "multipart/" + ((e[s++] || {}).value || "").toString().toLowerCase(), s < e.length - 1 && (e[s] && (r.parameters = {}, 
                [].concat(e[s] || []).forEach(function(e, t) {
                    t % 2 ? r.parameters[a] = i.mimeWordsDecode((e && e.value || "").toString()) : a = (e && e.value || "").toString().toLowerCase();
                })), s++);
            } else r.type = [ ((e[s++] || {}).value || "").toString().toLowerCase(), ((e[s++] || {}).value || "").toString().toLowerCase() ].join("/"), 
            e[s] && (r.parameters = {}, [].concat(e[s] || []).forEach(function(e, t) {
                t % 2 ? r.parameters[a] = i.mimeWordsDecode((e && e.value || "").toString()) : a = (e && e.value || "").toString().toLowerCase();
            })), s++, e[s] && (r.id = ((e[s] || {}).value || "").toString()), s++, e[s] && (r.description = ((e[s] || {}).value || "").toString()), 
            s++, e[s] && (r.encoding = ((e[s] || {}).value || "").toString().toLowerCase()), 
            s++, e[s] && (r.size = Number((e[s] || {}).value || 0) || 0), s++, "message/rfc822" === r.type ? (e[s] && (r.envelope = t._parseENVELOPE([].concat(e[s] || []))), 
            s++, e[s] && (r.childNodes = [ n(e[s], o) ]), s++, e[s] && (r.lineCount = Number((e[s] || {}).value || 0) || 0), 
            s++) : /^text\//.test(r.type) && (e[s] && (r.lineCount = Number((e[s] || {}).value || 0) || 0), 
            s++), s < e.length - 1 && (e[s] && (r.md5 = ((e[s] || {}).value || "").toString().toLowerCase()), 
            s++);
            return s < e.length - 1 && (Array.isArray(e[s]) && e[s].length && (r.disposition = ((e[s][0] || {}).value || "").toString().toLowerCase(), 
            Array.isArray(e[s][1]) && (r.dispositionParameters = {}, [].concat(e[s][1] || []).forEach(function(e, t) {
                t % 2 ? r.dispositionParameters[a] = i.mimeWordsDecode((e && e.value || "").toString()) : a = (e && e.value || "").toString().toLowerCase();
            }))), s++), s < e.length - 1 && (e[s] && (r.language = [].concat(e[s] || []).map(function(e) {
                return (e && e.value || "").toString().toLowerCase();
            })), s++), s < e.length - 1 && (e[s] && (r.location = ((e[s] || {}).value || "").toString()), 
            s++), r;
        };
        return n(e);
    }, a.prototype._buildSEARCHCommand = function(e, t) {
        var n = {
            command: t.byUid ? "UID SEARCH" : "SEARCH"
        }, o = !0, a = function(e) {
            var t = [];
            return Object.keys(e).forEach(function(n) {
                var r = [], s = function(e) {
                    return e.toUTCString().replace(/^\w+, 0?(\d+) (\w+) (\d+).*/, "$1-$2-$3");
                }, c = function(e) {
                    return "number" == typeof e ? {
                        type: "number",
                        value: e
                    } : "string" == typeof e ? /[\u0080-\uFFFF]/.test(e) ? (o = !1, {
                        type: "literal",
                        value: i.fromTypedArray(i.charset.encode(e))
                    }) : {
                        type: "string",
                        value: e
                    } : "[object Date]" === Object.prototype.toString.call(e) ? {
                        type: "atom",
                        value: s(e)
                    } : Array.isArray(e) ? e.map(c) : "object" == typeof e ? a(e) : void 0;
                };
                r.push({
                    type: "atom",
                    value: n.toUpperCase()
                }), [].concat(e[n] || []).forEach(function(e) {
                    switch (n.toLowerCase()) {
                      case "uid":
                        e = {
                            type: "sequence",
                            value: e
                        };
                        break;

                      default:
                        e = c(e);
                    }
                    e && (r = r.concat(e || []));
                }), t = t.concat(r || []);
            }), t;
        };
        return n.attributes = [].concat(a(e || {}) || []), o || (n.attributes.unshift({
            type: "atom",
            value: "UTF-8"
        }), n.attributes.unshift({
            type: "atom",
            value: "CHARSET"
        })), n;
    }, a.prototype._parseSEARCH = function(e) {
        var t = [];
        return e && e.payload && e.payload.SEARCH && e.payload.SEARCH.length ? ([].concat(e.payload.SEARCH || []).forEach(function(e) {
            [].concat(e.attributes || []).forEach(function(e) {
                e = Number(e && e.value || e || 0) || 0, t.indexOf(e) < 0 && t.push(e);
            });
        }.bind(this)), t.sort(function(e, t) {
            return e - t;
        }), t) : [];
    }, a.prototype._buildSTORECommand = function(e, t, n) {
        var i = {
            command: n.byUid ? "UID STORE" : "STORE",
            attributes: [ {
                type: "sequence",
                value: e
            } ]
        }, o = "", a = [];
        return (Array.isArray(t) || "object" != typeof t) && (t = {
            set: t
        }), t.add ? (a = [].concat(t.add || []), o = "+") : t.set ? (o = "", a = [].concat(t.set || [])) : t.remove && (o = "-", 
        a = [].concat(t.remove || [])), i.attributes.push({
            type: "atom",
            value: o + "FLAGS" + (n.silent ? ".SILENT" : "")
        }), i.attributes.push(a.map(function(e) {
            return {
                type: "atom",
                value: e
            };
        })), i;
    }, a.prototype._changeState = function(e) {
        e !== this.state && (o.debug(r, "entering state: " + this.state), this.state === this.STATE_SELECTED && this.selectedMailbox && (this.onclosemailbox(this.selectedMailbox), 
        this.selectedMailbox = !1), this.state = e);
    }, a.prototype._ensurePath = function(e, n, i) {
        var o, a, r, s = n.split(i), c = e;
        for (o = 0; o < s.length; o++) {
            for (r = !1, a = 0; a < c.children.length; a++) if (this._compareMailboxNames(c.children[a].name, t.imap.decode(s[o]))) {
                c = c.children[a], r = !0;
                break;
            }
            r || (c.children.push({
                name: t.imap.decode(s[o]),
                delimiter: i,
                path: s.slice(0, o + 1).join(i),
                children: []
            }), c = c.children[c.children.length - 1]);
        }
        return c;
    }, a.prototype._compareMailboxNames = function(e, t) {
        return ("INBOX" === e.toUpperCase() ? "INBOX" : e) === ("INBOX" === t.toUpperCase() ? "INBOX" : t);
    }, a.prototype._checkSpecialUse = function(e) {
        var t, n;
        if (e.flags) for (t = 0; t < s.length; t++) if (n = s[t], (e.flags || []).indexOf(n) >= 0) return e.specialUse = n, 
        n;
        return this._checkSpecialUseByName(e);
    }, a.prototype._checkSpecialUseByName = function(e) {
        var t, n, i = (e.name || "").toLowerCase().trim();
        for (t = 0; t < l.length; t++) if (n = l[t], c[n].indexOf(i) >= 0) return e.flags = [].concat(e.flags || []).concat(n), 
        e.specialUse = n, n;
        return !1;
    }, a.prototype._buildXOAuth2Token = function(e, t) {
        var n = [ "user=" + (e || ""), "auth=Bearer " + t, "", "" ];
        return i.base64.encode(n.join(""));
    }, a;
}), define("oauth", [ "require", "exports", "module", "./errorutils", "./syncbase", "./slog", "./date" ], function(e, t) {
    function n(e) {
        return a.log("oauth:renewing-access-token"), new Promise(function(t, n) {
            e._transientLastRenew = r.PERFNOW();
            var s = a.interceptable("oauth:renew-xhr", function() {
                return new XMLHttpRequest({
                    mozSystem: !0
                });
            });
            s.open("POST", e.tokenEndpoint, !0), s.setRequestHeader("Content-Type", "application/x-www-form-urlencoded"), 
            s.timeout = o.CONNECT_TIMEOUT_MS, s.send([ "client_id=", encodeURIComponent(e.clientId), "&client_secret=", encodeURIComponent(e.clientSecret), "&refresh_token=", encodeURIComponent(e.refreshToken), "&grant_type=refresh_token" ].join("")), 
            s.onload = function() {
                if (s.status < 200 || s.status >= 300) {
                    try {
                        var i = JSON.parse(s.responseText);
                    } catch (o) {}
                    a.error("oauth:xhr-fail", {
                        tokenEndpoint: e.tokenEndpoint,
                        status: s.status,
                        errResp: i
                    }), n("needs-oauth-reauth");
                } else try {
                    var l = JSON.parse(s.responseText);
                    if (l && l.access_token) {
                        a.log("oauth:got-access-token", {
                            _accessToken: l.access_token
                        });
                        var d = 1e3 * l.expires_in, p = r.NOW() + Math.max(0, d - c);
                        t({
                            accessToken: l.access_token,
                            expireTimeMS: p
                        });
                    } else a.error("oauth:no-access-token", {
                        data: s.responseText
                    }), n("needs-oauth-reauth");
                } catch (u) {
                    a.error("oauth:bad-json", {
                        error: u,
                        data: s.responseText
                    }), n("needs-oauth-reauth");
                }
            }, s.onerror = function(e) {
                n(i.analyzeException(e));
            }, s.ontimeout = function() {
                n("unresponsive-server");
            };
        });
    }
    var i = e("./errorutils"), o = e("./syncbase"), a = e("./slog"), r = e("./date"), s = 18e5, c = 3e4;
    t.isRenewPossible = function(e) {
        var t = e.oauth2, n = t && (t._transientLastRenew || 0), i = r.PERFNOW();
        return t ? !t || n && s > i - n ? !1 : !0 : !1;
    }, t.ensureUpdatedCredentials = function(e, t, i) {
        i && console.log("ensureUpdatedCredentials: force renewing token");
        var o = e.oauth2;
        return o && (!o.accessToken || o.expireTimeMS < r.NOW()) || i ? n(o).then(function(n) {
            o.accessToken = n.accessToken, o.expireTimeMS = n.expireTimeMS, a.log("oauth:credentials-changed", {
                _accessToken: o.accessToken,
                expireTimeMS: o.expireTimeMS
            }), t && t(e);
        }) : (a.log("oauth:credentials-ok"), Promise.resolve(!1));
    };
}), define("imap/client", [ "require", "exports", "module", "browserbox", "browserbox-imap", "imap-handler", "slog", "../syncbase", "../errorutils", "../oauth" ], function(e, t) {
    function n() {}
    function i(e, t) {
        if (!e || !e.response) return null;
        if (e.command && e.command.request && "STARTTLS" === e.command.request.command) return "bad-security";
        var n = t && !!t.options.auth.xoauth2, i = e.response, o = (i.code || "") + (i.humanReadable || "");
        return /Your account is not enabled for IMAP use/.test(o) || /IMAP access is disabled for your domain/.test(o) ? "imap-disabled" : /UNAVAILABLE/.test(o) ? "server-maintenance" : -1 == t.capability.indexOf("LOGINDISABLED") || t.authenticated ? /AUTHENTICATIONFAILED/.test(o) || /Invalid credentials/i.test(o) || /login failed/i.test(o) || /password/.test(o) || !t.authenticated ? n ? "needs-oauth-reauth" : "bad-user-or-pass" : null : "server-maintenance";
    }
    var o = e("browserbox"), a = e("browserbox-imap"), r = e("imap-handler"), s = e("slog"), c = e("../syncbase"), l = e("../errorutils"), d = e("../oauth"), p = window.setTimeout, u = window.clearTimeout;
    t.setTimeoutFunctions = function(e, t) {
        p = e, u = t;
    }, t.createImapConnection = function(e, i, a) {
        var r;
        return d.ensureUpdatedCredentials(e, a).then(function() {
            return new Promise(function(t, a) {
                r = new o(i.hostname, i.port, {
                    auth: {
                        user: e.username,
                        pass: e.password,
                        xoauth2: e.oauth2 ? e.oauth2.accessToken : null
                    },
                    id: {
                        vendor: "Mozilla",
                        name: "GaiaMail",
                        version: "0.2",
                        "support-url": "http://mzl.la/file-gaia-email-bug"
                    },
                    useSecureTransport: "ssl" === i.crypto || i.crypto === !0,
                    requireTLS: "starttls" === i.crypto,
                    ignoreTLS: "plain" === i.crypto
                });
                var l = p(function() {
                    r.onerror("unresponsive-server"), r.close();
                }, c.CONNECT_TIMEOUT_MS);
                r.onauth = function() {
                    u(l), s.info("imap:connected", i), r.onauth = r.onerror = n, t(r);
                }, r.onerror = function(e) {
                    u(l), a(e);
                }, r.connect();
            });
        }).catch(function(n) {
            var o = f(r, n);
            if (r && r.close(), "needs-oauth-reauth" === o && d.isRenewPossible(e)) return d.ensureUpdatedCredentials(e, a, !0).then(function() {
                return t.createImapConnection(e, i, a);
            });
            throw s.error("imap:connect-error", {
                error: o
            }), o;
        });
    };
    var h = a.prototype._processResponse;
    a.prototype._processResponse = function(e) {
        h.apply(this, arguments);
        var t = (e && e.command || "").toString().toUpperCase().trim();
        -1 !== [ "NO", "BAD" ].indexOf(t) && (s.log("imap:protocol-error", {
            humanReadable: e.humanReadable,
            responseCode: e.code,
            commandData: this._currentCommand && this._currentCommand.request && r.compiler(this._currentCommand.request)
        }), this._lastImapError = {
            command: this._currentCommand,
            response: e
        });
    }, a.prototype._onError = function(e) {
        this.isError(e) ? this.onerror(e) : e && this.isError(e.data) ? this.onerror(e.data) : this.onerror(e && e.data && e.data.message || e.data || e || "Error"), 
        this.close();
    };
    var f = t.normalizeImapError = function(e, t) {
        var n = l.analyzeException(t), o = e && i(e.client._lastImapError, e), a = n || o || "unknown";
        return s.error("imap:normalized-error", {
            error: t,
            errorName: t && t.name,
            errorMessage: t && t.message,
            errorStack: t && t.stack,
            socketLevelError: n,
            protocolLevelError: o,
            reportAs: a
        }), a;
    };
}), define("imap/account", [ "rdcommon/log", "slog", "../a64", "../accountmixins", "../allback", "../errbackoff", "../mailslice", "../searchfilter", "../syncbase", "../util", "../composite/incoming", "./folder", "./jobs", "./client", "../errorutils", "../disaster-recovery", "module", "require", "exports" ], function(e, t, n, i, o, a, r, s, c, l, d, p, u, h, f, m, g, v, _) {
    function y(e, t, n, i, o, r, s, c, l) {
        this._LOG = w.ImapAccount(this, c, n), b.apply(this, [ p.ImapFolderSyncer ].concat(Array.slice(arguments))), 
        this._maxConnsAllowed = 3, this._pendingConn = null, this._ownedConns = [], this._demandedConns = [], 
        this._backoffEndpoint = a.createEndpoint("imap:" + this.id, this, this._LOG), l && this._reuseConnection(l), 
        this.tzOffset = t.accountDef.tzOffset, this._jobDriver = new u.ImapJobDriver(this, this._folderInfos.$mutationState, this._LOG), 
        this._TEST_doNotCloseFolder = !1, this.ensureEssentialOfflineFolders();
    }
    l.bsearchForInsert, o.allbackMaker;
    var b = d.CompositeIncomingAccount;
    _.Account = _.ImapAccount = y, y.prototype = Object.create(b.prototype);
    var x = {
        type: "imap",
        supportsServerFolders: !0,
        toString: function() {
            return "[ImapAccount: " + this.id + "]";
        },
        get isGmail() {
            return -1 !== this.meta.capability.indexOf("X-GM-EXT-1");
        },
        get isCoreMailServer() {
            return -1 !== this.meta.capability.indexOf("X-CM-EXT-1");
        },
        get sentMessagesAutomaticallyAppearInSentFolder() {
            return this.isGmail || this.isCoreMailServer;
        },
        get numActiveConns() {
            return this._ownedConns.length;
        },
        __folderDemandsConnection: function(e, t, n, i, o) {
            if (o && !this.universe.online) return window.setZeroTimeout(i), void 0;
            var a = {
                folderId: e,
                label: t,
                callback: n,
                deathback: i,
                dieOnConnectFailure: Boolean(o)
            };
            this._demandedConns.push(a), this._demandedConns.length > 1 || this._allocateExistingConnection() || this._makeConnectionIfPossible();
        },
        _killDieOnConnectFailureDemands: function() {
            for (var e = 0; e < this._demandedConns.length; e++) {
                var t = this._demandedConns[e];
                t.dieOnConnectFailure && (t.deathback.call(null), this._demandedConns.splice(e--, 1));
            }
        },
        _allocateExistingConnection: function() {
            if (!this._demandedConns.length) return !1;
            for (var e = this._demandedConns[0], t = 0; t < this._ownedConns.length; t++) {
                var n = this._ownedConns[t];
                if (e.folderId && n.folderId === e.folderId && this._LOG.folderAlreadyHasConn(e.folderId), 
                !n.inUseBy) return n.inUseBy = e, this._demandedConns.shift(), this._LOG.reuseConnection(e.folderId, e.label), 
                e.callback(n.conn), !0;
            }
            return !1;
        },
        allOperationsCompleted: function() {
            this.maybeCloseUnusedConnections();
        },
        maybeCloseUnusedConnections: function() {
            !c.KILL_CONNECTIONS_WHEN_JOBLESS || this._demandedConns.length || this.universe.areServerJobsWaiting(this) || this.closeUnusedConnections();
        },
        closeUnusedConnections: function() {
            for (var e = this._ownedConns.length - 1; e >= 0; e--) {
                var t = this._ownedConns[e];
                t.inUseBy || (console.log("Killing unused IMAP connection."), this._ownedConns.splice(e, 1), 
                t.conn.client.close(), this._LOG.deadConnection("unused", null));
            }
        },
        _makeConnectionIfPossible: function() {
            if (this._ownedConns.length >= this._maxConnsAllowed) return this._LOG.maximumConnsNoNew(), 
            void 0;
            if (!this._pendingConn) {
                this._pendingConn = !0;
                var e = this._makeConnection.bind(this);
                this._backoffEndpoint.scheduleConnectAttempt(e);
            }
        },
        _makeConnection: function(e, t, n) {
            this._pendingConn = !0, v([ "./client" ], function(i) {
                this._LOG.createConnection(t, n), i.createImapConnection(this._credentials, this._connInfo, function() {
                    return new Promise(function(e) {
                        this.universe.saveAccountDef(this.compositeAccount.accountDef, null, e);
                    }.bind(this));
                }.bind(this)).then(function(t) {
                    m.associateSocketWithAccount(t.client.socket, this), this._pendingConn = null, this._bindConnectionDeathHandlers(t), 
                    this._backoffEndpoint.noteConnectSuccess(), this._ownedConns.push({
                        conn: t,
                        inUseBy: null
                    }), this._allocateExistingConnection(), this._demandedConns.length && this._makeConnectionIfPossible(), 
                    e && e(null);
                }.bind(this)).catch(function(n) {
                    this._LOG.deadConnection("connect-error", t), f.shouldReportProblem(n) && this.universe.__reportAccountProblem(this.compositeAccount, n, "incoming"), 
                    this._pendingConn = null, e && e(n), f.shouldRetry(n) ? this._backoffEndpoint.noteConnectFailureMaybeRetry(f.wasErrorFromReachableState(n)) ? this._makeConnectionIfPossible() : this._killDieOnConnectFailureDemands() : (this._backoffEndpoint.noteBrokenConnection(), 
                    this._killDieOnConnectFailureDemands());
                }.bind(this));
            }.bind(this));
        },
        _reuseConnection: function(e) {
            m.associateSocketWithAccount(e.client.socket, this), this._ownedConns.push({
                conn: e,
                inUseBy: null
            }), this._bindConnectionDeathHandlers(e);
        },
        _bindConnectionDeathHandlers: function(e) {
            e.breakIdle(function() {
                e.client.TIMEOUT_ENTER_IDLE = c.STALE_CONNECTION_TIMEOUT_MS, e.client.onidle = function() {
                    console.warn("Killing stale IMAP connection."), e.client.close();
                }, e.client._enterIdle();
            }), e.onclose = function() {
                for (var t = 0; t < this._ownedConns.length; t++) {
                    var n = this._ownedConns[t];
                    if (n.conn === e) return this._LOG.deadConnection("closed", n.inUseBy && n.inUseBy.folderId), 
                    n.inUseBy && n.inUseBy.deathback && n.inUseBy.deathback(e), n.inUseBy = null, this._ownedConns.splice(t, 1), 
                    void 0;
                }
            }.bind(this), e.onerror = function(t) {
                t = h.normalizeImapError(e, t), this._LOG.connectionError(t), console.error("imap:onerror", JSON.stringify({
                    error: t,
                    host: this._connInfo.hostname,
                    port: this._connInfo.port
                }));
            }.bind(this);
        },
        __folderDoneWithConnection: function(e, t, n) {
            for (var i = 0; i < this._ownedConns.length; i++) {
                var o = this._ownedConns[i];
                if (o.conn === e) return n && this._backoffEndpoint(o.inUseBy.folderId), this._LOG.releaseConnection(o.inUseBy.folderId, o.inUseBy.label), 
                o.inUseBy = null, this.maybeCloseUnusedConnections(), void 0;
            }
            this._LOG.connectionMismatch();
        },
        _syncFolderList: function(e, t) {
            e.listMailboxes(this._syncFolderComputeDeltas.bind(this, e, t));
        },
        _determineFolderType: function(e, t) {
            var n = (e.flags || []).map(function(e) {
                return e.substr(1).toUpperCase();
            }), i = null;
            if (-1 !== n.indexOf("NOSELECT")) i = "nomail"; else {
                for (var o = 0; o < n.length; o++) switch (n[o]) {
                  case "ALL":
                  case "ALLMAIL":
                  case "ARCHIVE":
                    i = "archive";
                    break;

                  case "DRAFTS":
                    i = "drafts";
                    break;

                  case "FLAGGED":
                    i = "starred";
                    break;

                  case "IMPORTANT":
                    i = "important";
                    break;

                  case "INBOX":
                    i = "inbox";
                    break;

                  case "JUNK":
                    i = "junk";
                    break;

                  case "SENT":
                    i = "sent";
                    break;

                  case "SPAM":
                    i = "junk";
                    break;

                  case "STARRED":
                    i = "starred";
                    break;

                  case "TRASH":
                    i = "trash";
                    break;

                  case "HASCHILDREN":
                  case "HASNOCHILDREN":
                  case "MARKED":
                  case "UNMARKED":
                  case "NOINFERIORS":                }
                if (!i) {
                    var a = this._namespaces.personal[0] && this._namespaces.personal[0].prefix, r = t === a + e.name;
                    if (r || t === e.name) switch (e.name.toUpperCase()) {
                      case "DRAFT":
                      case "DRAFTS":
                        i = "drafts";
                        break;

                      case "INBOX":
                        "INBOX" === t.toUpperCase() && (i = "inbox");
                        break;

                      case "BULK MAIL":
                      case "JUNK":
                      case "SPAM":
                        i = "junk";
                        break;

                      case "SENT":
                        i = "sent";
                        break;

                      case "TRASH":
                        i = "trash";
                        break;

                      case "UNSENT MESSAGES":
                        i = "queue";
                    }
                }
                i || (i = "normal");
            }
            return i;
        },
        _namespaces: {
            personal: {
                prefix: "",
                delimiter: "/"
            },
            provisional: !0
        },
        _syncFolderComputeDeltas: function(e, n, i, o) {
            function a(e, n, i) {
                e.forEach(function(e) {
                    var o;
                    e.name;
                    var r = e.delimiter || "/";
                    0 === e.path.indexOf(r) && (e.path = e.path.slice(r.length));
                    var c = e.path, d = s._determineFolderType(e, c);
                    "inbox" === d && (c = "INBOX"), l.hasOwnProperty(c) ? (o = l[c], o.name = e.name, 
                    o.delim = r, t.log("imap:folder-sync:existing", {
                        type: d,
                        name: e.name,
                        path: c,
                        delim: r
                    }), l[c] = !0) : (t.log("imap:folder-sync:add", {
                        type: d,
                        name: e.name,
                        path: c,
                        delim: r
                    }), o = s._learnAboutFolder(e.name, c, i, d, r, n)), e.children && a(e.children, n + 1, o.id);
                });
            }
            var s = this;
            if (i) return n(i), void 0;
            if (s._namespaces.provisional) return e.listNamespaces(function(i, a) {
                !i && a && (s._namespaces = a), s._namespaces.provisional = !1, t.log("imap:list-namespaces", {
                    namespaces: a
                }), s._syncFolderComputeDeltas(e, n, i, o);
            }), void 0;
            for (var c, l = {}, d = 0; d < this.folders.length; d++) c = this.folders[d], l[c.path] = c;
            a(o.children, "", 0, null);
            for (var p in l) c = l[p], c !== !0 && (r.FolderStorage.isTypeLocalOnly(c.type) || (t.log("imap:delete-dead-folder", {
                type: c.type,
                id: c.id
            }), this._forgetFolder(c.id)));
            this.ensureEssentialOnlineFolders(), this.normalizeFolderHierarchy(), n(null);
        },
        ensureEssentialOfflineFolders: function() {
            [ "outbox", "localdrafts" ].forEach(function(e) {
                this.getFirstFolderWithType(e) || this._learnAboutFolder(e, e, null, e, "", 0, !0);
            }, this);
        },
        ensureEssentialOnlineFolders: function(e) {
            var t = {
                trash: "Trash",
                sent: "Sent"
            }, n = o.latch();
            for (var i in t) this.getFirstFolderWithType(i) || this.universe.createFolder(this.id, null, t[i], i, !1, n.defer());
            n.then(e);
        },
        normalizeFolderHierarchy: i.normalizeFolderHierarchy,
        saveSentMessage: function(e) {
            this.sentMessagesAutomaticallyAppearInSentFolder || e.withMessageBlob({
                includeBcc: !0
            }, function(e) {
                var t = {
                    messageText: e,
                    flags: [ "\\Seen" ]
                }, n = this.getFirstFolderWithType("sent");
                n && this.universe.appendMessages(n.id, [ t ]);
            }.bind(this));
        },
        shutdown: function(e) {
            function t() {
                0 === --n && e();
            }
            b.prototype.shutdownFolders.call(this), this._backoffEndpoint.shutdown();
            for (var n = this._ownedConns.length, i = 0; i < this._ownedConns.length; i++) {
                var o = this._ownedConns[i];
                if (e) {
                    o.inUseBy = {
                        deathback: t
                    };
                    try {
                        o.conn.client.close();
                    } catch (a) {
                        n--;
                    }
                } else o.conn.client.close();
            }
            this._LOG.__die(), !n && e && e();
        },
        checkAccount: function(e) {
            this._LOG.checkAccount_begin(null), this._makeConnection(function(t) {
                this._LOG.checkAccount_end(t), e(t);
            }.bind(this), null, "check");
        },
        accountDeleted: function() {
            this._alive = !1, this.shutdown();
        }
    };
    for (var S in x) Object.defineProperty(y.prototype, S, Object.getOwnPropertyDescriptor(x, S));
    var w = _.LOGFAB = e.register(g, {
        ImapAccount: d.LOGFAB_DEFINITION.CompositeIncomingAccount
    });
}), define("md5", [ "require", "exports", "module" ], function(e, t, n) {
    function i(e) {
        return a(o(r(e)));
    }
    function o(e) {
        return c(l(s(e), 8 * e.length));
    }
    function a(e) {
        try {} catch (t) {
            v = 0;
        }
        for (var n, i = v ? "0123456789ABCDEF" : "0123456789abcdef", o = "", a = 0; a < e.length; a++) n = e.charCodeAt(a), 
        o += i.charAt(15 & n >>> 4) + i.charAt(15 & n);
        return o;
    }
    function r(e) {
        for (var t, n, i = "", o = -1; ++o < e.length; ) t = e.charCodeAt(o), n = o + 1 < e.length ? e.charCodeAt(o + 1) : 0, 
        t >= 55296 && 56319 >= t && n >= 56320 && 57343 >= n && (t = 65536 + ((1023 & t) << 10) + (1023 & n), 
        o++), 127 >= t ? i += String.fromCharCode(t) : 2047 >= t ? i += String.fromCharCode(192 | 31 & t >>> 6, 128 | 63 & t) : 65535 >= t ? i += String.fromCharCode(224 | 15 & t >>> 12, 128 | 63 & t >>> 6, 128 | 63 & t) : 2097151 >= t && (i += String.fromCharCode(240 | 7 & t >>> 18, 128 | 63 & t >>> 12, 128 | 63 & t >>> 6, 128 | 63 & t));
        return i;
    }
    function s(e) {
        for (var t = Array(e.length >> 2), n = 0; n < t.length; n++) t[n] = 0;
        for (var n = 0; n < 8 * e.length; n += 8) t[n >> 5] |= (255 & e.charCodeAt(n / 8)) << n % 32;
        return t;
    }
    function c(e) {
        for (var t = "", n = 0; n < 32 * e.length; n += 8) t += String.fromCharCode(255 & e[n >> 5] >>> n % 32);
        return t;
    }
    function l(e, t) {
        e[t >> 5] |= 128 << t % 32, e[(t + 64 >>> 9 << 4) + 14] = t;
        for (var n = 1732584193, i = -271733879, o = -1732584194, a = 271733878, r = 0; r < e.length; r += 16) {
            var s = n, c = i, l = o, d = a;
            n = p(n, i, o, a, e[r + 0], 7, -680876936), a = p(a, n, i, o, e[r + 1], 12, -389564586), 
            o = p(o, a, n, i, e[r + 2], 17, 606105819), i = p(i, o, a, n, e[r + 3], 22, -1044525330), 
            n = p(n, i, o, a, e[r + 4], 7, -176418897), a = p(a, n, i, o, e[r + 5], 12, 1200080426), 
            o = p(o, a, n, i, e[r + 6], 17, -1473231341), i = p(i, o, a, n, e[r + 7], 22, -45705983), 
            n = p(n, i, o, a, e[r + 8], 7, 1770035416), a = p(a, n, i, o, e[r + 9], 12, -1958414417), 
            o = p(o, a, n, i, e[r + 10], 17, -42063), i = p(i, o, a, n, e[r + 11], 22, -1990404162), 
            n = p(n, i, o, a, e[r + 12], 7, 1804603682), a = p(a, n, i, o, e[r + 13], 12, -40341101), 
            o = p(o, a, n, i, e[r + 14], 17, -1502002290), i = p(i, o, a, n, e[r + 15], 22, 1236535329), 
            n = u(n, i, o, a, e[r + 1], 5, -165796510), a = u(a, n, i, o, e[r + 6], 9, -1069501632), 
            o = u(o, a, n, i, e[r + 11], 14, 643717713), i = u(i, o, a, n, e[r + 0], 20, -373897302), 
            n = u(n, i, o, a, e[r + 5], 5, -701558691), a = u(a, n, i, o, e[r + 10], 9, 38016083), 
            o = u(o, a, n, i, e[r + 15], 14, -660478335), i = u(i, o, a, n, e[r + 4], 20, -405537848), 
            n = u(n, i, o, a, e[r + 9], 5, 568446438), a = u(a, n, i, o, e[r + 14], 9, -1019803690), 
            o = u(o, a, n, i, e[r + 3], 14, -187363961), i = u(i, o, a, n, e[r + 8], 20, 1163531501), 
            n = u(n, i, o, a, e[r + 13], 5, -1444681467), a = u(a, n, i, o, e[r + 2], 9, -51403784), 
            o = u(o, a, n, i, e[r + 7], 14, 1735328473), i = u(i, o, a, n, e[r + 12], 20, -1926607734), 
            n = h(n, i, o, a, e[r + 5], 4, -378558), a = h(a, n, i, o, e[r + 8], 11, -2022574463), 
            o = h(o, a, n, i, e[r + 11], 16, 1839030562), i = h(i, o, a, n, e[r + 14], 23, -35309556), 
            n = h(n, i, o, a, e[r + 1], 4, -1530992060), a = h(a, n, i, o, e[r + 4], 11, 1272893353), 
            o = h(o, a, n, i, e[r + 7], 16, -155497632), i = h(i, o, a, n, e[r + 10], 23, -1094730640), 
            n = h(n, i, o, a, e[r + 13], 4, 681279174), a = h(a, n, i, o, e[r + 0], 11, -358537222), 
            o = h(o, a, n, i, e[r + 3], 16, -722521979), i = h(i, o, a, n, e[r + 6], 23, 76029189), 
            n = h(n, i, o, a, e[r + 9], 4, -640364487), a = h(a, n, i, o, e[r + 12], 11, -421815835), 
            o = h(o, a, n, i, e[r + 15], 16, 530742520), i = h(i, o, a, n, e[r + 2], 23, -995338651), 
            n = f(n, i, o, a, e[r + 0], 6, -198630844), a = f(a, n, i, o, e[r + 7], 10, 1126891415), 
            o = f(o, a, n, i, e[r + 14], 15, -1416354905), i = f(i, o, a, n, e[r + 5], 21, -57434055), 
            n = f(n, i, o, a, e[r + 12], 6, 1700485571), a = f(a, n, i, o, e[r + 3], 10, -1894986606), 
            o = f(o, a, n, i, e[r + 10], 15, -1051523), i = f(i, o, a, n, e[r + 1], 21, -2054922799), 
            n = f(n, i, o, a, e[r + 8], 6, 1873313359), a = f(a, n, i, o, e[r + 15], 10, -30611744), 
            o = f(o, a, n, i, e[r + 6], 15, -1560198380), i = f(i, o, a, n, e[r + 13], 21, 1309151649), 
            n = f(n, i, o, a, e[r + 4], 6, -145523070), a = f(a, n, i, o, e[r + 11], 10, -1120210379), 
            o = f(o, a, n, i, e[r + 2], 15, 718787259), i = f(i, o, a, n, e[r + 9], 21, -343485551), 
            n = m(n, s), i = m(i, c), o = m(o, l), a = m(a, d);
        }
        return Array(n, i, o, a);
    }
    function d(e, t, n, i, o, a) {
        return m(g(m(m(t, e), m(i, a)), o), n);
    }
    function p(e, t, n, i, o, a, r) {
        return d(t & n | ~t & i, e, t, o, a, r);
    }
    function u(e, t, n, i, o, a, r) {
        return d(t & i | n & ~i, e, t, o, a, r);
    }
    function h(e, t, n, i, o, a, r) {
        return d(t ^ n ^ i, e, t, o, a, r);
    }
    function f(e, t, n, i, o, a, r) {
        return d(n ^ (t | ~i), e, t, o, a, r);
    }
    function m(e, t) {
        var n = (65535 & e) + (65535 & t), i = (e >> 16) + (t >> 16) + (n >> 16);
        return i << 16 | 65535 & n;
    }
    function g(e, t) {
        return e << t | e >>> 32 - t;
    }
    n.exports = function(e) {
        return i(e);
    };
    var v = 0;
}), define("pop3/transport", [ "mimefuncs", "exports" ], function(e, t) {
    function n(e, t) {
        var n = new Uint8Array(e.length + t.length);
        return n.set(e, 0), n.set(t, e.length), n;
    }
    function i() {
        this.buffer = new Uint8Array(0), this.unprocessedLines = [];
    }
    function o(e, t) {
        this.lines = e, this.isMultiline = t, this.ok = this.lines[0][0] === d, this.err = !this.ok, 
        this.request = null;
    }
    function a(e, t, n, i) {
        this.command = e, this.args = t, this.expectMultiline = n, this.onresponse = i || null;
    }
    function r() {
        this.parser = new i(), this.onsend = function() {
            throw new Error("You must implement Pop3Protocol.onsend to send data.");
        }, this.unsentRequests = [], this.pipeline = !1, this.pendingRequests = [], this.closed = !1;
    }
    window.setTimeout.bind(window), window.clearTimeout.bind(window);
    var s = "\r".charCodeAt(0), c = "\n".charCodeAt(0), l = ".".charCodeAt(0), d = "+".charCodeAt(0);
    "-".charCodeAt(0), " ".charCodeAt(0);
    var p = new TextEncoder("utf-8", {
        fatal: !1
    });
    i.prototype.push = function(e) {
        for (var t = this.buffer = n(this.buffer, e), i = 0; i < t.length - 1; i++) if (t[i] === s && t[i + 1] === c) {
            var o = i + 1;
            this.unprocessedLines.push(t.subarray(0, o + 1)), t = this.buffer = t.subarray(o + 1), 
            i = -1;
        }
    }, i.prototype.extractResponse = function(e) {
        if (!this.unprocessedLines.length) return null;
        if (this.unprocessedLines[0][0] !== d && (e = !1), e) {
            for (var t = -1, n = 1; n < this.unprocessedLines.length; n++) {
                var i = this.unprocessedLines[n];
                if (3 === i.byteLength && i[0] === l && i[1] === s && i[2] === c) {
                    t = n;
                    break;
                }
            }
            if (-1 === t) return null;
            var a = this.unprocessedLines.splice(0, t + 1);
            a.pop();
            for (var n = 1; t > n; n++) a[n][0] === l && (a[n] = a[n].subarray(1));
            return new o(a, !0);
        }
        return new o([ this.unprocessedLines.shift() ], !1);
    }, o.prototype.getStatusLine = function() {
        return this.getLineAsString(0).replace(/^(\+OK|-ERR) /, "");
    }, o.prototype.getLineAsString = function(t) {
        return e.fromTypedArray(this.lines[t]);
    }, o.prototype.getLinesAsString = function() {
        for (var e = [], t = 0; t < this.lines.length; t++) e.push(this.getLineAsString(t));
        return e;
    }, o.prototype.getDataLines = function() {
        for (var e = [], t = 1; t < this.lines.length; t++) {
            var n = this.getLineAsString(t);
            e.push(n.slice(0, n.length - 2));
        }
        return e;
    }, o.prototype.getDataAsString = function() {
        for (var e = [], t = 1; t < this.lines.length; t++) e.push(this.getLineAsString(t));
        return e.join("");
    }, o.prototype.toString = function() {
        return this.getLinesAsString().join("\r\n");
    }, t.Request = a, a.prototype.toByteArray = function() {
        return p.encode(this.command + (this.args.length ? " " + this.args.join(" ") : "") + "\r\n");
    }, a.prototype._respondWithError = function(e) {
        var t = new o([ p.encode("-ERR " + e + "\r\n") ], !1);
        t.request = this, this.onresponse(t, null);
    }, t.Response = o, t.Pop3Protocol = r, r.prototype.sendRequest = function(e, t, n, i) {
        var o;
        return o = e instanceof a ? e : new a(e, t, n, i), this.closed ? (o._respondWithError("(request sent after connection closed)"), 
        void 0) : (this.pipeline || 0 === this.pendingRequests.length ? (this.onsend(o.toByteArray()), 
        this.pendingRequests.push(o)) : this.unsentRequests.push(o), void 0);
    }, r.prototype.onreceive = function(e) {
        this.parser.push(new Uint8Array(e.data));
        for (var t; ;) {
            var n = this.pendingRequests[0];
            if (t = this.parser.extractResponse(n && n.expectMultiline), !t) break;
            if (!n) {
                console.error("Unsolicited response from server: " + t);
                break;
            }
            t.request = n, this.pendingRequests.shift(), this.unsentRequests.length && this.sendRequest(this.unsentRequests.shift()), 
            n.onresponse && (t.err ? n.onresponse(t, null) : n.onresponse(null, t));
        }
    }, r.prototype.onclose = function() {
        this.closed = !0;
        var e = this.pendingRequests.concat(this.unsentRequests);
        this.pendingRequests = [], this.unsentRequests = [];
        for (var t = 0; t < e.length; t++) {
            var n = e[t];
            n._respondWithError("(connection closed, no response)");
        }
    };
}), define("imap/imapchew", [ "mimefuncs", "../db/mail_rep", "../mailchew", "mimeparser", "exports" ], function(e, t, n, i, o) {
    function a(t) {
        var n = /^([^']*)'([^']*)'(.+)$/.exec(t);
        return n ? e.mimeWordsDecode("=?" + (n[1] || "us-ascii") + "?Q?" + n[3].replace(/%/g, "=") + "?=") : null;
    }
    function r(e) {
        return Array.isArray(e) ? e.map(r) : e && "<" === e[0] ? e.slice(1, -1) : e;
    }
    function s(e, t) {
        return e.headers[t] && e.headers[t][0] || null;
    }
    function c(n) {
        function i(e) {
            var t = e.encoding.toLowerCase();
            return "base64" === t ? Math.floor(57 * e.size / 78) : "quoted-printable" === t ? e.size : e.size;
        }
        function o(n, u) {
            var h, f, m, g = n.type.split("/")[0], v = n.type.split("/")[1];
            if ("multipart" !== g) {
                if (f = n.parameters && n.parameters.name ? e.mimeWordsDecode(n.parameters.name) : n.parameters && n.parameters["name*"] ? a(n.parameters["name*"]) : n.dispositionParameters && n.dispositionParameters.filename ? e.mimeWordsDecode(n.dispositionParameters.filename) : n.dispositionParameters && n.dispositionParameters["filename*"] ? a(n.dispositionParameters["filename*"]) : null, 
                m = n.disposition ? "inline" == n.disposition.toLowerCase() ? "text" === g || n.id ? "inline" : "attachment" : "attachment" == n.disposition.toLowerCase() ? "attachment" : "inline" : "related" === u && n.id && "image" === g ? "inline" : f || "text" !== g ? "attachment" : "inline", 
                "text" !== g && "image" !== g && (m = "attachment"), "application" === g && ("pgp-signature" === v || "pkcs7-signature" === v)) return !0;
                var _ = function(e, n) {
                    return t.makeAttachmentPart({
                        name: n || "unnamed-" + ++d,
                        contentId: e.id ? r(e.id) : null,
                        type: e.type.toLowerCase(),
                        part: e.part,
                        encoding: e.encoding && e.encoding.toLowerCase(),
                        sizeEstimate: i(e),
                        file: null
                    });
                }, y = function(e) {
                    return t.makeBodyPart({
                        type: v,
                        part: e.part || "1",
                        sizeEstimate: e.size,
                        amountDownloaded: 0,
                        isDownloaded: 0 === e.size,
                        _partInfo: e.size ? {
                            partID: e.part,
                            type: g,
                            subtype: v,
                            params: l(e.parameters),
                            encoding: e.encoding && e.encoding.toLowerCase()
                        } : null,
                        content: ""
                    });
                };
                if ("attachment" === m) return s.push(_(n, f)), !0;
                switch (g) {
                  case "image":
                    return p.push(_(n, f)), !0;

                  case "text":
                    if ("plain" === v || "html" === v) return c.push(y(n)), !0;
                }
                return !1;
            }
            switch (v) {
              case "alternative":
                for (h = n.childNodes.length - 1; h >= 0; h--) {
                    var b = n.childNodes[h], x = b.type.split("/")[0], S = b.type.split("/")[1];
                    switch (x) {
                      case "text":
                        break;

                      case "multipart":
                        if (o(b)) return !0;
                        break;

                      default:
                        continue;
                    }
                    switch (S) {
                      case "html":
                      case "plain":
                        if (o(b), v) return !0;
                    }
                }
                return !1;

              case "mixed":
              case "signed":
              case "related":
                for (h = 0; h < n.childNodes.length; h++) o(n.childNodes[h], v);
                return !0;

              default:
                return console.warn("Ignoring multipart type:", v), !1;
            }
        }
        var s = [], c = [], d = 0, p = [];
        return o(n.bodystructure), {
            bodyReps: c,
            attachments: s,
            relatedParts: p
        };
    }
    function l(e) {
        if (Array.isArray(e)) return e.map(l);
        if (e && "object" == typeof e) {
            if ("value" in e) return e.value;
            var t = {};
            for (var n in e) t[n] = l(e[n]);
            return t;
        }
        return e && "object" == typeof e ? e : void 0 !== e ? e : null;
    }
    o.chewHeaderAndBodyStructure = function(e, n, o) {
        var a = c(e);
        e.date = e.internaldate && f(e.internaldate), e.headers = {};
        for (var d in e) if (/header\.fields/.test(d)) {
            var p = new i();
            p.write(e[d] + "\r\n"), p.end(), e.headers = p.node.headers;
            break;
        }
        var u = l(s(e, "from")), h = l(s(e, "references"));
        return {
            header: t.makeHeaderInfo({
                id: o,
                srvid: e.uid,
                suid: n + "/" + o,
                guid: r(l(s(e, "message-id"))),
                author: u && u[0] || {
                    address: "missing-address@example.com"
                },
                to: l(s(e, "to")),
                cc: l(s(e, "cc")),
                bcc: l(s(e, "bcc")),
                replyTo: l(s(e, "reply-to")),
                date: e.date,
                flags: e.flags || [],
                hasAttachments: a.attachments.length > 0,
                subject: l(s(e, "subject")),
                snippet: null
            }),
            bodyInfo: t.makeBodyInfo({
                date: e.date,
                size: 0,
                attachments: a.attachments,
                relatedParts: a.relatedParts,
                references: h ? r(h.split(/\s+/)) : null,
                bodyReps: a.bodyReps
            })
        };
    }, o.updateMessageWithFetch = function(e, t, i, o, a) {
        var r = t.bodyReps[i.bodyRepIndex];
        (!i.bytes || o.bytesFetched < i.bytes[1]) && (r.isDownloaded = !0, r._partInfo = null), 
        !r.isDownloaded && o.buffer && (r._partInfo.pendingBuffer = o.buffer), r.amountDownloaded += o.bytesFetched;
        var s = n.processMessageContent(o.text, r.type, r.isDownloaded, i.createSnippet, a);
        i.createSnippet && (e.snippet = s.snippet), r.isDownloaded && (r.content = s.content);
    }, o.selectSnippetBodyRep = function(e, t) {
        if (e.snippet) return -1;
        for (var n = t.bodyReps, i = n.length, a = 0; i > a; a++) if (o.canBodyRepFillSnippet(n[a])) return a;
        return -1;
    }, o.canBodyRepFillSnippet = function(e) {
        return e && "plain" === e.type || "html" === e.type;
    }, o.calculateBytesToDownloadForImapBodyDisplay = function(e) {
        var t = 0;
        return e.bodyReps.forEach(function(e) {
            e.isDownloaded || (t += e.sizeEstimate - e.amountDownloaded);
        }), e.relatedParts.forEach(function(e) {
            e.file || (t += e.sizeEstimate);
        }), t;
    };
    var d = /^( ?\d|\d{2})-(.{3})-(\d{4}) (\d{2}):(\d{2}):(\d{2})(?: ([+-]\d{4}))?$/, p = 36e5, u = 6e4, h = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ], f = o.parseImapDateTime = function(e) {
        var t = d.exec(e);
        if (!t) throw new Error("Not a good IMAP date-time: " + e);
        var n = parseInt(t[1], 10), i = h.indexOf(t[2]), o = parseInt(t[3], 10), a = parseInt(t[4], 10), r = parseInt(t[5], 10), s = parseInt(t[6], 10), c = Date.UTC(o, i, n, a, r, s), l = t[7] ? parseInt(t[7], 10) : 0, f = Math.floor(l / 100), m = l % 100;
        return c -= f * p + m * u;
    };
    o.formatImapDateTime = function(e) {
        var t;
        return t = (e.getDate() < 10 ? " " : "") + e.getDate() + "-" + h[e.getMonth()] + "-" + e.getFullYear() + " " + ("0" + e.getHours()).slice(-2) + ":" + ("0" + e.getMinutes()).slice(-2) + ":" + ("0" + e.getSeconds()).slice(-2) + (e.getTimezoneOffset() > 0 ? " -" : " +") + ("0" + Math.abs(e.getTimezoneOffset()) / 60).slice(-2) + ("0" + Math.abs(e.getTimezoneOffset()) % 60).slice(-2);
    };
}), define("pop3/mime_mapper", [], function() {
    return {
        _typeToExtensionMap: {
            "image/jpeg": "jpg",
            "image/png": "png",
            "image/gif": "gif",
            "image/bmp": "bmp",
            "audio/mpeg": "mp3",
            "audio/mp4": "m4a",
            "audio/ogg": "ogg",
            "audio/webm": "webm",
            "audio/3gpp": "3gp",
            "audio/amr": "amr",
            "video/mp4": "mp4",
            "video/mpeg": "mpg",
            "video/ogg": "ogg",
            "video/webm": "webm",
            "video/3gpp": "3gp",
            "application/vcard": "vcf",
            "text/vcard": "vcf",
            "text/x-vcard": "vcf"
        },
        _extensionToTypeMap: {
            jpg: "image/jpeg",
            jpeg: "image/jpeg",
            jpe: "image/jpeg",
            png: "image/png",
            gif: "image/gif",
            bmp: "image/bmp",
            mp3: "audio/mpeg",
            m4a: "audio/mp4",
            m4b: "audio/mp4",
            m4p: "audio/mp4",
            m4r: "audio/mp4",
            aac: "audio/aac",
            opus: "audio/ogg",
            amr: "audio/amr",
            mp4: "video/mp4",
            mpeg: "video/mpeg",
            mpg: "video/mpeg",
            ogv: "video/ogg",
            ogx: "video/ogg",
            webm: "video/webm",
            "3gp": "video/3gpp",
            ogg: "video/ogg",
            vcf: "text/vcard"
        },
        _parseExtension: function(e) {
            var t = e.split(".");
            return t.length > 1 ? t.pop() : "";
        },
        isSupportedType: function(e) {
            return e in this._typeToExtensionMap;
        },
        isSupportedExtension: function(e) {
            return e in this._extensionToTypeMap;
        },
        isFilenameMatchesType: function(e, t) {
            var n = this._parseExtension(e), i = this.guessTypeFromExtension(n);
            return i == t;
        },
        guessExtensionFromType: function(e) {
            return this._typeToExtensionMap[e];
        },
        guessTypeFromExtension: function(e) {
            return this._extensionToTypeMap[e];
        },
        guessTypeFromFileProperties: function(e, t) {
            var n = this._parseExtension(e), i = this.isSupportedType(t) ? t : this.guessTypeFromExtension(n);
            return i || "";
        },
        ensureFilenameMatchesType: function(e, t) {
            if (!this.isFilenameMatchesType(e, t)) {
                var n = this.guessExtensionFromType(t);
                n && (e += "." + n);
            }
            return e;
        }
    };
}), define("pop3/pop3", [ "module", "exports", "rdcommon/log", "tcp-socket", "md5", "./transport", "mimeparser", "imap/imapchew", "syncbase", "date", "mimefuncs", "./mime_mapper", "allback" ], function(e, t, n, i, o, a, r, s, c, l, d, p, u) {
    function h(e, t, n) {
        var i = e.headers[t];
        return i && i[0] ? i[0].value : n || null;
    }
    function f(e, t) {
        var n = e.headers[t];
        return n && n[0] ? n[0].params || {} : {};
    }
    function m(e, t, n, i) {
        var o = {};
        o.part = t || "1", o.type = e.contentType.value, o.parameters = f(e, "content-type");
        var a = h(e, "content-disposition");
        if (a && (o.disposition = a, o.dispositionParameters = f(e, "content-disposition")), 
        o.id = h(e, "content-id"), o.encoding = "binary", o.size = e.content && e.content.length || 0, 
        o.description = null, o.lines = null, o.md5 = null, o.childNodes = [], null != e.content || /^multipart\//.test(o.type) || (e.content = new Uint8Array()), 
        null != e.content && (n[o.part] = e.content, i === e && (n.partial = o.part)), e._childNodes.length) for (var r = 0; r < e._childNodes.length; r++) {
            var s = e._childNodes[r];
            o.childNodes.push(m(s, o.part + "." + (r + 1), n, i));
        }
        return o;
    }
    var g = window.setTimeout.bind(window), v = window.clearTimeout.bind(window);
    t.setTimeoutFunctions = function(e, t) {
        g = e, v = t;
    };
    var _ = t.Pop3Client = function(e, t) {
        if (this.options = e = e || {}, e.host = e.host || null, e.username = e.username || null, 
        e.password = e.password || null, e.port = e.port || null, e.crypto = e.crypto || !1, 
        e.connTimeout = e.connTimeout || 3e4, e.debug = e.debug || !1, e.authMethods = [ "apop", "sasl", "user-pass" ], 
        this._LOG = e._logParent ? y.Pop3Client(this, e._logParent, Date.now() % 1e3) : null, 
        e.preferredAuthMethod) {
            var n = e.authMethods.indexOf(e.preferredAuthMethod);
            -1 !== n && e.authMethods.splice(n, 1), e.authMethods.unshift(e.preferredAuthMethod);
        }
        if (e.crypto === !0 ? e.crypto = "ssl" : e.crypto || (e.crypto = "plain"), !e.port && (e.port = {
            plain: 110,
            starttls: 110,
            ssl: 995
        }[e.crypto], !e.port)) throw new Error("Invalid crypto option for Pop3Client: " + e.crypto);
        this.state = "disconnected", this.authMethod = null, this.idToUidl = {}, this.uidlToId = {}, 
        this.idToSize = {}, this._messageList = null, this._greetingLine = null, this.protocol = new a.Pop3Protocol(), 
        this.socket = i.open(e.host, e.port, {
            useSecureTransport: "ssl" === e.crypto || e.crypto === !0
        });
        var o = g(function() {
            this.state = "disconnected", o && (v(o), o = null), t && t({
                scope: "connection",
                request: null,
                name: "unresponsive-server",
                message: "Could not connect to " + e.host + ":" + e.port + " with " + e.crypto + " encryption."
            });
        }.bind(this), e.connTimeout);
        this.socket.ondata = this.protocol.onreceive.bind(this.protocol), this.protocol.onsend = this.socket.send.bind(this.socket), 
        this.socket.onopen = function() {
            console.log("pop3:onopen"), o && (v(o), o = null), this.state = "greeting";
        }.bind(this), this.socket.onerror = function(e) {
            var n = e && e.data || e;
            console.log("pop3:onerror", n), o && (v(o), o = null), t && t({
                scope: "connection",
                request: null,
                name: "unresponsive-server",
                message: "Socket exception: " + JSON.stringify(n),
                exception: n
            });
        }.bind(this), this.onclose = null, this.socket.onclose = function() {
            console.log("pop3:onclose"), this.protocol.onclose(), this.close(), this.onclose && this.onclose();
        }.bind(this), this.protocol.pendingRequests.push(new a.Request(null, [], !1, function(e, n) {
            return e ? (t && t({
                scope: "connection",
                request: null,
                name: "unresponsive-server",
                message: e.getStatusLine(),
                response: e
            }), void 0) : (this._greetingLine = n.getLineAsString(0), this._maybeUpgradeConnection(function(e) {
                return e ? (t && t(e), void 0) : (this._thenAuthorize(function(e) {
                    e || (this.state = "ready"), t && t(e);
                }), void 0);
            }.bind(this)), void 0);
        }.bind(this)));
    };
    _.prototype.close = _.prototype.die = function() {
        "disconnected" !== this.state && (this.state = "disconnected", this.socket.close());
    }, _.prototype._getCapabilities = function() {
        this.protocol.sendRequest("CAPA", [], !0, function(e, t) {
            if (e) this.capabilities = {}; else for (var n = t.getDataLines(), i = 0; i < n.length; i++) {
                var o = n[i].split(" ");
                this.capabilities[o[0]] = o.slice(1);
            }
        }.bind(this));
    }, _.prototype._maybeUpgradeConnection = function(e) {
        "starttls" === this.options.crypto ? (this.state = "starttls", this.protocol.sendRequest("STLS", [], !1, function(t) {
            return t ? (e && e({
                scope: "connection",
                request: t.request,
                name: "bad-security",
                message: t.getStatusLine(),
                response: t
            }), void 0) : (this.socket.upgradeToSecure(), e(), void 0);
        }.bind(this))) : e();
    }, _.prototype._thenAuthorize = function(e) {
        this.state = "authorization", this.authMethod = this.options.authMethods.shift();
        var t, n = this.options.username, i = this.options.password;
        switch (this.authMethod) {
          case "apop":
            var a = /<.*?>/.exec(this._greetingLine || ""), r = a && a[0];
            r ? (t = o(r + i).toLowerCase(), this.protocol.sendRequest("APOP", [ n, t ], !1, function(t) {
                t ? (this._greetingLine = null, this._thenAuthorize(e)) : e();
            }.bind(this))) : this._thenAuthorize(e);
            break;

          case "sasl":
            t = btoa(n + "\0" + n + "\0" + i), this.protocol.sendRequest("AUTH", [ "PLAIN", t ], !1, function(t) {
                t ? this._thenAuthorize(e) : e();
            }.bind(this));
            break;

          case "user-pass":
          default:
            this.protocol.sendRequest("USER", [ n ], !1, function(t) {
                return t ? (e && e({
                    scope: "authentication",
                    request: t.request,
                    name: "bad-user-or-pass",
                    message: t.getStatusLine(),
                    response: t
                }), void 0) : (this.protocol.sendRequest("PASS", [ i ], !1, function(t) {
                    return t ? (e && e({
                        scope: "authentication",
                        request: null,
                        name: "bad-user-or-pass",
                        message: t.getStatusLine(),
                        response: t
                    }), void 0) : (e(), void 0);
                }.bind(this)), void 0);
            }.bind(this));
        }
    }, _.prototype.quit = function(e) {
        this.state = "disconnected", this.protocol.sendRequest("QUIT", [], !1, function(t) {
            this.close(), t ? e && e({
                scope: "mailbox",
                request: t.request,
                name: "server-problem",
                message: t.getStatusLine(),
                response: t
            }) : e && e();
        }.bind(this));
    }, _.prototype._loadMessageList = function(e) {
        return this._messageList ? (e(null, this._messageList), void 0) : (this.protocol.sendRequest("UIDL", [], !0, function(t, n) {
            if (t) return e && e({
                scope: "mailbox",
                request: t.request,
                name: "server-problem",
                message: t.getStatusLine(),
                response: t
            }), void 0;
            for (var i = n.getDataLines(), o = 0; o < i.length; o++) {
                var a = i[o].split(" "), r = a[0], s = a[1];
                this.idToUidl[r] = s, this.uidlToId[s] = r;
            }
        }.bind(this)), this.protocol.sendRequest("LIST", [], !0, function(t, n) {
            if (t) return e && e({
                scope: "mailbox",
                request: t.request,
                name: "server-problem",
                message: t.getStatusLine(),
                response: t
            }), void 0;
            for (var i = n.getDataLines(), o = [], a = 0; a < i.length; a++) {
                var r = i[a].split(" "), s = r[0], c = parseInt(r[1], 10);
                this.idToSize[s] = c, o.unshift({
                    uidl: this.idToUidl[s],
                    size: c,
                    number: s
                });
            }
            this._messageList = o, e && e(null, o);
        }.bind(this)), void 0);
    }, _.prototype.listMessages = function(e, t) {
        var n = e.filter, i = e.progress, o = e.checkpointInterval || null, a = e.maxMessages || 1/0, r = e.checkpoint, s = [];
        this._loadMessageList(function(e, c) {
            if (e) return t && t(e), void 0;
            for (var l = 0, d = 0, p = [], h = 0, f = 0; f < c.length; f++) {
                var m = c[f];
                !n || n(m.uidl) ? p.length < a ? (l += m.size, p.push(m)) : s.push(m) : h++;
            }
            console.log("POP3: listMessages found " + p.length + " new, " + s.length + " overflow, and " + h + " seen messages. New UIDLs:"), 
            p.forEach(function(e) {
                console.log("POP3: " + e.size + " bytes: " + e.uidl);
            });
            var g = p.length;
            o || (o = g);
            var v = null, _ = function() {
                if (console.log("POP3: Next batch. Messages left: " + p.length), !p.length || this.protocol.closed) return console.log("POP3: Sync complete. " + g + " messages synced, " + s.length + " overflow messages."), 
                t && t(v, g, s), void 0;
                var e = p.splice(0, o), n = u.latch();
                e.forEach(function(e) {
                    var t = n.defer(e.number);
                    this.downloadPartialMessageByNumber(e.number, function(n, o) {
                        d += e.size, n ? v || (v = n) : i && i({
                            totalBytes: l,
                            bytesFetched: d,
                            size: e.size,
                            message: o
                        }), t(n);
                    });
                }.bind(this)), n.then(function(e) {
                    var t = !1;
                    for (var n in e) if (console.log("result", n, e[n]), !e[n][0]) {
                        t = !0;
                        break;
                    }
                    r && t ? (console.log("POP3: Checkpoint."), r(_)) : _();
                });
            }.bind(this);
            _();
        }.bind(this));
    }, _.prototype.downloadMessageByUidl = function(e, t) {
        this._loadMessageList(function(n) {
            n ? t && t(n) : this.downloadMessageByNumber(this.uidlToId[e], t);
        }.bind(this));
    }, _.prototype.downloadPartialMessageByNumber = function(e, t) {
        var n = Math.floor(c.POP3_SNIPPET_SIZE_GOAL / 80);
        this.protocol.sendRequest("TOP", [ e, n ], !0, function(n, i) {
            if (n) return t && t({
                scope: "message",
                request: n.request,
                name: "server-problem",
                message: n.getStatusLine(),
                response: n
            }), void 0;
            var o = this.idToSize[e], a = i.getDataAsString(), r = !o || a.length < o;
            t(null, this.parseMime(a, r, e));
        }.bind(this));
    }, _.prototype.downloadMessageByNumber = function(e, t) {
        this.protocol.sendRequest("RETR", [ e ], !0, function(n, i) {
            return n ? (t && t({
                scope: "message",
                request: n.request,
                name: "server-problem",
                message: n.getStatusLine(),
                response: n
            }), void 0) : (t(null, this.parseMime(i.getDataAsString(), !1, e)), void 0);
        }.bind(this));
    }, _.parseMime = function(e) {
        return _.prototype.parseMime.call(this, e);
    }, _.prototype.parseMime = function(e, t, n) {
        var i, o = new r();
        for (o.write(d.charset.encode(e, "utf-8")), o.end(), i = o.node; i._currentChild && i !== i._currentChild; ) i = i._currentChild;
        var a, u, f = o.node, g = t ? i : null, v = n && this.idToSize[n] || e.length, _ = h(f, "date"), y = l.NOW();
        _ ? (u = Date.parse(_), (isNaN(u) || u > y) && (u = y)) : u = y;
        var b = [];
        for (var x in f.headers) b.push(x + ": " + f.headers[x][0].initial + "\r\n");
        var S = {}, w = {
            uid: n && this.idToUidl[n],
            "header.fields[]": b.join(""),
            internaldate: u && s.formatImapDateTime(new Date(u)),
            flags: [],
            bodystructure: m(f, "1", S, g)
        }, T = s.chewHeaderAndBodyStructure(w, null, null), k = s.selectSnippetBodyRep(T.header, T.bodyInfo), E = {}, I = 0, A = S.partial;
        for (var O in S) "partial" !== O && O !== A && (I += S[O].length, E[O] = S[O].length);
        A && (E[A] = v - I);
        for (var C = 0; C < T.bodyInfo.bodyReps.length; C++) {
            var M = T.bodyInfo.bodyReps[C];
            a = d.charset.decode(S[M.part], "utf-8");
            var N = {
                bytes: A === M.part ? [ -1, -1 ] : null,
                bodyRepIndex: C,
                createSnippet: C === k
            };
            if (null != a) {
                M.size = E[M.part];
                var D = {
                    bytesFetched: a.length,
                    text: a
                };
                s.updateMessageWithFetch(T.header, T.bodyInfo, N, D, this._LOG);
            }
        }
        for (var C = 0; C < T.bodyInfo.relatedParts.length; C++) {
            var L = T.bodyInfo.relatedParts[C];
            L.sizeEstimate = E[L.part], a = S[L.part], null != a && A !== L.part && (L.file = new Blob([ a ], {
                type: L.type
            }));
        }
        for (var C = 0; C < T.bodyInfo.attachments.length; C++) {
            var F = T.bodyInfo.attachments[C];
            a = S[F.part], F.sizeEstimate = E[F.part], null != a && A !== F.part && p.isSupportedType(F.type) && (F.file = new Blob([ a ], {
                type: F.type
            }));
        }
        return t && !T.header.hasAttachments && (h(f, "x-ms-has-attach") || /multipart\/mixed/.test(f.contentType.value) || v > c.POP3_INFER_ATTACHMENTS_SIZE) && (T.header.hasAttachments = !0), 
        T.bodyInfo.bodyReps.push({
            type: "fake",
            part: "fake",
            sizeEstimate: 0,
            amountDownloaded: 0,
            isDownloaded: !t,
            content: null,
            size: 0
        }), T.header.bytesToDownloadForBodyDisplay = t ? v : 0, T;
    };
    var y = t.LOGFAB = n.register(e, {
        Pop3Client: {
            type: n.CONNECTION,
            subtype: n.CLIENT,
            events: {},
            TEST_ONLY_events: {},
            errors: {
                htmlParseError: {
                    ex: n.EXCEPTION
                },
                htmlSnippetError: {
                    ex: n.EXCEPTION
                },
                textChewError: {
                    ex: n.EXCEPTION
                },
                textSnippetError: {
                    ex: n.EXCEPTION
                }
            },
            asyncJobs: {}
        }
    });
    _._LOG = y.Pop3Client();
}), define("pop3/sync", [ "rdcommon/log", "slog", "../util", "module", "require", "exports", "../mailchew", "../syncbase", "../date", "../jobmixins", "../allback", "./pop3" ], function(e, t, n, i, o, a, r, s, c, l, d) {
    function p(e, t, n) {
        this._LOG = m.Pop3FolderSyncer(this, n, t.folderId), this.account = e, this.storage = t, 
        this.isInbox = "inbox" === t.folderMeta.type;
    }
    function u(e, t, n, i) {
        return function() {
            var a = Array.slice(arguments);
            o([], function() {
                var o = function() {
                    return this.isInbox ? (this.account.withConnection(function(e, n, o) {
                        var r = a[t];
                        e ? r && r(e) : (a[t] = function(e) {
                            o(), r && r(e);
                        }, i.apply(this, [ n ].concat(a)));
                    }.bind(this), n), void 0) : (i.apply(this, [ null ].concat(a)), void 0);
                }.bind(this);
                e && this.account._conn && "disconnected" !== this.account._conn.state ? this.account._conn.quit(o) : o();
            }.bind(this));
        };
    }
    function h(e) {
        for (var t = [], n = 0; e > n; n++) t.push(n);
        return t;
    }
    var f = 1;
    a.Pop3FolderSyncer = p, p.prototype = {
        syncable: !0,
        get canGrowSync() {
            return this.isInbox;
        },
        downloadBodies: u(!1, 2, "downloadBodies", function(e, t, n, i) {
            var o = d.latch();
            this.storage;
            for (var a = 0; a < t.length; a++) t[a] && null == t[a].snippet && this.downloadBodyReps(t[a], n, o.defer(a));
            o.then(function(e) {
                var n = null;
                for (var o in e) n = e[o][0];
                i(n, t.length);
            });
        }),
        downloadBodyReps: u(!1, 2, "downloadBodyReps", function(e, t, n, i) {
            n instanceof Function && (i = n, n = {}), console.log("POP3: Downloading bodyReps for UIDL " + t.srvid), 
            e.downloadMessageByUidl(t.srvid, function(e, n) {
                if (e) return i(e), void 0;
                t.bytesToDownloadForBodyDisplay = n.header.bytesToDownloadForBodyDisplay, console.log("POP3: Storing message " + t.srvid + " with " + t.bytesToDownloadForBodyDisplay + " bytesToDownload.");
                var o = n.bodyInfo.attachments.length > 0;
                this.storeMessage(t, n.bodyInfo, {
                    flush: o
                }, function() {
                    i && i(null, n.bodyInfo, o);
                });
            }.bind(this));
        }),
        downloadMessageAttachments: function(e, t, n) {
            console.log("POP3: ERROR: downloadMessageAttachments called and POP3 shouldn't do that."), 
            n(null, null);
        },
        storeMessage: function(e, t, n, i) {
            i = i || function() {};
            var o = {
                changeDetails: {}
            }, a = this.getMessageIdForUidl(e.srvid);
            null == e.id && (e.id = null == a ? this.storage._issueNewHeaderId() : a, e.suid = this.storage.folderId + "/" + e.id, 
            e.guid = e.guid || e.srvid);
            for (var r = d.latch(), s = this, c = 0; c < t.attachments.length; c++) {
                var p = t.attachments[c];
                p.file instanceof Blob && (console.log("Saving attachment", p.file), l.saveToDeviceStorage(this._LOG, p.file, "sdcard", p.name, p, r.defer()));
            }
            r.then(function() {
                if (r = d.latch(), null == a) s.storeMessageUidlForMessageId(e.srvid, e.id), s.storage.addMessageHeader(e, t, r.defer()), 
                s.storage.addMessageBody(e, t, r.defer()); else {
                    s.storage.updateMessageHeader(e.date, e.id, !0, e, t, r.defer()), o.changeDetails.attachments = h(t.attachments.length), 
                    o.changeDetails.bodyReps = h(t.bodyReps.length);
                    var c = {};
                    n.flush && (c.flushBecause = "blobs"), s.storage.updateMessageBody(e, t, c, o, r.defer());
                }
                r.then(function() {
                    i(null, t);
                });
            });
        },
        get inboxMeta() {
            return this.inboxMeta = this.account.getFolderMetaForFolderId(this.account.getFirstFolderWithType("inbox").id);
        },
        getMessageIdForUidl: function(e) {
            return null == e ? null : (this.inboxMeta.uidlMap = this.inboxMeta.uidlMap || {}, 
            this.inboxMeta.uidlMap[e]);
        },
        storeMessageUidlForMessageId: function(e, t) {
            this.inboxMeta.uidlMap = this.inboxMeta.uidlMap || {}, this.inboxMeta.uidlMap[e] = t, 
            this.inboxMeta.overflowMap && delete this.inboxMeta.overflowMap[e];
        },
        storeOverflowMessageUidl: function(e, t) {
            this.inboxMeta.overflowMap = this.inboxMeta.overflowMap || {}, this.inboxMeta.overflowMap[e] = {
                size: t
            };
        },
        hasOverflowMessages: function() {
            if (!this.inboxMeta.overflowMap) return !1;
            for (var e in this.inboxMeta.overflowMap) return !0;
            return !1;
        },
        isUidlInOverflowMap: function(e) {
            return this.inboxMeta.overflowMap ? !!this.inboxMeta.overflowMap[e] : !1;
        },
        initialSync: function(e, t, n, i, o) {
            n("sync", !0), this.sync("initial", e, i, o);
        },
        refreshSync: function(e, t, n, i, o, a, r) {
            this.sync("refresh", e, a, r);
        },
        _performTestAdditionsAndDeletions: function(e) {
            var t = this.storage.folderMeta, n = d.latch(), i = !1;
            return t._TEST_pendingHeaderDeletes && (t._TEST_pendingHeaderDeletes.forEach(function(e) {
                i = !0, this.storage.deleteMessageHeaderAndBody(e.suid, e.date, n.defer());
            }, this), t._TEST_pendingHeaderDeletes = null), t._TEST_pendingAdds && (t._TEST_pendingAdds.forEach(function(e) {
                i = !0, this.storeMessage(e.header, e.bodyInfo, {}, n.defer());
            }, this), t._TEST_pendingAdds = null), n.then(function() {
                e();
            }), i;
        },
        growSync: function(e, t, n, i, o, a) {
            return t === f && this.hasOverflowMessages() ? (this.sync("grow", e, o, a), !0) : !1;
        },
        allConsumersDead: function() {},
        shutdown: function() {
            this._LOG.__die();
        },
        sync: u(!0, 2, "sync", function(e, n, i, o, a) {
            var r = this;
            t.log("pop3.sync:begin", {
                syncType: n
            });
            var l, p = !1, u = function(e) {
                return p ? (t.log("pop3.sync:duplicateDone", {
                    syncType: n,
                    err: e
                }), void 0) : (t.log("pop3.sync:end", {
                    syncType: n,
                    err: e
                }), p = !0, o(e ? "unknown" : null), void 0);
            };
            l = "grow" !== n ? function(e) {
                return null == r.getMessageIdForUidl(e) && !r.isUidlInOverflowMap(e);
            } : this.isUidlInOverflowMap.bind(this);
            var h, f = 0, m = 0, g = d.latch();
            if (this.isInbox) {
                h = !0, this._LOG.sync_begin();
                var v = g.defer(), _ = !1;
                e.onclose = function() {
                    _ || (_ = !0, window.setTimeout(function() {
                        window.setTimeout(function() {
                            u("closed");
                        }, 0);
                    }, 0));
                }, e.listMessages({
                    filter: l,
                    checkpointInterval: s.POP3_SAVE_STATE_EVERY_N_MESSAGES,
                    maxMessages: s.POP3_MAX_MESSAGES_PER_SYNC,
                    checkpoint: function(e) {
                        this.account.__checkpointSyncCompleted(e, "syncBatch");
                    }.bind(this),
                    progress: function(e) {
                        var t = e.totalBytes, n = e.message, i = g.defer();
                        this.storeMessage(n.header, n.bodyInfo, {}, function() {
                            f += e.size, m++, a(.1 + .7 * f / t), i();
                        });
                    }.bind(this)
                }, function(t, n, i) {
                    return _ = !0, e.quit(), t ? (u(t), void 0) : (i.length && (i.forEach(function(e) {
                        this.storeOverflowMessageUidl(e.uidl, e.size);
                    }, this), this._LOG.overflowMessages(i.length)), v(), void 0);
                }.bind(this));
            } else i.desiredHeaders = this._TEST_pendingAdds && this._TEST_pendingAdds.length, 
            h = this._performTestAdditionsAndDeletions(g.defer());
            g.then(function() {
                this.storage.markSyncRange(s.OLDEST_SYNC_DATE + c.DAY_MILLIS + 1, c.NOW(), "XXX", c.NOW()), 
                this.hasOverflowMessages() || this.storage.markSyncedToDawnOfTime(), this.isInbox && this._LOG.sync_end(), 
                h ? this.account.__checkpointSyncCompleted(y, "syncComplete") : y();
            }.bind(this));
            var y = function() {
                "initial" === n ? (this.storage._curSyncSlice.ignoreHeaders = !1, this.storage._curSyncSlice.waitingOnData = "db", 
                this.storage.getMessagesInImapDateRange(s.OLDEST_SYNC_DATE, null, s.INITIAL_FILL_SIZE, s.INITIAL_FILL_SIZE, this.storage.onFetchDBHeaders.bind(this.storage, this.storage._curSyncSlice, !1, u, null))) : u(null);
            }.bind(this);
        })
    };
    var m = a.LOGFAB = e.register(i, {
        Pop3FolderSyncer: {
            type: e.CONNECTION,
            subtype: e.CLIENT,
            events: {
                savedAttachment: {
                    storage: !0,
                    mimeType: !0,
                    size: !0
                },
                saveFailure: {
                    storage: !1,
                    mimeType: !1,
                    error: !1
                },
                overflowMessages: {
                    count: !0
                }
            },
            TEST_ONLY_events: {},
            errors: {
                callbackErr: {
                    ex: e.EXCEPTION
                },
                htmlParseError: {
                    ex: e.EXCEPTION
                },
                htmlSnippetError: {
                    ex: e.EXCEPTION
                },
                textChewError: {
                    ex: e.EXCEPTION
                },
                textSnippetError: {
                    ex: e.EXCEPTION
                },
                illegalSync: {
                    startTS: !1,
                    endTS: !1
                }
            },
            asyncJobs: {
                sync: {},
                syncDateRange: {
                    newMessages: !0,
                    existingMessages: !0,
                    deletedMessages: !0,
                    start: !1,
                    end: !1,
                    skewedStart: !1,
                    skewedEnd: !1
                }
            }
        }
    });
}), define("pop3/jobs", [ "module", "exports", "rdcommon/log", "../allback", "mix", "../jobmixins", "../drafts/jobs", "./pop3" ], function(e, t, n, i, o, a, r) {
    function s(e, t, n) {
        this._LOG = c.Pop3JobDriver(this, n, e.id), this.account = e, this.resilientServerIds = !0, 
        this._heldMutexReleasers = [], this._stateDelta = {}, this._state = t, t.hasOwnProperty("suidToServerId") || (t.suidToServerId = {}, 
        t.moveMap = {});
    }
    t.Pop3JobDriver = s, s.prototype = {
        _accessFolderForMutation: function(e, t, n, i, o) {
            var a = this.account.getFolderStorageForFolderId(e);
            a.runMutexed(o, function(e) {
                this._heldMutexReleasers.push(e);
                try {
                    n(a.folderSyncer, a);
                } catch (t) {
                    this._LOG.callbackErr(t);
                }
            }.bind(this));
        },
        local_do_createFolder: function(e, t) {
            var n, i, o = null, a = 0;
            if (e.parentFolderId) {
                if (!this.account._folderInfos.hasOwnProperty(e.parentFolderId)) throw new Error("No such folder: " + e.parentFolderId);
                var r = this.account._folderInfos[e.parentFolderId];
                i = r.$meta.delim, n = r.$meta.path + i, o = r.$meta.id, a = r.depth + 1;
            } else n = "", i = "/";
            if (n += "string" == typeof e.folderName ? e.folderName : e.folderName.join(i), 
            e.containOnlyOtherFolders && (n += i), this.account.getFolderByPath(n)) t(null); else {
                var s = self.account._learnAboutFolder(e.folderName, n, o, "normal", i, a);
                t(null, s);
            }
        },
        local_do_purgeExcessMessages: function(e, t) {
            this._accessFolderForMutation(e.folderId, !1, function(e, n) {
                n.purgeExcessMessages(function(e) {
                    t(null, null, e > 0);
                });
            }, null, "purgeExcessMessages");
        },
        local_do_saveSentDraft: function(e, t) {
            this._accessFolderForMutation(e.folderId, !1, function(n, o) {
                var a = i.latch();
                o.addMessageHeader(e.headerInfo, e.bodyInfo, a.defer()), o.addMessageBody(e.headerInfo, e.bodyInfo, a.defer()), 
                a.then(function() {
                    t(null, null, !0);
                });
            }, null, "saveSentDraft");
        },
        do_syncFolderList: function(e, t) {
            this.account.meta.lastFolderSyncAt = Date.now(), t(null);
        },
        do_modtags: function(e, t) {
            t(null);
        },
        undo_modtags: function(e, t) {
            t(null);
        },
        local_do_modtags: a.local_do_modtags,
        local_undo_modtags: a.local_undo_modtags,
        local_do_move: a.local_do_move,
        local_undo_move: a.local_undo_move,
        local_do_delete: a.local_do_delete,
        local_undo_delete: a.local_undo_delete,
        local_do_downloadBodies: a.local_do_downloadBodies,
        do_downloadBodies: a.do_downloadBodies,
        check_downloadBodies: a.check_downloadBodies,
        check_downloadBodyReps: a.check_downloadBodyReps,
        do_downloadBodyReps: a.do_downloadBodyReps,
        local_do_downloadBodyReps: a.local_do_downloadBodyReps,
        local_do_sendOutboxMessages: a.local_do_sendOutboxMessages,
        do_sendOutboxMessages: a.do_sendOutboxMessages,
        check_sendOutboxMessages: a.check_sendOutboxMessages,
        local_undo_sendOutboxMessages: a.local_undo_sendOutboxMessages,
        undo_sendOutboxMessages: a.undo_sendOutboxMessages,
        local_do_setOutboxSyncEnabled: a.local_do_setOutboxSyncEnabled,
        local_do_upgradeDB: a.local_do_upgradeDB,
        postJobCleanup: a.postJobCleanup,
        allJobsDone: a.allJobsDone,
        _partitionAndAccessFoldersSequentially: a._partitionAndAccessFoldersSequentially
    }, o(s.prototype, r.draftsMixins);
    var c = t.LOGFAB = n.register(e, {
        Pop3JobDriver: {
            type: n.DAEMON,
            events: {
                savedAttachment: {
                    storage: !0,
                    mimeType: !0,
                    size: !0
                },
                saveFailure: {
                    storage: !1,
                    mimeType: !1,
                    error: !1
                }
            },
            TEST_ONLY_events: {
                saveFailure: {
                    filename: !1
                }
            },
            asyncJobs: {
                acquireConnWithoutFolder: {
                    label: !1
                }
            },
            errors: {
                callbackErr: {
                    ex: n.EXCEPTION
                }
            }
        }
    });
}), define("pop3/account", [ "rdcommon/log", "../errbackoff", "../composite/incoming", "./sync", "../errorutils", "./jobs", "../drafts/draft_rep", "../disaster-recovery", "module", "require", "exports" ], function(e, t, n, i, o, a, r, s, c, l, d) {
    function p(e, n, o, r, c, l, d, p, h) {
        this._LOG = m.Pop3Account(this, p, o), u.apply(this, [ i.Pop3FolderSyncer ].concat(Array.slice(arguments))), 
        this._conn = null, this._pendingConnectionRequests = [], this._backoffEndpoint = t.createEndpoint("pop3:" + this.id, this, this._LOG), 
        this.tzOffset = 0, h && (s.associateSocketWithAccount(h.socket, this), this._conn = h), 
        this.ensureEssentialOfflineFolders(), this._jobDriver = new a.Pop3JobDriver(this, this._folderInfos.$mutationState, this._LOG);
    }
    var u = n.CompositeIncomingAccount;
    d.Account = d.Pop3Account = p, p.prototype = Object.create(u.prototype);
    var h = {
        type: "pop3",
        supportsServerFolders: !1,
        toString: function() {
            return "[Pop3Account: " + this.id + "]";
        },
        withConnection: function(e, t) {
            this._pendingConnectionRequests.push(e);
            var n = function() {
                var e = this._pendingConnectionRequests.shift();
                if (e) {
                    var i = function(t) {
                        t ? (e(t), n()) : e(null, this._conn, n);
                    }.bind(this);
                    this._conn && "disconnected" !== this._conn.state ? i() : this._makeConnection(i, t);
                }
            }.bind(this);
            1 === this._pendingConnectionRequests.length && n();
        },
        __folderDoneWithConnection: function() {},
        _makeConnection: function(e, t) {
            this._conn = !0, l([ "./pop3", "./probe" ], function(n, i) {
                this._LOG.createConnection(t);
                var a = {
                    host: this._connInfo.hostname,
                    port: this._connInfo.port,
                    crypto: this._connInfo.crypto,
                    preferredAuthMethod: this._connInfo.preferredAuthMethod,
                    username: this._credentials.username,
                    password: this._credentials.password
                };
                this._LOG && (a._logParent = this._LOG);
                var r = this._conn = new n.Pop3Client(a, function(t) {
                    t ? (console.error("Connect error:", t.name, "formal:", t, "on", this._connInfo.hostname, this._connInfo.port), 
                    t = i.normalizePop3Error(t), o.shouldReportProblem(t) && this.universe.__reportAccountProblem(this.compositeAccount, t, "incoming"), 
                    e && e(t, null), r.close(), o.shouldRetry(t) ? this._backoffEndpoint.noteConnectFailureMaybeRetry(o.wasErrorFromReachableState(t)) ? this._backoffEndpoint.scheduleConnectAttempt(this._makeConnection.bind(this)) : this._backoffEndpoint.noteBrokenConnection() : this._backoffEndpoint.noteBrokenConnection()) : (this._backoffEndpoint.noteConnectSuccess(), 
                    e && e(null, r));
                }.bind(this));
                s.associateSocketWithAccount(r.socket, this);
            }.bind(this));
        },
        saveSentMessage: function(e) {
            var t = this.getFirstFolderWithType("sent");
            if (t) {
                var n = this.getFolderStorageForFolderId(t.id), i = n._issueNewHeaderId(), o = n.folderId + "/" + i, a = r.cloneDraftMessageForSentFolderWithoutAttachments(e.header, e.body, {
                    id: i,
                    suid: o
                });
                this.universe.saveSentDraft(t.id, a.header, a.body);
            }
        },
        deleteFolder: function(e, t) {
            if (!this._folderInfos.hasOwnProperty(e)) throw new Error("No such folder: " + e);
            var n = this._folderInfos[e].$meta;
            self._LOG.deleteFolder(n.path), self._forgetFolder(e), t && t(null, n);
        },
        shutdown: function(e) {
            u.prototype.shutdownFolders.call(this), this._backoffEndpoint.shutdown(), this._conn && this._conn.close && this._conn.close(), 
            this._LOG.__die(), e && e();
        },
        checkAccount: function(e) {
            null !== this._conn && ("disconnected" !== this._conn.state && this._conn.close(), 
            this._conn = null), this._LOG.checkAccount_begin(null), this.withConnection(function(t) {
                this._LOG.checkAccount_end(t), e(t);
            }.bind(this), "checkAccount");
        },
        ensureEssentialOfflineFolders: function() {
            [ "sent", "localdrafts", "trash", "outbox" ].forEach(function(e) {
                this.getFirstFolderWithType(e) || this._learnAboutFolder(e, e, null, e, "", 0, !0);
            }, this);
        },
        ensureEssentialOnlineFolders: function(e) {
            e && e();
        },
        accountDeleted: function() {
            this._alive = !1, this.shutdown();
        }
    };
    for (var f in h) Object.defineProperty(p.prototype, f, Object.getOwnPropertyDescriptor(h, f));
    var m = d.LOGFAB = e.register(c, {
        Pop3Account: n.LOGFAB_DEFINITION.CompositeIncomingAccount
    });
}), define("axeshim-smtpclient", [ "slog" ], function() {
    var e = require("slog"), t = "smtpclient";
    return {
        debug: function(n, i) {
            e.debug(t, {
                msg: i
            });
        },
        log: function(n, i) {
            e.log(t, {
                msg: i
            });
        },
        warn: function(n, i) {
            e.warn(t, {
                msg: i
            });
        },
        error: function(n, i) {
            e.error(t, {
                msg: i
            });
        }
    };
}), function(e, t) {
    "function" == typeof define && define.amd ? define("ext/smtpclient/src/smtpclient-response-parser", t) : "object" == typeof exports ? module.exports = t() : e.SmtpClientResponseParser = t();
}(this, function() {
    var e = function() {
        this._remainder = "", this._block = {
            data: [],
            lines: [],
            statusCode: null
        }, this.destroyed = !1;
    };
    return e.prototype.onerror = function() {}, e.prototype.ondata = function() {}, 
    e.prototype.onend = function() {}, e.prototype.send = function(e) {
        if (this.destroyed) return this.onerror(new Error('This parser has already been closed, "write" is prohibited'));
        var t = (this._remainder + (e || "")).split(/\r?\n/);
        this._remainder = t.pop();
        for (var n = 0, i = t.length; i > n; n++) this._processLine(t[n]);
    }, e.prototype.end = function(e) {
        return this.destroyed ? this.onerror(new Error('This parser has already been closed, "end" is prohibited')) : (e && this.send(e), 
        this._remainder && this._processLine(this._remainder), this.destroyed = !0, this.onend(), 
        void 0);
    }, e.prototype._processLine = function(e) {
        var t, n;
        if (e.trim()) if (this._block.lines.push(e), t = e.match(/^(\d{3})([\- ])(?:(\d+\.\d+\.\d+)(?: ))?(.*)/)) {
            if (this._block.data.push(t[4]), "-" === t[2]) return this._block.statusCode && this._block.statusCode !== Number(t[1]) ? this.onerror("Invalid status code " + t[1] + " for multi line response (" + this._block.statusCode + " expected)") : this._block.statusCode || (this._block.statusCode = Number(t[1])), 
            void 0;
            n = {
                statusCode: Number(t[1]) || 0,
                enhancedStatus: t[3] || null,
                data: this._block.data.join("\n"),
                line: this._block.lines.join("\n")
            }, n.success = n.statusCode >= 200 && n.statusCode < 300, this.ondata(n), this._block = {
                data: [],
                lines: [],
                statusCode: null
            }, this._block.statusCode = null;
        } else this.onerror(new Error('Invalid SMTP response "' + e + '"')), this.ondata({
            success: !1,
            statusCode: this._block.statusCode || null,
            enhancedStatus: null,
            data: [ e ].join("\n"),
            line: this._block.lines.join("\n")
        }), this._block = {
            data: [],
            lines: [],
            statusCode: null
        };
    }, e;
}), function(e, t) {
    var n;
    "function" == typeof define && define.amd ? define("ext/smtpclient/src/smtpclient", [ "tcp-socket", "stringencoding", "axe", "./smtpclient-response-parser" ], function(e, n, i, o) {
        return t(e, n.TextEncoder, n.TextDecoder, i, o, window.btoa);
    }) : "object" == typeof exports && "undefined" != typeof navigator ? (n = require("wo-stringencoding"), 
    module.exports = t(require("tcp-socket"), n.TextEncoder, n.TextDecoder, require("axe-logger"), require("./smtpclient-response-parser"), btoa)) : "object" == typeof exports ? (n = require("wo-stringencoding"), 
    module.exports = t(require("tcp-socket"), n.TextEncoder, n.TextDecoder, require("axe-logger"), require("./smtpclient-response-parser"), function(e) {
        var t = require("buffer").Buffer;
        return new t(e, "binary").toString("base64");
    })) : (navigator.TCPSocket = navigator.TCPSocket || navigator.mozTCPSocket, e.SmtpClient = t(navigator.TCPSocket, e.TextEncoder, e.TextDecoder, e.axe, e.SmtpClientResponseParser, window.btoa));
}(this, function(e, t, n, i, o, a) {
    function r(t, n, i) {
        this._TCPSocket = e, this.options = i || {}, this.port = n || (this.options.useSecureTransport ? 465 : 25), 
        this.host = t || "localhost", this.options.useSecureTransport = "useSecureTransport" in this.options ? !!this.options.useSecureTransport : 465 === this.port, 
        this.options.auth = this.options.auth || !1, this.options.name = this.options.name || !1, 
        this.socket = !1, this.destroyed = !1, this.maxAllowedSize = 0, this.waitDrain = !1, 
        this._parser = new o(), this._authenticatedAs = null, this._supportedAuth = [], 
        this._dataMode = !1, this._lastDataBytes = "", this._envelope = null, this._currentAction = null, 
        this._secureMode = !!this.options.useSecureTransport;
    }
    var s = "SMTP Client";
    return r.prototype.onerror = function() {}, r.prototype.ondrain = function() {}, 
    r.prototype.onclose = function() {}, r.prototype.onidle = function() {}, r.prototype.onready = function() {}, 
    r.prototype.ondone = function() {}, r.prototype.connect = function() {
        if (!this.options.name && "getHostname" in this._TCPSocket && "function" == typeof this._TCPSocket.getHostname) return this._TCPSocket.getHostname(function(e, t) {
            this.options.name = t || "localhost", this.connect();
        }.bind(this)), void 0;
        this.options.name || (this.options.name = "localhost"), this.socket = this._TCPSocket.open(this.host, this.port, {
            binaryType: "arraybuffer",
            useSecureTransport: this._secureMode,
            ca: this.options.ca,
            tlsWorkerPath: this.options.tlsWorkerPath
        });
        try {
            this.socket.oncert = this.oncert;
        } catch (e) {}
        this.socket.onerror = this._onError.bind(this), this.socket.onopen = this._onOpen.bind(this);
    }, r.prototype.suspend = function() {
        this.socket && "open" === this.socket.readyState && this.socket.suspend();
    }, r.prototype.resume = function() {
        this.socket && "open" === this.socket.readyState && this.socket.resume();
    }, r.prototype.quit = function() {
        i.debug(s, "Sending QUIT..."), this._sendCommand("QUIT"), this._currentAction = this.close;
    }, r.prototype.reset = function(e) {
        this.options.auth = e || this.options.auth, i.debug(s, "Sending RSET..."), this._sendCommand("RSET"), 
        this._currentAction = this._actionRSET;
    }, r.prototype.close = function() {
        i.debug(s, "Closing connection..."), this.socket && "open" === this.socket.readyState ? this.socket.close() : this._destroy();
    }, r.prototype.useEnvelope = function(e) {
        this._envelope = e || {}, this._envelope.from = [].concat(this._envelope.from || "anonymous@" + this.options.name)[0], 
        this._envelope.to = [].concat(this._envelope.to || []), this._envelope.rcptQueue = [].concat(this._envelope.to), 
        this._envelope.rcptFailed = [], this._envelope.responseQueue = [], this._currentAction = this._actionMAIL, 
        i.debug(s, "Sending MAIL FROM..."), this._sendCommand("MAIL FROM:<" + this._envelope.from + ">");
    }, r.prototype.send = function(e) {
        return this._dataMode ? this._sendString(e) : !0;
    }, r.prototype.end = function(e) {
        return this._dataMode ? (e && e.length && this.send(e), this._currentAction = this._actionStream, 
        this.waitDrain = "\r\n" === this._lastDataBytes ? this.socket.send(new Uint8Array([ 46, 13, 10 ]).buffer) : "\r" === this._lastDataBytes.substr(-1) ? this.socket.send(new Uint8Array([ 10, 46, 13, 10 ]).buffer) : this.socket.send(new Uint8Array([ 13, 10, 46, 13, 10 ]).buffer), 
        this._dataMode = !1, this.waitDrain) : !0;
    }, r.prototype._onOpen = function() {
        this.socket.ondata = this._onData.bind(this), this.socket.onclose = this._onClose.bind(this), 
        this.socket.ondrain = this._onDrain.bind(this), this._parser.ondata = this._onCommand.bind(this), 
        this._currentAction = this._actionGreeting;
    }, r.prototype._onData = function(e) {
        var t = new n("UTF-8").decode(new Uint8Array(e.data));
        i.debug(s, "SERVER: " + t), this._parser.send(t);
    }, r.prototype._onDrain = function() {
        this.waitDrain = !1, this.ondrain();
    }, r.prototype._onError = function(e) {
        e instanceof Error && e.message ? (i.error(s, e), this.onerror(e)) : e && e.data instanceof Error ? (i.error(s, e.data), 
        this.onerror(e.data)) : (i.error(s, new Error(e && e.data && e.data.message || e.data || e || "Error")), 
        this.onerror(new Error(e && e.data && e.data.message || e.data || e || "Error"))), 
        this.close();
    }, r.prototype._onClose = function() {
        i.debug(s, "Socket closed."), this._destroy();
    }, r.prototype._onCommand = function(e) {
        "function" == typeof this._currentAction && this._currentAction.call(this, e);
    }, r.prototype._destroy = function() {
        this.destroyed || (this.destroyed = !0, this.onclose());
    }, r.prototype._sendString = function(e) {
        return this.options.disableEscaping || (e = e.replace(/\n\./g, "\n.."), "\n" !== this._lastDataBytes.substr(-1) && this._lastDataBytes || "." !== e.charAt(0) || (e = "." + e)), 
        e.length > 2 ? this._lastDataBytes = e.substr(-2) : 1 === e.length && (this._lastDataBytes = this._lastDataBytes.substr(-1) + e), 
        i.debug(s, "Sending " + e.length + " bytes of payload"), this.waitDrain = this.socket.send(new t("UTF-8").encode(e).buffer), 
        this.waitDrain;
    }, r.prototype._sendCommand = function(e) {
        this.waitDrain = this.socket.send(new t("UTF-8").encode(e + ("\r\n" !== e.substr(-2) ? "\r\n" : "")).buffer);
    }, r.prototype._authenticateUser = function() {
        if (!this.options.auth) return this._currentAction = this._actionIdle, this.onidle(), 
        void 0;
        var e;
        switch (!this.options.authMethod && this.options.auth.xoauth2 && (this.options.authMethod = "XOAUTH2"), 
        e = this.options.authMethod ? this.options.authMethod.toUpperCase().trim() : (this._supportedAuth[0] || "PLAIN").toUpperCase().trim()) {
          case "LOGIN":
            return i.debug(s, "Authentication via AUTH LOGIN"), this._currentAction = this._actionAUTH_LOGIN_USER, 
            this._sendCommand("AUTH LOGIN"), void 0;

          case "PLAIN":
            return i.debug(s, "Authentication via AUTH PLAIN"), this._currentAction = this._actionAUTHComplete, 
            this._sendCommand("AUTH PLAIN " + a(unescape(encodeURIComponent("\0" + this.options.auth.user + "\0" + this.options.auth.pass)))), 
            void 0;

          case "XOAUTH2":
            return i.debug(s, "Authentication via AUTH XOAUTH2"), this._currentAction = this._actionAUTH_XOAUTH2, 
            this._sendCommand("AUTH XOAUTH2 " + this._buildXOAuth2Token(this.options.auth.user, this.options.auth.xoauth2)), 
            void 0;
        }
        this._onError(new Error("Unknown authentication method " + e));
    }, r.prototype._actionGreeting = function(e) {
        return 220 !== e.statusCode ? (this._onError(new Error("Invalid greeting: " + e.data)), 
        void 0) : (this.options.lmtp ? (i.debug(s, "Sending LHLO " + this.options.name), 
        this._currentAction = this._actionLHLO, this._sendCommand("LHLO " + this.options.name)) : (i.debug(s, "Sending EHLO " + this.options.name), 
        this._currentAction = this._actionEHLO, this._sendCommand("EHLO " + this.options.name)), 
        void 0);
    }, r.prototype._actionLHLO = function(e) {
        return e.success ? (this._actionEHLO(e), void 0) : (i.error(s, "LHLO not successful"), 
        this._onError(new Error(e.data)), void 0);
    }, r.prototype._actionEHLO = function(e) {
        var t;
        if (!e.success) {
            if (!this._secureMode && this.options.requireTLS) {
                var n = "STARTTLS not supported without EHLO";
                return i.error(s, n), this._onError(new Error(n)), void 0;
            }
            return i.warn(s, "EHLO not successful, trying HELO " + this.options.name), this._currentAction = this._actionHELO, 
            this._sendCommand("HELO " + this.options.name), void 0;
        }
        return e.line.match(/AUTH(?:\s+[^\n]*\s+|\s+)PLAIN/i) && (i.debug(s, "Server supports AUTH PLAIN"), 
        this._supportedAuth.push("PLAIN")), e.line.match(/AUTH(?:\s+[^\n]*\s+|\s+)LOGIN/i) && (i.debug(s, "Server supports AUTH LOGIN"), 
        this._supportedAuth.push("LOGIN")), e.line.match(/AUTH(?:\s+[^\n]*\s+|\s+)XOAUTH2/i) && (i.debug(s, "Server supports AUTH XOAUTH2"), 
        this._supportedAuth.push("XOAUTH2")), (t = e.line.match(/SIZE (\d+)/i)) && Number(t[1]) && (this._maxAllowedSize = Number(t[1]), 
        i.debug(s, "Maximum allowd message size: " + this._maxAllowedSize)), !this._secureMode && (e.line.match(/[ \-]STARTTLS\s?$/im) && !this.options.ignoreTLS || this.options.requireTLS) ? (this._currentAction = this._actionSTARTTLS, 
        this._sendCommand("STARTTLS"), void 0) : (this._authenticateUser.call(this), void 0);
    }, r.prototype._actionSTARTTLS = function(e) {
        return e.success ? (this._secureMode = !0, this.socket.upgradeToSecure(), this._currentAction = this._actionEHLO, 
        this._sendCommand("EHLO " + this.options.name), void 0) : (i.error(s, "STARTTLS not successful"), 
        this._onError(new Error(e.data)), void 0);
    }, r.prototype._actionHELO = function(e) {
        return e.success ? (this._authenticateUser.call(this), void 0) : (i.error(s, "HELO not successful"), 
        this._onError(new Error(e.data)), void 0);
    }, r.prototype._actionAUTH_LOGIN_USER = function(e) {
        return 334 !== e.statusCode || "VXNlcm5hbWU6" !== e.data ? (i.error(s, "AUTH LOGIN USER not successful: " + e.data), 
        this._onError(new Error('Invalid login sequence while waiting for "334 VXNlcm5hbWU6 ": ' + e.data)), 
        void 0) : (i.debug(s, "AUTH LOGIN USER successful"), this._currentAction = this._actionAUTH_LOGIN_PASS, 
        this._sendCommand(a(unescape(encodeURIComponent(this.options.auth.user)))), void 0);
    }, r.prototype._actionAUTH_LOGIN_PASS = function(e) {
        return 334 !== e.statusCode || "UGFzc3dvcmQ6" !== e.data ? (i.error(s, "AUTH LOGIN PASS not successful: " + e.data), 
        this._onError(new Error('Invalid login sequence while waiting for "334 UGFzc3dvcmQ6 ": ' + e.data)), 
        void 0) : (i.debug(s, "AUTH LOGIN PASS successful"), this._currentAction = this._actionAUTHComplete, 
        this._sendCommand(a(unescape(encodeURIComponent(this.options.auth.pass)))), void 0);
    }, r.prototype._actionAUTH_XOAUTH2 = function(e) {
        e.success ? this._actionAUTHComplete(e) : (i.warn(s, "Error during AUTH XOAUTH2, sending empty response"), 
        this._sendCommand(""), this._currentAction = this._actionAUTHComplete);
    }, r.prototype._actionAUTHComplete = function(e) {
        return e.success ? (i.debug(s, "Authentication successful."), this._authenticatedAs = this.options.auth.user, 
        this._currentAction = this._actionIdle, this.onidle(), void 0) : (i.debug(s, "Authentication failed: " + e.data), 
        this._onError(new Error(e.data)), void 0);
    }, r.prototype._actionIdle = function(e) {
        return e.statusCode > 300 ? (this._onError(new Error(e.line)), void 0) : (this._onError(new Error(e.data)), 
        void 0);
    }, r.prototype._actionMAIL = function(e) {
        return e.success ? (this._envelope.rcptQueue.length ? (i.debug(s, "MAIL FROM successful, proceeding with " + this._envelope.rcptQueue.length + " recipients"), 
        i.debug(s, "Adding recipient..."), this._envelope.curRecipient = this._envelope.rcptQueue.shift(), 
        this._currentAction = this._actionRCPT, this._sendCommand("RCPT TO:<" + this._envelope.curRecipient + ">")) : this._onError(new Error("Can't send mail - no recipients defined")), 
        void 0) : (i.debug(s, "MAIL FROM unsuccessful: " + e.data), this._onError(new Error(e.data)), 
        void 0);
    }, r.prototype._actionRCPT = function(e) {
        if (e.success ? this._envelope.responseQueue.push(this._envelope.curRecipient) : (i.warn(s, "RCPT TO failed for: " + this._envelope.curRecipient), 
        this._envelope.rcptFailed.push(this._envelope.curRecipient)), this._envelope.rcptQueue.length) i.debug(s, "Adding recipient..."), 
        this._envelope.curRecipient = this._envelope.rcptQueue.shift(), this._currentAction = this._actionRCPT, 
        this._sendCommand("RCPT TO:<" + this._envelope.curRecipient + ">"); else {
            if (!(this._envelope.rcptFailed.length < this._envelope.to.length)) return this._onError(new Error("Can't send mail - all recipients were rejected")), 
            this._currentAction = this._actionIdle, void 0;
            this._currentAction = this._actionDATA, i.debug(s, "RCPT TO done, proceeding with payload"), 
            this._sendCommand("DATA");
        }
    }, r.prototype._actionRSET = function(e) {
        return e.success ? (this._authenticatedAs = null, this._authenticateUser.call(this), 
        void 0) : (i.error(s, "RSET unsuccessful " + e.data), this._onError(new Error(e.data)), 
        void 0);
    }, r.prototype._actionDATA = function(e) {
        return [ 250, 354 ].indexOf(e.statusCode) < 0 ? (i.error(s, "DATA unsuccessful " + e.data), 
        this._onError(new Error(e.data)), void 0) : (this._dataMode = !0, this._currentAction = this._actionIdle, 
        this.onready(this._envelope.rcptFailed), void 0);
    }, r.prototype._actionStream = function(e) {
        var t;
        if (this.options.lmtp) {
            if (t = this._envelope.responseQueue.shift(), e.success ? i.error(s, "Local delivery to " + t + " succeeded.") : (i.error(s, "Local delivery to " + t + " failed."), 
            this._envelope.rcptFailed.push(t)), this._envelope.responseQueue.length) return this._currentAction = this._actionStream, 
            void 0;
            this._currentAction = this._actionIdle, this.ondone(!0);
        } else e.success ? i.debug(s, "Message sent successfully.") : i.error(s, "Message sending failed."), 
        this._currentAction = this._actionIdle, this.ondone(!!e.success);
        this._currentAction === this._actionIdle && (i.debug(s, "Idling while waiting for new connections..."), 
        this.onidle());
    }, r.prototype._buildXOAuth2Token = function(e, t) {
        var n = [ "user=" + (e || ""), "auth=Bearer " + t, "", "" ];
        return a(unescape(encodeURIComponent(n.join(""))));
    }, r;
}), define("smtpclient", [ "ext/smtpclient/src/smtpclient" ], function(e) {
    return e;
}), define("smtp/client", [ "require", "exports", "module", "slog", "smtpclient", "../syncbase", "../oauth" ], function(e, t) {
    var n = e("slog"), i = e("smtpclient"), o = e("../syncbase"), a = e("../oauth"), r = window.setTimeout, s = window.clearTimeout;
    t.setTimeoutFunctions = function(e, t) {
        r = e, s = t;
    }, t.createSmtpConnection = function(e, c, d) {
        var p;
        return a.ensureUpdatedCredentials(e, d).then(function() {
            return new Promise(function(t, a) {
                function l() {
                    u && (s(u), u = null);
                }
                var d = {
                    user: void 0 !== e.outgoingUsername ? e.outgoingUsername : e.username,
                    pass: void 0 !== e.outgoingPassword ? e.outgoingPassword : e.password,
                    xoauth2: e.oauth2 ? e.oauth2.accessToken : null
                };
                n.log("smtp:connect", {
                    _auth: d,
                    usingOauth2: !!e.oauth2,
                    connInfo: c
                }), p = new i(c.hostname, c.port, {
                    auth: d,
                    useSecureTransport: "ssl" === c.crypto || c.crypto === !0,
                    requireTLS: "starttls" === c.crypto,
                    ignoreTLS: "plain" === c.crypto
                });
                var u = r(function() {
                    p.onerror("unresponsive-server"), p.close();
                }, o.CONNECT_TIMEOUT_MS);
                p.onidle = function() {
                    l(), n.info("smtp:connected", c), p.onidle = p.onclose = p.onerror = function() {}, 
                    t(p);
                }, p.onerror = function(e) {
                    l(), a(e);
                }, p.onclose = function() {
                    l(), a("server-maybe-offline");
                }, p.connect();
            });
        }).catch(function(i) {
            var o = l(p, i, !1);
            if (p && p.close(), "needs-oauth-reauth" === o && a.isRenewPossible(e)) return a.ensureUpdatedCredentials(e, d, !0).then(function() {
                return t.createImapConnection(e, c, d);
            });
            throw n.error("smtp:connect-error", {
                error: o,
                connInfo: c
            }), o;
        });
    };
    var c = i.prototype._onCommand;
    i.prototype._onCommand = function(e) {
        e.statusCode && !e.success && (this._lastSmtpError = e), c.apply(this, arguments);
    }, i.prototype._onError = function(e) {
        e instanceof Error && e.message ? this.onerror(e) : e && e.data instanceof Error ? this.onerror(e.data) : this.onerror(e && e.data && e.data.message || e.data || e || "Error"), 
        this.close();
    };
    var l = t.analyzeSmtpError = function(e, t, i) {
        var o = t;
        (o && !o.statusCode && "Error" === o.name || !o) && (o = e && e._lastSmtpError || null), 
        o || (o = "null-error");
        var a = e && !!e.options.auth.xoauth2, r = "unknown";
        if (o.statusCode) if (e._currentAction === e._actionSTARTTLS || e._currentAction === e._actionEHLO) r = "bad-security"; else switch (o.statusCode) {
          case 535:
            r = a ? "needs-oauth-reauth" : "bad-user-or-pass";
            break;

          case 534:
            r = "bad-user-or-pass";
            break;

          case 501:
            r = i ? "bad-message" : "server-maybe-offline";
            break;

          case 550:
          case 551:
          case 553:
          case 554:
            r = "bad-address";
            break;

          case 500:
            r = "server-problem";
            break;

          default:
            r = i ? "bad-message" : "unknown";
        } else "ConnectionRefusedError" === o.name ? r = "unresponsive-server" : /^Security/.test(o.name) ? r = "bad-security" : "string" == typeof o && (r = o);
        return n.log("smtp:analyzed-error", {
            statusCode: o.statusCode,
            enhancedStatus: o.enhancedStatus,
            rawError: t,
            rawErrorName: t && t.name,
            rawErrorMessage: t && t.message,
            rawErrorStack: t && t.stack,
            normalizedError: r,
            errorName: o.name,
            errorMessage: o.message,
            errorData: o.data,
            wasSending: i
        }), r;
    };
}), define("smtp/account", [ "require", "slog", "./client", "../disaster-recovery" ], function(e) {
    function t(e, t, n, i, o) {
        this.universe = e, this.compositeAccount = t, this.accountId = n, this.credentials = i, 
        this.connInfo = o, this._activeConnections = [];
    }
    var n = e("slog"), i = e("./client"), o = e("../disaster-recovery");
    return t.prototype = {
        type: "smtp",
        toString: function() {
            return "[SmtpAccount: " + this.id + "]";
        },
        get numActiveConns() {
            return this._activeConnections.length;
        },
        shutdown: function() {},
        accountDeleted: function() {
            this.shutdown();
        },
        sendMessage: function(e, t) {
            this.establishConnection({
                sendEnvelope: function(t) {
                    var i = e.getEnvelope();
                    n.log("smtp:sendEnvelope", {
                        _envelope: i
                    }), t.useEnvelope(i);
                },
                onProgress: function() {
                    e.renewSmartWakeLock("SMTP XHR Progress");
                },
                sendMessage: function(t) {
                    n.log("smtp:building-blob"), e.withMessageBlob({
                        includeBcc: !1
                    }, function(e) {
                        n.log("smtp:sending-blob", {
                            size: e.size
                        }), t.socket.send(e), t._lastDataBytes = "\r\n", t.end();
                    });
                },
                onSendComplete: function() {
                    n.log("smtp:sent"), t(null);
                },
                onError: function(e, i) {
                    n.error("smtp:error", {
                        error: e,
                        badAddresses: i
                    }), t(e, i);
                }
            });
        },
        checkAccount: function(e) {
            var t = !1;
            this.establishConnection({
                sendEnvelope: function(n, i) {
                    t = !0, i(), e();
                },
                sendMessage: function() {},
                onSendComplete: function() {},
                onError: function(t) {
                    "bad-user-or-pass" === t && this.universe.__reportAccountProblem(this.compositeAccount, t, "outgoing"), 
                    e(t);
                }.bind(this)
            });
        },
        establishConnection: function(e) {
            var t, a = !1;
            i.createSmtpConnection(this.credentials, this.connInfo, function() {
                return new Promise(function(e) {
                    this.universe.saveAccountDef(this.compositeAccount.accountDef, null, e);
                }.bind(this));
            }.bind(this)).then(function(r) {
                t = r, o.associateSocketWithAccount(t.socket, this), this._activeConnections.push(t);
                var s = t.socket.ondrain;
                t.socket.ondrain = function() {
                    s && s.call(t.socket), e.onProgress && e.onProgress();
                }, e.sendEnvelope(t, t.close.bind(t)), t.onready = function(i) {
                    n.log("smtp:onready"), i.length ? (t.close(), n.warn("smtp:bad-recipients", {
                        badRecipients: i
                    }), e.onError("bad-recipient", i)) : (a = !0, e.sendMessage(t));
                }, t.ondone = function(o) {
                    if (t.close(), o) n.log("smtp:sent"), e.onSendComplete(t); else {
                        n.error("smtp:send-failed");
                        var r = i.analyzeSmtpError(t, null, a);
                        e.onError(r, null);
                    }
                }, t.onerror = function(n) {
                    t.close(), n = i.analyzeSmtpError(t, n, a), e.onError(n, null);
                }, t.onclose = function() {
                    n.log("smtp:onclose");
                    var e = this._activeConnections.indexOf(t);
                    -1 !== e ? this._activeConnections.splice(e, 1) : n.error("smtp:dead-unknown-connection");
                }.bind(this);
            }.bind(this)).catch(function(n) {
                n = i.analyzeSmtpError(t, n, a), e.onError(n);
            });
        }
    }, {
        Account: t,
        SmtpAccount: t
    };
}), define("composite/account", [ "rdcommon/log", "../accountcommon", "../a64", "../accountmixins", "../imap/account", "../pop3/account", "../smtp/account", "../allback", "exports" ], function(e, t, n, i, o, a, r, s, c) {
    function l(e, t, n, o, a, r) {
        this.universe = e, this.id = t.id, this.accountDef = t, this._enabled = !0, this.problems = [], 
        t.credentials && t.credentials.oauth2 && (t.credentials.oauth2._transientLastRenew = 0), 
        this.identities = t.identities, d.hasOwnProperty(t.receiveType) || r.badAccountType(t.receiveType), 
        d.hasOwnProperty(t.sendType) || r.badAccountType(t.sendType), this._receivePiece = new d[t.receiveType](e, this, t.id, t.credentials, t.receiveConnInfo, n, o, r, a), 
        this._sendPiece = new d[t.sendType](e, this, t.id, t.credentials, t.sendConnInfo, o, r), 
        this._LOG = this._receivePiece._LOG, this.folders = this._receivePiece.folders, 
        this.meta = this._receivePiece.meta, this.mutations = this._receivePiece.mutations, 
        this.tzOffset = t.tzOffset, i.accountConstructorMixin.call(this, this._receivePiece, this._sendPiece);
    }
    var d = {
        imap: o.ImapAccount,
        pop3: a.Pop3Account,
        smtp: r.SmtpAccount
    };
    c.Account = c.CompositeAccount = l, l.prototype = {
        toString: function() {
            return "[CompositeAccount: " + this.id + "]";
        },
        get supportsServerFolders() {
            return this._receivePiece.supportsServerFolders;
        },
        toBridgeWire: function() {
            return {
                id: this.accountDef.id,
                name: this.accountDef.name,
                type: this.accountDef.type,
                defaultPriority: this.accountDef.defaultPriority,
                enabled: this.enabled,
                problems: this.problems,
                syncRange: this.accountDef.syncRange,
                syncInterval: this.accountDef.syncInterval,
                notifyOnNew: this.accountDef.notifyOnNew,
                playSoundOnSend: this.accountDef.playSoundOnSend,
                identities: this.identities,
                credentials: {
                    username: this.accountDef.credentials.username,
                    outgoingUsername: this.accountDef.credentials.outgoingUsername,
                    oauth2: this.accountDef.credentials.oauth2
                },
                servers: [ {
                    type: this.accountDef.receiveType,
                    connInfo: this.accountDef.receiveConnInfo,
                    activeConns: this._receivePiece.numActiveConns || 0
                }, {
                    type: this.accountDef.sendType,
                    connInfo: this.accountDef.sendConnInfo,
                    activeConns: this._sendPiece.numActiveConns || 0
                } ]
            };
        },
        toBridgeFolder: function() {
            return {
                id: this.accountDef.id,
                name: this.accountDef.name,
                path: this.accountDef.name,
                type: "account"
            };
        },
        get enabled() {
            return this._enabled;
        },
        set enabled(e) {
            this._enabled = this._receivePiece.enabled = e;
        },
        saveAccountState: function(e, t, n) {
            return this._receivePiece.saveAccountState(e, t, n);
        },
        get _saveAccountIsImminent() {
            return this.__saveAccountIsImminent;
        },
        set _saveAccountIsImminent(e) {
            this.___saveAccountIsImminent = this._receivePiece._saveAccountIsImminent = e;
        },
        runAfterSaves: function(e) {
            return this._receivePiece.runAfterSaves(e);
        },
        allOperationsCompleted: function() {
            this._receivePiece.allOperationsCompleted && this._receivePiece.allOperationsCompleted();
        },
        checkAccount: function(e) {
            var t = s.latch();
            this._receivePiece.checkAccount(t.defer("incoming")), this._sendPiece.checkAccount(t.defer("outgoing")), 
            t.then(function(t) {
                e(t.incoming[0], t.outgoing[0]);
            });
        },
        shutdown: function(e) {
            this._sendPiece.shutdown(), this._receivePiece.shutdown(e);
        },
        accountDeleted: function() {
            this._sendPiece.accountDeleted(), this._receivePiece.accountDeleted();
        },
        deleteFolder: function(e, t) {
            return this._receivePiece.deleteFolder(e, t);
        },
        sliceFolderMessages: function(e, t) {
            return this._receivePiece.sliceFolderMessages(e, t);
        },
        searchFolderMessages: function(e, t, n, i) {
            return this._receivePiece.searchFolderMessages(e, t, n, i);
        },
        syncFolderList: function(e) {
            return this._receivePiece.syncFolderList(e);
        },
        sendMessage: function(e, t) {
            return this._sendPiece.sendMessage(e, function(n, i) {
                n || this._receivePiece.saveSentMessage(e), t(n, i, null);
            }.bind(this));
        },
        getFolderStorageForFolderId: function(e) {
            return this._receivePiece.getFolderStorageForFolderId(e);
        },
        getFolderMetaForFolderId: function(e) {
            return this._receivePiece.getFolderMetaForFolderId(e);
        },
        runOp: function(e, t, n) {
            return this._receivePiece.runOp(e, t, n);
        },
        ensureEssentialOnlineFolders: function(e) {
            return this._receivePiece.ensureEssentialOnlineFolders(e);
        },
        getFirstFolderWithType: i.getFirstFolderWithType,
        upgradeFolderStoragesIfNeeded: function() {
            for (var e in this._receivePiece._folderStorages) {
                var t = this._receivePiece._folderStorages[e];
                t.upgradeIfNeeded();
            }
        }
    };
}), define("composite/configurator", [ "rdcommon/log", "../accountcommon", "../a64", "../allback", "./account", "../date", "require", "exports" ], function(e, t, n, i, o, a, r, s) {
    i.allbackMaker, s.account = o, s.configurator = {
        tryToCreateAccount: function(e, t, n, i) {
            var o, s, c, l;
            if (n) {
                l = "imap+smtp" === n.type ? "imap" : "pop3";
                var d = null;
                d = void 0 !== t.outgoingPassword ? t.outgoingPassword : t.password, o = {
                    username: n.incoming.username,
                    password: t.password,
                    outgoingUsername: n.outgoing.username,
                    outgoingPassword: d
                }, n.oauth2Tokens && (o.oauth2 = {
                    authEndpoint: n.oauth2Settings.authEndpoint,
                    tokenEndpoint: n.oauth2Settings.tokenEndpoint,
                    scope: n.oauth2Settings.scope,
                    clientId: n.oauth2Secrets.clientId,
                    clientSecret: n.oauth2Secrets.clientSecret,
                    refreshToken: n.oauth2Tokens.refreshToken,
                    accessToken: n.oauth2Tokens.accessToken,
                    expireTimeMS: n.oauth2Tokens.expireTimeMS,
                    _transientLastRenew: a.PERFNOW()
                }), s = {
                    hostname: n.incoming.hostname,
                    port: n.incoming.port,
                    crypto: "string" == typeof n.incoming.socketType ? n.incoming.socketType.toLowerCase() : n.incoming.socketType
                }, "pop3" === l && (s.preferredAuthMethod = null), c = {
                    emailAddress: t.emailAddress,
                    hostname: n.outgoing.hostname,
                    port: n.outgoing.port,
                    crypto: "string" == typeof n.outgoing.socketType ? n.outgoing.socketType.toLowerCase() : n.outgoing.socketType
                };
            }
            var p = new Promise(function(e, t) {
                "imap" === l ? r([ "../imap/probe" ], function(n) {
                    n.probeAccount(o, s).then(e, t);
                }) : r([ "../pop3/probe" ], function(n) {
                    n.probeAccount(o, s).then(e, t);
                });
            }), u = new Promise(function(e, t) {
                r([ "../smtp/probe" ], function(n) {
                    n.probeAccount(o, c).then(e, t);
                });
            });
            Promise.all([ p, u ]).then(function(n) {
                var a, r = n[0].conn, d = null;
                "imap" === l ? (d = n[0].timezoneOffset, a = this._defineImapAccount) : "pop3" === l && (s.preferredAuthMethod = r.authMethod, 
                a = this._definePop3Account), a.call(this, e, t, o, s, c, r, d, i);
            }.bind(this)).catch(function(e) {
                p.then(function(t) {
                    t.conn.close(), i(e, null, {
                        server: c.hostname
                    });
                }).catch(function(e) {
                    i(e, null, {
                        server: s.hostname
                    });
                });
            });
        },
        recreateAccount: function(e, i, o, a) {
            var r = o.def, s = {
                username: r.credentials.username,
                password: r.credentials.password,
                outgoingUsername: r.credentials.outgoingUsername,
                outgoingPassword: r.credentials.outgoingPassword,
                authMechanism: r.credentials.authMechanism,
                oauth2: r.credentials.oauth2
            }, c = n.encodeInt(e.config.nextAccountNum++), l = r.type || "imap+smtp", d = {
                id: c,
                name: r.name,
                type: l,
                receiveType: l.split("+")[0],
                sendType: "smtp",
                syncRange: r.syncRange,
                syncInterval: r.syncInterval || 0,
                notifyOnNew: r.hasOwnProperty("notifyOnNew") ? r.notifyOnNew : !0,
                playSoundOnSend: r.hasOwnProperty("playSoundOnSend") ? r.playSoundOnSend : !0,
                credentials: s,
                receiveConnInfo: {
                    hostname: r.receiveConnInfo.hostname,
                    port: r.receiveConnInfo.port,
                    crypto: r.receiveConnInfo.crypto,
                    preferredAuthMethod: r.receiveConnInfo.preferredAuthMethod || null
                },
                sendConnInfo: {
                    hostname: r.sendConnInfo.hostname,
                    port: r.sendConnInfo.port,
                    crypto: r.sendConnInfo.crypto
                },
                identities: t.recreateIdentities(e, c, r.identities),
                tzOffset: void 0 !== o.tzOffset ? o.tzOffset : -252e5
            };
            this._loadAccount(e, d, o.folderInfo, null, function(e) {
                a(null, e, null);
            });
        },
        _defineImapAccount: function(e, t, i, o, r, s, c, l) {
            var d = n.encodeInt(e.config.nextAccountNum++), p = {
                id: d,
                name: t.accountName || t.emailAddress,
                defaultPriority: a.NOW(),
                type: "imap+smtp",
                receiveType: "imap",
                sendType: "smtp",
                syncRange: "auto",
                syncInterval: t.syncInterval || 0,
                notifyOnNew: t.hasOwnProperty("notifyOnNew") ? t.notifyOnNew : !0,
                playSoundOnSend: t.hasOwnProperty("playSoundOnSend") ? t.playSoundOnSend : !0,
                credentials: i,
                receiveConnInfo: o,
                sendConnInfo: r,
                identities: [ {
                    id: d + "/" + n.encodeInt(e.config.nextIdentityNum++),
                    name: t.displayName,
                    address: t.emailAddress,
                    replyTo: null,
                    signature: null,
                    signatureEnabled: !1
                } ],
                tzOffset: c
            };
            this._loadAccount(e, p, null, s, function(e) {
                l(null, e, null);
            });
        },
        _definePop3Account: function(e, t, i, o, r, s, c, l) {
            var d = n.encodeInt(e.config.nextAccountNum++), p = {
                id: d,
                name: t.accountName || t.emailAddress,
                defaultPriority: a.NOW(),
                type: "pop3+smtp",
                receiveType: "pop3",
                sendType: "smtp",
                syncRange: "auto",
                syncInterval: t.syncInterval || 0,
                notifyOnNew: t.hasOwnProperty("notifyOnNew") ? t.notifyOnNew : !0,
                playSoundOnSend: t.hasOwnProperty("playSoundOnSend") ? t.playSoundOnSend : !0,
                credentials: i,
                receiveConnInfo: o,
                sendConnInfo: r,
                identities: [ {
                    id: d + "/" + n.encodeInt(e.config.nextIdentityNum++),
                    name: t.displayName,
                    address: t.emailAddress,
                    replyTo: null,
                    signature: null,
                    signatureEnabled: !1
                } ]
            };
            this._loadAccount(e, p, null, s, function(e) {
                l(null, e, null);
            });
        },
        _loadAccount: function(e, t, n, i, o) {
            var a;
            a = "imap" === t.receiveType ? {
                $meta: {
                    nextFolderNum: 0,
                    nextMutationNum: 0,
                    lastFolderSyncAt: 0,
                    capability: n && n.$meta.capability || i.capability
                },
                $mutations: [],
                $mutationState: {}
            } : {
                $meta: {
                    nextFolderNum: 0,
                    nextMutationNum: 0,
                    lastFolderSyncAt: 0
                },
                $mutations: [],
                $mutationState: {}
            }, e.saveAccountDef(t, a), e._loadAccount(t, a, i, o);
        }
    };
});